/*
SQLyog Community Edition- MySQL GUI v6.56
MySQL - 5.0.51b-community-nt : Database - studio
*********************************************************************
*/


/*!40101 SET NAMES utf8 */;

/*!40101 SET SQL_MODE=''*/;

/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

CREATE DATABASE /*!32312 IF NOT EXISTS*/`studio` /*!40100 DEFAULT CHARACTER SET latin1 */;

USE `studio`;

/*Table structure for table `dao_amb0f` */

DROP TABLE IF EXISTS `DAO_AMB0F`;

CREATE TABLE `DAO_AMB0F` (
  `AMB_CDE` char(10) NOT NULL,
  `AMB_DES` char(50) NOT NULL,
  `AMB_PACK` char(50) NOT NULL,
  `AMB_POOL` char(25) NOT NULL,
  `TPL_CDE` char(10) default NULL,
  PRIMARY KEY  (`AMB_CDE`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `dao_amb0f` */

insert  into `DAO_AMB0F`(`AMB_CDE`,`AMB_DES`,`AMB_PACK`,`AMB_POOL`,`TPL_CDE`) values ('CLASSICLOG','Classic Models Environments with log fields','it.eng.common.dao','classicmodelspool','AmbCanc'),('DAOCLASSIC','Environment Classic Models','it.eng.common.dao','classicmodelspool','CLASSICENV');

/*Table structure for table `dao_dct0f` */

DROP TABLE IF EXISTS `DAO_DCT0F`;

CREATE TABLE `DAO_DCT0F` (
  `DCT_AMB` char(10) NOT NULL,
  `DCT_FLD` char(80) NOT NULL,
  `DCT_WEB` char(80) NOT NULL,
  `DCT_TYP` int(11) default NULL,
  `DCT_L01` char(80) default NULL,
  `DCT_L02` char(80) default NULL,
  `DCT_L03` char(80) default NULL,
  `DCT_LEN` int(11) default NULL,
  `DCT_TYD` char(1) default NULL,
  `DCT_DLN` int(11) default NULL,
  PRIMARY KEY  (`DCT_AMB`,`DCT_FLD`),
  KEY `FK_dao_dct0f_typ` (`DCT_TYP`),
  CONSTRAINT `FK_dao_dct0f_amb` FOREIGN KEY (`DCT_AMB`) REFERENCES `DAO_AMB0F` (`AMB_CDE`) ON DELETE CASCADE,
  CONSTRAINT `FK_dao_dct0f_typ` FOREIGN KEY (`DCT_TYP`) REFERENCES `DAO_TYP0F` (`TYP_COD`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `dao_dct0f` */

insert  into `DAO_DCT0F`(`DCT_AMB`,`DCT_FLD`,`DCT_WEB`,`DCT_TYP`,`DCT_L01`,`DCT_L02`,`DCT_L03`,`DCT_LEN`,`DCT_TYD`,`DCT_DLN`) values ('DAOCLASSIC','addressLine1','addressLine1',130,'Address line 1','','',50,NULL,NULL),('DAOCLASSIC','addressLine2','addressLine2',130,'Address line 2','','',50,NULL,NULL),('DAOCLASSIC','amount','amount',40,'Amount','','',20,NULL,NULL),('DAOCLASSIC','checkNumber','checkNumber',50,'Check number','','',25,NULL,NULL),('DAOCLASSIC','city','city',50,'City','','',50,NULL,NULL),('DAOCLASSIC','comments','comments',60,'Comments','','',500,NULL,NULL),('DAOCLASSIC','contactFirstName','contactFirstName',110,'Contact First Name','','',50,NULL,NULL),('DAOCLASSIC','contactLastName','contactLastName',120,'Contact Last Name','','',50,NULL,NULL),('DAOCLASSIC','country','country',50,'Country','','',50,NULL,NULL),('DAOCLASSIC','creditLimit','creditLimit',40,'Credit limit','','',20,NULL,NULL),('DAOCLASSIC','customerName','customerName',120,'Customer Name','','',50,NULL,NULL),('DAOCLASSIC','customerNumber','customerNumber',90,'Customer Number','','',20,NULL,NULL),('DAOCLASSIC','email','email',160,'E-Mail','','',50,NULL,NULL),('DAOCLASSIC','employeeNumber','employeeNumber',90,'Employee number','','',20,NULL,NULL),('DAOCLASSIC','extension','extension',50,'Extension','','',15,NULL,NULL),('DAOCLASSIC','firstName','firstName',110,'First name','','',50,NULL,NULL),('DAOCLASSIC','htmlDescription','htmlDescription',150,'HTML Description','','',5000,NULL,NULL),('DAOCLASSIC','image','image',70,'Image','','',5000,NULL,NULL),('DAOCLASSIC','jobTitle','jobTitle',50,'Job title','','',50,NULL,NULL),('DAOCLASSIC','lastName','lastName',50,'Last name','','',50,NULL,NULL),('DAOCLASSIC','officeCode','officeCode',50,'Office code','','',20,NULL,NULL),('DAOCLASSIC','orderDate','orderDate',20,'Order date','','',12,NULL,NULL),('DAOCLASSIC','orderLineNumber','orderLineNumber',10,'Order line number','','',10,NULL,NULL),('DAOCLASSIC','orderNumber','orderNumber',10,'Order number','','',10,NULL,NULL),('DAOCLASSIC','paymentDate','paymentDate',20,'Payment date','','',12,NULL,NULL),('DAOCLASSIC','phone','phone',140,'Phone #','','',50,NULL,NULL),('DAOCLASSIC','postalCode','postalCode',50,'Postal code','','',15,NULL,NULL),('DAOCLASSIC','priceEach','priceEach',40,'Price each','','',20,NULL,NULL),('DAOCLASSIC','productCode','productCode',50,'Product code','','',20,NULL,NULL),('DAOCLASSIC','productLine','productLine',50,'Product line','','',20,NULL,NULL),('DAOCLASSIC','quantityOrdered','quantityOrdered',10,'Quantity ordered','','',10,NULL,NULL),('DAOCLASSIC','reportsTo','reportsTo',10,'Reports to','','',10,NULL,NULL),('DAOCLASSIC','requiredDate','requiredDate',20,'Required date','','',12,NULL,NULL),('DAOCLASSIC','salesRepEmployeeNumber','salesRepEmployeeNumber',90,'Sales report employee number','','',10,NULL,NULL),('DAOCLASSIC','shippedDate','shippedDate',20,'Shipped date','','',12,NULL,NULL),('DAOCLASSIC','state','state',50,'State','','',50,NULL,NULL),('DAOCLASSIC','status','status',170,'Status','','',50,NULL,NULL),('DAOCLASSIC','territory','territory',50,'Territory','','',50,NULL,NULL),('DAOCLASSIC','textDescription','textDescription',60,'Text description','','',5000,NULL,NULL);

/*Table structure for table `dao_fil0f` */

DROP TABLE IF EXISTS `DAO_FIL0F`;

CREATE TABLE `DAO_FIL0F` (
  `AMB_CDE` char(10) NOT NULL,
  `FIL_PH` char(50) NOT NULL,
  `FIL_UPD` char(50) NOT NULL,
  `FIL_LSV` char(50) NOT NULL,
  `FIL_LSA` char(50) NOT NULL,
  `FIL_PRE` char(50) NOT NULL,
  `FIL_PKG` char(80) default NULL,
  `FIL_TPL` char(10) default NULL,
  `FIL_STM` char(80) default NULL,
  `FIL_DSC` char(80) default NULL,
  `FIL_CRU` char(80) default NULL,
  PRIMARY KEY  (`AMB_CDE`,`FIL_PH`),
  CONSTRAINT `FK_dao_fil0f_amb` FOREIGN KEY (`AMB_CDE`) REFERENCES `DAO_AMB0F` (`AMB_CDE`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `dao_fil0f` */

insert  into `DAO_FIL0F`(`AMB_CDE`,`FIL_PH`,`FIL_UPD`,`FIL_LSV`,`FIL_LSA`,`FIL_PRE`,`FIL_PKG`,`FIL_TPL`,`FIL_STM`,`FIL_DSC`,`FIL_CRU`) values ('CLASSICLOG','employees','employees','employees','employees','','it.eng.dao.classicmodels','ClassicDAO','StmClassic','Employees with flag','TmplCRUD'),('DAOCLASSIC','customers','customers','customers','customers','','it.eng.dao.classicmodels','FileDAO','StmStdNL','Customers table','TmplCRUD'),('DAOCLASSIC','employees','employees','employees','employees','','it.eng.dao.classicmodels','FileDAO','StmStdNL','Employees table','TmplCRUD'),('DAOCLASSIC','offices','offices','offices','offices','','it.eng.dao.classicmodels','FileDAO','StmStdNL','Offices table','TmplCRUD'),('DAOCLASSIC','orderdetails','orderdetails','orderdetails','orderdetails','','it.eng.dao.classicmodels','FileDAO','StmStdNL','Order details table','TmplCRUD'),('DAOCLASSIC','orders','orders','orders','orders','','it.eng.dao.classicmodels','FileDAO','StmStdNL','Orders','TmplCRUD'),('DAOCLASSIC','payments','payments','payments','payments','','it.eng.dao.classicmodels','FileDAO','StmStdNL','Payments table','TmplCRUD'),('DAOCLASSIC','productlines','productlines','productlines','productlines','','it.eng.dao.classicmodels','FileDAO','StmStdNL','Product lines table','TmplCRUD'),('DAOCLASSIC','products','products','products','products','','it.eng.dao.classicmodels','FileDAO','StmStdNL','Products table','TmplCRUD');

/*Table structure for table `DAO_FLD0F` */

DROP TABLE IF EXISTS `DAO_FLD0F`;

CREATE TABLE `DAO_FLD0F` (
  `AMB_CDE` char(10) NOT NULL,
  `FIL_PH` char(50) NOT NULL,
  `FLD_PRO` int(11) NOT NULL,
  `FLD_DES` char(50) NOT NULL,
  `FLD_FLD` char(50) NOT NULL,
  `FLD_WEB` char(50) NOT NULL,
  `FLD_WIDGET` char(25) NOT NULL,
  `FLD_LENGTH` int(11) NOT NULL,
  `FLD_ILEN` int(11) NOT NULL,
  `FLD_OLEN` int(11) NOT NULL,
  `FLD_KEY` char(1) default NULL,
  `FLD_NUL` char(1) default NULL,
  `FLD_DEC` int(11) default NULL,
  `FLD_TYP` int(11) default NULL,
  `FLD_MND` char(1) default NULL,
  `FLD_INS` char(1) default NULL,
  `FLD_UPD` char(1) default NULL,
  PRIMARY KEY  (`AMB_CDE`,`FIL_PH`,`FLD_PRO`),
  CONSTRAINT `FK_dao_fld0f_fil` FOREIGN KEY (`AMB_CDE`, `FIL_PH`) REFERENCES `DAO_FIL0F` (`AMB_CDE`, `FIL_PH`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `dao_fld0f` */

insert  into `DAO_FLD0F`(`AMB_CDE`,`FIL_PH`,`FLD_PRO`,`FLD_DES`,`FLD_FLD`,`FLD_WEB`,`FLD_WIDGET`,`FLD_LENGTH`,`FLD_ILEN`,`FLD_OLEN`,`FLD_KEY`,`FLD_NUL`,`FLD_DEC`,`FLD_TYP`,`FLD_MND`,`FLD_INS`,`FLD_UPD`) values ('CLASSICLOG','employees',10,'employeeNumber','employeeNumber','employeeNumber','Text',11,11,11,'Y','N',0,0,'Y','Y','Y'),('CLASSICLOG','employees',20,'lastName','lastName','lastName','Text',50,50,50,'N','Y',0,0,'N','Y','Y'),('CLASSICLOG','employees',30,'firstName','firstName','firstName','Text',50,50,50,'N','Y',0,0,'N','Y','Y'),('CLASSICLOG','employees',40,'extension','extension','extension','Text',10,10,10,'N','Y',0,0,'N','Y','Y'),('CLASSICLOG','employees',50,'email','email','email','Text',100,100,100,'N','Y',0,0,'N','Y','Y'),('CLASSICLOG','employees',60,'officeCode','officeCode','officeCode','Text',10,10,10,'N','Y',0,0,'N','Y','Y'),('CLASSICLOG','employees',70,'reportsTo','reportsTo','reportsTo','Text',11,11,11,'N','Y',0,0,'N','Y','Y'),('CLASSICLOG','employees',80,'jobTitle','jobTitle','jobTitle','Text',50,50,50,'N','Y',0,0,'N','Y','Y'),('DAOCLASSIC','customers',10,'Customer Number','customerNumber','customerNumber','Text',11,10,10,'Y','N',0,10,'Y','Y','Y'),('DAOCLASSIC','customers',20,'Customer Name','customerName','customerName','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','customers',30,'Contact Last Name','contactLastName','contactLastName','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','customers',40,'Contact First Name','contactFirstName','contactFirstName','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','customers',50,'Phone #','phone','phone','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','customers',60,'Address line 1','addressLine1','addressLine1','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','customers',70,'Address line 2','addressLine2','addressLine2','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','customers',80,'City','city','city','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','customers',90,'State','state','state','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','customers',100,'Postal code','postalCode','postalCode','TextArea',15,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','customers',110,'Country','country','country','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','customers',120,'Sales report employee number','salesRepEmployeeNumber','salesRepEmployeeNumber','Text',11,10,10,'N','Y',0,10,'N','Y','Y'),('DAOCLASSIC','customers',130,'Credit limit','creditLimit','creditLimit','Text',22,10,10,'N','Y',31,40,'N','Y','Y'),('DAOCLASSIC','employees',10,'Employee number','employeeNumber','employeeNumber','Text',11,10,10,'Y','N',0,10,'Y','Y','Y'),('DAOCLASSIC','employees',20,'Last name','lastName','lastName','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','employees',30,'First name','firstName','firstName','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','employees',40,'Extension','extension','extension','TextArea',10,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','employees',50,'E-Mail','email','email','TextArea',100,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','employees',60,'Office code','officeCode','officeCode','TextArea',10,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','employees',70,'Reports to','reportsTo','reportsTo','Text',11,10,10,'N','Y',0,10,'N','Y','Y'),('DAOCLASSIC','employees',80,'Job title','jobTitle','jobTitle','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','employees',90,'expireDate','expireDate','expireDate','Text',10,10,10,'N','Y',0,0,'N','Y','Y'),('DAOCLASSIC','employees',100,'lastUser','lastUser','lastUser','Text',50,50,50,'N','Y',0,0,'N','Y','Y'),('DAOCLASSIC','offices',10,'Office code','officeCode','officeCode','TextArea',10,50,50,'Y','N',0,50,'Y','Y','Y'),('DAOCLASSIC','offices',20,'City','city','city','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','offices',30,'Phone #','phone','phone','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','offices',40,'Address line 1','addressLine1','addressLine1','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','offices',50,'Address line 2','addressLine2','addressLine2','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','offices',60,'State','state','state','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','offices',70,'Country','country','country','TextArea',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','offices',80,'Postal code','postalCode','postalCode','TextArea',15,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','offices',90,'Territory','territory','territory','TextArea',10,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','orderdetails',10,'Order number','orderNumber','orderNumber','Text',11,10,10,'Y','N',0,10,'Y','Y','Y'),('DAOCLASSIC','orderdetails',20,'Product code','productCode','productCode','TextArea',15,50,50,'Y','N',0,50,'Y','Y','Y'),('DAOCLASSIC','orderdetails',30,'Quantity ordered','quantityOrdered','quantityOrdered','Text',11,10,10,'N','Y',0,10,'N','Y','Y'),('DAOCLASSIC','orderdetails',40,'Price each','priceEach','priceEach','Text',22,12,12,'N','Y',31,40,'N','Y','Y'),('DAOCLASSIC','orderdetails',50,'Order line number','orderLineNumber','orderLineNumber','Text',6,10,10,'N','Y',0,10,'N','Y','Y'),('DAOCLASSIC','orders',10,'Order number','orderNumber','orderNumber','Text',11,10,10,'Y','N',0,10,'Y','Y','Y'),('DAOCLASSIC','orders',20,'Order date','orderDate','orderDate','DateField',19,8,12,'N','Y',0,20,'N','Y','Y'),('DAOCLASSIC','orders',30,'Required date','requiredDate','requiredDate','DateField',19,8,12,'N','Y',0,20,'N','Y','Y'),('DAOCLASSIC','orders',40,'Shipped date','shippedDate','shippedDate','DateField',19,8,12,'N','Y',0,20,'N','Y','Y'),('DAOCLASSIC','orders',50,'Status','status','status','STATUSFLD',15,50,50,'N','Y',0,170,'N','Y','Y'),('DAOCLASSIC','orders',60,'Comments','comments','comments','TextArea',65535,5000,5000,'N','Y',0,60,'N','Y','Y'),('DAOCLASSIC','orders',70,'Customer Number','customerNumber','customerNumber','Text',11,10,10,'N','Y',0,90,'N','Y','Y'),('DAOCLASSIC','payments',10,'Customer Number','customerNumber','customerNumber','Text',11,10,10,'Y','N',0,10,'Y','Y','Y'),('DAOCLASSIC','payments',20,'Check number','checkNumber','checkNumber','TextArea',50,50,50,'Y','N',0,50,'Y','Y','Y'),('DAOCLASSIC','payments',30,'Payment date','paymentDate','paymentDate','DateField',19,8,12,'N','Y',0,20,'N','Y','Y'),('DAOCLASSIC','payments',40,'Amount','amount','amount','Text',22,12,12,'N','Y',31,40,'N','Y','Y'),('DAOCLASSIC','productlines',10,'Product line','productLine','productLine','TextArea',50,50,50,'Y','N',0,50,'Y','Y','Y'),('DAOCLASSIC','productlines',20,'Text description','textDescription','textDescription','TextArea',4000,5000,5000,'N','Y',0,60,'N','Y','Y'),('DAOCLASSIC','productlines',30,'HTML Description','htmlDescription','htmlDescription','TextArea',16777215,5000,5000,'N','Y',0,60,'N','Y','Y'),('DAOCLASSIC','productlines',40,'Image','image','image','FileField',16777215,5000,5000,'N','Y',0,70,'N','Y','Y'),('DAOCLASSIC','products',10,'Product code','productCode','productCode','Text',15,50,50,'Y','N',0,50,'Y','Y','Y'),('DAOCLASSIC','products',20,'productName','productName','productName','Text',70,70,70,'N','Y',0,0,'N','Y','Y'),('DAOCLASSIC','products',30,'Product line','productLine','productLine','Text',50,50,50,'N','Y',0,50,'N','Y','Y'),('DAOCLASSIC','products',40,'productScale','productScale','productScale','Text',10,10,10,'N','Y',0,0,'N','Y','Y'),('DAOCLASSIC','products',50,'productVendor','productVendor','productVendor','Text',50,50,50,'N','Y',0,0,'N','Y','Y'),('DAOCLASSIC','products',60,'productDescription','productDescription','productDescription','Text',65535,65535,65535,'N','Y',0,0,'N','Y','Y'),('DAOCLASSIC','products',70,'quantityInStock','quantityInStock','quantityInStock','Text',6,6,6,'N','Y',0,0,'N','Y','Y'),('DAOCLASSIC','products',80,'buyPrice','buyPrice','buyPrice','Text',22,22,22,'N','Y',31,0,'N','Y','Y'),('DAOCLASSIC','products',90,'MSRP','MSRP','MSRP','Text',22,22,22,'N','Y',31,0,'N','Y','Y');

/*Table structure for table `dao_lgt0f` */

DROP TABLE IF EXISTS `DAO_LGT0F`;

CREATE TABLE `DAO_LGT0F` (
  `LOG_CDE` int(11) NOT NULL auto_increment,
  `LOG_DES` char(50) default NULL,
  `LOG_COD` char(100) default NULL,
  `LOG_DTP` int(11) default NULL,
  PRIMARY KEY  (`LOG_CDE`),
  KEY `FK_dao_lgt0f_typ` (`LOG_DTP`),
  CONSTRAINT `FK_dao_lgt0f_typ` FOREIGN KEY (`LOG_DTP`) REFERENCES `DAO_TYP0F` (`TYP_COD`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=latin1;

/*Data for the table `dao_lgt0f` */

insert  into `DAO_LGT0F`(`LOG_CDE`,`LOG_DES`,`LOG_COD`,`LOG_DTP`) values (10,'Deleted flag','getCurrentSqlDate()',20),(20,'User','getUserName()',50);

/*Table structure for table `dao_log0f` */

DROP TABLE IF EXISTS `DAO_LOG0F`;

CREATE TABLE `DAO_LOG0F` (
  `AMB_CDE` char(10) NOT NULL,
  `LOG_PRO` int(11) NOT NULL,
  `LOG_DES` char(50) NOT NULL,
  `LOG_FLG` char(1) NOT NULL,
  `LOG_TIP` int(11) NOT NULL,
  `LOG_FLD` char(50) NOT NULL,
  PRIMARY KEY  (`AMB_CDE`,`LOG_PRO`),
  KEY `FK_dao_log0f_lgt` (`LOG_TIP`),
  CONSTRAINT `FK_dao_log0f_amb` FOREIGN KEY (`AMB_CDE`) REFERENCES `DAO_AMB0F` (`AMB_CDE`) ON DELETE CASCADE,
  CONSTRAINT `FK_dao_log0f_lgt` FOREIGN KEY (`LOG_TIP`) REFERENCES `DAO_LGT0F` (`LOG_CDE`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `dao_log0f` */

insert  into `DAO_LOG0F`(`AMB_CDE`,`LOG_PRO`,`LOG_DES`,`LOG_FLG`,`LOG_TIP`,`LOG_FLD`) values ('CLASSICLOG',10,'Discharge Flag','D',10,'discharge'),('CLASSICLOG',20,'Last User','',20,'lastUser');

/*Table structure for table `dao_red0f` */

DROP TABLE IF EXISTS `DAO_RED0F`;

CREATE TABLE `DAO_RED0F` (
  `AMB_CDE` char(10) NOT NULL,
  `FIL_PH` char(50) NOT NULL,
  `REL_NAM` char(50) NOT NULL,
  `FLD_PRO` int(11) NOT NULL,
  `FLD_PROREL` int(11) NOT NULL,
  PRIMARY KEY  (`AMB_CDE`,`FIL_PH`,`REL_NAM`,`FLD_PRO`,`FLD_PROREL`),
  CONSTRAINT `FK_dao_red0f_rel` FOREIGN KEY (`AMB_CDE`, `FIL_PH`, `REL_NAM`) REFERENCES `DAO_REL0F` (`AMB_CDE`, `FIL_PH`, `REL_NAM`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `dao_red0f` */

insert  into `DAO_RED0F`(`AMB_CDE`,`FIL_PH`,`REL_NAM`,`FLD_PRO`,`FLD_PROREL`) values ('DAOCLASSIC','customers','employee',120,10);

/*Table structure for table `dao_rel0f` */

DROP TABLE IF EXISTS `DAO_REL0F`;

CREATE TABLE `DAO_REL0F` (
  `AMB_CDE` char(10) NOT NULL,
  `FIL_PH` char(50) NOT NULL,
  `REL_NAM` char(50) NOT NULL,
  `AMB_CDEREL` char(10) NOT NULL,
  `FIL_PHREL` char(50) NOT NULL,
  `REL_TYP` int(11) default NULL,
  `SUBREL` char(1) default NULL,
  PRIMARY KEY  (`AMB_CDE`,`FIL_PH`,`REL_NAM`),
  KEY `FK_dao_rel0f_detail` (`AMB_CDEREL`,`FIL_PHREL`),
  CONSTRAINT `FK_dao_rel0f_detail` FOREIGN KEY (`AMB_CDEREL`, `FIL_PHREL`) REFERENCES `DAO_FIL0F` (`AMB_CDE`, `FIL_PH`) ON DELETE CASCADE,
  CONSTRAINT `FK_dao_rel0f_master` FOREIGN KEY (`AMB_CDE`, `FIL_PH`) REFERENCES `DAO_FIL0F` (`AMB_CDE`, `FIL_PH`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `dao_rel0f` */

insert  into `DAO_REL0F`(`AMB_CDE`,`FIL_PH`,`REL_NAM`,`AMB_CDEREL`,`FIL_PHREL`,`REL_TYP`,`SUBREL`) values ('DAOCLASSIC','customers','employee','DAOCLASSIC','employees',1,'N');

/*Table structure for table `dao_rfd0f` */

DROP TABLE IF EXISTS `DAO_RFD0F`;

CREATE TABLE `DAO_RFD0F` (
  `AMB_CDE` char(10) NOT NULL,
  `FIL_PH` char(50) NOT NULL,
  `REL_NAM` char(50) NOT NULL,
  `FLD_PRO` int(11) NOT NULL,
  `FLD_USE` char(1) NOT NULL,
  PRIMARY KEY  (`AMB_CDE`,`FIL_PH`,`REL_NAM`,`FLD_PRO`),
  CONSTRAINT `FK_dao_rfd0f_rel` FOREIGN KEY (`AMB_CDE`, `FIL_PH`, `REL_NAM`) REFERENCES `DAO_REL0F` (`AMB_CDE`, `FIL_PH`, `REL_NAM`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `dao_rfd0f` */

insert  into `DAO_RFD0F`(`AMB_CDE`,`FIL_PH`,`REL_NAM`,`FLD_PRO`,`FLD_USE`) values ('DAOCLASSIC','customers','employee',20,'E'),('DAOCLASSIC','customers','employee',30,'E');

/*Table structure for table `dao_tpl0f` */

DROP TABLE IF EXISTS `DAO_TPL0F`;

CREATE TABLE `DAO_TPL0F` (
  `TPL_CDE` varchar(10) NOT NULL,
  `TPL_DES` varchar(50) NOT NULL,
  `TPL_REF` varchar(80) NOT NULL,
  `TPL_TPY` varchar(10) default NULL,
  PRIMARY KEY  (`TPL_CDE`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `dao_tpl0f` */

insert  into `DAO_TPL0F`(`TPL_CDE`,`TPL_DES`,`TPL_REF`,`TPL_TPY`) values ('AmbCanc   ','Deleted Flag Environment','ClassicEnvironmentDAO','JENVIRON'),('AmbDAO    ','Basic Environment','BasicEnvironmentDAO','JENVIRON  '),('ClassicDAO','DAO Files with flag','FileClassicDao','JFILEDAO'),('CLASSICENV','Classic Models Environment','BasicEnvironmentDAO','JENVIRON'),('Column    ','Column Template                                   ','ColumnTemplate                                                                  ','XMLCOLUMN '),('ComboModul','Combo Dao Template','TemplateComboModuleField                                                        ','XMLFLDWDG '),('ComboStati','Static Combo Template','TemplateComboStaticField                                                        ','XMLFLDWDG '),('DateField ','Date Field Widget                                 ','TemplateDateField                                                               ','XMLFLDWDG '),('DettStd   ','Standard Detail Module','TemplateDetailModule','XMLMODULE '),('Fieldset  ','Template Fieldset                                 ','TemplateFieldset                                                                ','XMLFLDSET '),('FileDAO   ','Java Files Template','FileDAO','JFILEDAO'),('FileField ','Field File Template','TemplateFileField                                                               ','XMLFLDWDG '),('FldValidat','XML Field Validator                               ','TemplateFieldValidator                                                          ','XMLFLDVAL '),('ListaSmart','Smart List Module','TemplateListModule','XMLMODULE '),('ModRicerca','Find Module','TemplateSearchModule','XMLMODULE '),('PagineStd ','Standard Page','TemplatePage','XMLPAGE   '),('PAGLISTA  ','Page with only list module','TemplateListPage','XMLPAGE   '),('PAGRICLIS ','Page with Find e List Modules','TemplateSearchListPage','XMLPAGE   '),('PagRicList','Page with Find, List and Detail Modules','TemplateSearchPage','XMLPAGE   '),('Publisher ','Publisher Template','TemplatePublisher                                                               ','XMLPUBLIS '),('Service   ','Service Template','TemplateService                                                                 ','XMLFLDVAL '),('ServiceAct','Template validation service action                ','TemplateServiceAction                                                           ','XMLFLDVAL '),('STATUSFLD','Template Combo Status Field','TemplateComboStatusField','XMLFLDWDG'),('StmClassic','Statements with deleted flag','stmClassicdao','SQLSTATM'),('StmStd    ','Standard statements template','stmdao                                                                          ','SQLSTATM  '),('StmStdNL  ','DAO statements without flag','stmdaonl                                                                        ','SQLSTATM  '),('TabPage','List/Detail page with tabs','TemplateTabsPage','XMLPAGE'),('Tabulatore','XML Tab template','TemplateTab                                                                     ','XMLTAB    '),('Text      ','Text Fields Template','TemplateTextField                                                               ','XMLFLDWDG '),('TextArea  ','Text Area Fields Template','TemplateTextAreaField                                                           ','XMLFLDWDG '),('TmplCRUD  ','Template CRUD standard                            ','TemplateAlberoGenerazione.xml                                                   ','XMLCRUD   '),('TPLOOKUP  ','Lookup template                                   ','TemplateLookup                                                                  ','XMLLOOKUP '),('TPLOOKUPF ','Lookup Fields Template','TemplateLookupFields                                                            ','XMLLOOKFI '),('TPPAGDOP','Double Page Template','TemplateDoublePage','XMLPAGE'),('Validation','Detail Validation Template','TemplateDetailValidation','XMLFLDVAL '),('ValidLista','List Validation Template','TemplateListValidation','XMLFLDVAL '),('ValidRicer','Find Validation Template','TemplateSearchValidation','XMLFLDVAL ');

/*Table structure for table `dao_typ0f` */

DROP TABLE IF EXISTS `DAO_TYP0F`;

CREATE TABLE `DAO_TYP0F` (
  `TYP_COD` int(11) NOT NULL,
  `TYP_DES` char(50) default NULL,
  `TYP_CLA` char(80) default NULL,
  `TYP_VLD` char(80) default NULL,
  `TYP_WDG` char(80) default NULL,
  `TYP_SQL` int(11) default NULL,
  `TYP_INL` int(11) default NULL,
  `TYP_OUL` int(11) default NULL,
  `TYP_VIN` char(80) default NULL,
  `TYP_VUP` char(80) default NULL,
  `FLD_VIS` char(1) default NULL,
  `TYP_INS` char(1) default NULL,
  `TYP_UPD` char(1) default NULL,
  PRIMARY KEY  (`TYP_COD`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `dao_typ0f` */

insert  into `DAO_TYP0F`(`TYP_COD`,`TYP_DES`,`TYP_CLA`,`TYP_VLD`,`TYP_WDG`,`TYP_SQL`,`TYP_INL`,`TYP_OUL`,`TYP_VIN`,`TYP_VUP`,`FLD_VIS`,`TYP_INS`,`TYP_UPD`) values (0,'Unassigned Type','','','Text',0,0,0,'','','Y','Y','Y'),(10,'INTEGER','','','Text',-5,10,10,'','','Y','Y','Y'),(20,'DATE','DATE','DATE','DateField',91,8,12,'DEFAULT_ZERO_DATE','DEFAULT_ZERO_DATE','Y','Y','Y'),(30,'DOUBLE','NUMBER_23_3','DECIMAL','Text',8,10,10,'DEFAULT_ZERO','DEFAULT_ZERO','Y','Y','Y'),(40,'CURRENCY','NUMBER_23_3','IMPORTO','Text',8,12,12,'DEFAULT_ZERO','DEFAULT_ZERO','Y','Y','Y'),(50,'TEXT','','','Text',12,50,50,'','','Y','Y','Y'),(60,'TEXTBLOB','','','TextArea',2004,5000,5000,'','','Y','Y','Y'),(70,'IMAGEBLOB','','','FileField',2004,5000,5000,'','','Y','Y','Y'),(80,'TIME','TIME','TIME','DateField',92,10,10,'','','Y','Y','Y'),(90,'ID','','NUMERIC','Text',4,10,10,'','','Y','Y','Y'),(100,'Fiscal Code','','FISCALCODE','Text',12,16,16,'','','Y','Y','Y'),(110,'First Name','','','Text',12,50,50,'','','Y','Y','Y'),(120,'Last Name','','','Text',12,50,50,'','','Y','Y','Y'),(130,'Address','','','Text',12,50,50,'','','Y','Y','Y'),(140,'Phone Number','','','Text',12,20,20,'','','Y','Y','Y'),(150,'HTML Text','','','TextArea',-1,65535,65535,'','','Y','Y','Y'),(160,'E-MAIL','','','Text',12,50,50,'','','Y','Y','Y'),(170,'Order Status','STATUS','','STATUSFLD',12,50,50,'','','Y','Y','Y');

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
