/**
* Metodo per chiamate AJAX asincrone
* @param resultDivId  : Nome del div che dovr? contenere l'html ritornato dalla chiamata
* @param inForm:        Nome della form contenente i dati da inviare con la post
* @param strURL:        Url da richiamare con la post
*
* Esempio di utilizzo: 
* <form name="f1">
*  <p>word: <input name="word" type="text">  
*  <input value="Go" type="button" onclick='JavaScript:xmlhttpPost("resultDiv", "f1", "/cgi-bin/simple-ajax-example.cgi")'></p>
*  <div id="resultDiv"></div>
*</form>
*/
function xmlhttpPost(inForm, strURL) {
	
	var xmlHttpReq = false;
    var self = this;
    // Mozilla/Safari
    if (window.XMLHttpRequest) {
        self.xmlHttpReq = new XMLHttpRequest();
    }
    // IE
    else if (window.ActiveXObject) {
        self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");
    }
	self.xmlHttpReq.open('POST', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    self.xmlHttpReq.onreadystatechange = function() {
        if (self.xmlHttpReq.readyState == 4) {
	         updatepage(self.xmlHttpReq.responseText);
        }
    }
    self.xmlHttpReq.send(getquerystring(inForm));
}

function getquerystring(inForm) {
	qstr='DOAJAX=1&';
	if (inForm != null) {
		var form = document.forms[inForm];
		if (form != null) {
			var inputs = form.getElementsByTagName('input'); 
			for (var i=0; inputs != null && i < inputs.length; i++) { 
				if ((inputs[i].getAttribute('type') != "button") &&
		   	        (inputs[i].getAttribute('type') != "checkbox") &&
		   	        (inputs[i].getAttribute('type') != "submit")) {
		   	        if (inputs[i].value != '') {
						qstr = qstr + inputs[i].name + "=" + inputs[i].value + "&" ;
					}
				}
			}
			inputs = form.getElementsByTagName('select'); 
			for (var i=0; inputs != null && i < inputs.length; i++) { 
				var val = inputs[i].options[inputs[i].selectedIndex].value ;
				if (val != ''){
						qstr = qstr + inputs[i].name + "=" + val + "&" ;
					}
			}
		}
	}
	
//	alert("queryString = '" + qstr + "'") ;
    return qstr;
}

function updatepage(str){
//alert(str) ;
	var startTime=new Date().getTime();
	var info=str.split('|');
	var error=null ;
	if(info.length>0)	{
		for(k=0;k<info.length;k+=2) {
			divId = info[k].trim() ;
			if (divId=="error") {
				error = info[k+1] ;
			}
			
			var obj = document.getElementById(divId);
			if(obj)	{
					
				if (obj.className=='combobox') {
					refreshOptionsList(obj,info[k+1]);
				} else {
			
					if(k+1>info.length || info[k+1]==null || info[k+1]=="") {
						obj.innerHTML = '';
					} else {
						obj.innerHTML = info[k+1];
					}
				
				}
			}
		}
	}
	// Nascondo la popUp di attesa
	nascondiSpecia();
	if (error != null) {
		if (document.getElementById("errors")) {
			document.getElementById("errors").value = error;
		}
	}
	initPage();

var endTime=new Date().getTime();
//alert('Elapsed time using local variable: '+((endTime-startTime)/1000)+' seconds.');
}

function loadCombo(formName,actionName,id) {
	var _url = "AjaxServlet?ACTION_NAME="+actionName+"&NAVIGATOR_DISABLED=TRUE&ID="+id;
	go('TRUE',_url,formName,'PLAIN');
}

/**
 *
 */
function parseXmlOutput(output) {
	
	var xmlDoc;
	
	try //Internet Explorer
	  {
	  xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
	  xmlDoc.async="false";
	  xmlDoc.loadXML(output);
	  }
	catch(e)
	  {
	  try //Firefox, Mozilla, Opera, etc.
	    {
	    var parser=new DOMParser();
	    xmlDoc=parser.parseFromString(output,"text/xml");
	    }
	  catch(e) {}
	  }
	
	return xmlDoc;
} 

/**
 *
 */
function refreshOptionsList(obj,xml) {
	
		var tmp;
		var oOption;					
		
		//Clean the current options
		var len = obj.length;
		for (i=0;i<len;i++) {
			obj.remove(0);
		}
		
		//Adds an empty row
		oOption = document.createElement("OPTION");
	    oOption.text="";
	    oOption.value="";
		oOption.selected = true;
	 	try
	    {
	    obj.add(oOption,null); // standards compliant
	    }
	  	catch(ex)
	    {
	    obj.add(oOption); // IE only
	    }
		
		var out = parseXmlOutput(xml);
		var x=out.documentElement.childNodes;
		
		//Converts the ROWS.ROW structure with VALUE, DISPLAY pairs in new options
		for (i=0;i<x.length;i++)
		{ 
		if (x[i].nodeName=='ROWS')
		  {
		  	for (z=0;z<x[i].childNodes.length;z++) {
		  		if (x[i].childNodes[z].nodeName=='ROW') {
			  		oOption = document.createElement("OPTION");
		    		oOption.text=x[i].childNodes[z].getAttribute('DISPLAY');
		    		oOption.value=x[i].childNodes[z].getAttribute('VALUE');
		    		try
				    {
				    obj.add(oOption,null); // standards compliant
				    }
				    catch(ex)
				    {
				    obj.add(oOption); // IE only
				    }
		    	}
		  	}
		  } 
		}
} 

