// Creation date and time: 19/11/2008 15:38:16 Source Template : jEnviron/DeletedFlagEnvironmentDAO 

package it.eng.common.dao;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SessionContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.dao.AbstractDAO;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.mappers.DB2SQLMapper;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFInternalError;
import it.eng.spago.tracing.TracerSingleton;
import it.eng.spago.util.QueryExecutor;
import it.eng.spago.util.StatementProvider;
import java.io.Serializable;
import java.sql.SQLException;
import java.sql.Types;
import java.util.ArrayList;
import java.util.concurrent.CancellationException;
import java.util.Calendar;
import java.text.SimpleDateFormat;

public abstract class CLASSICLOGDAO extends AbstractDAO implements Serializable {
	protected final static String FLG_DELETED = "A";
	protected final static String FLG_ACTIVED = " ";

	private String _flagCancelled = FLG_ACTIVED ;
	protected abstract String[] getParametersForCancelledQuery() ;
	protected abstract String getCancelledQuery() ;
	
	public String getQuery()  throws Exception  {
		String type = getType() ;
		String statement = "";
		if (type.equals(QueryExecutor.UPDATE))
			statement = handleUpdate() ;
		else if (type.equals(QueryExecutor.CREATE))
			statement = handleInsert() ;
		else if (type.equals(QueryExecutor.READ))
			statement = handleSelect() ;
		else if (type.equals(QueryExecutor.DELETE))
			statement = handleDelete() ;
		return statement ;
	}

	
	protected java.sql.Date getCurrentSqlDate() {
		return new java.sql.Date(it.eng.spago.util.StringUtils.getCurrentDate().getTime()) ;
	}

	public String getFlagCancelled() {
		return _flagCancelled ;
	}
	
	protected String getCurrentDate() {
		Calendar cal = Calendar.getInstance();
    	SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
    	return sdf.format(cal.getTime());	
    }
	
	protected String getCurrentTime() {
		Calendar cal = Calendar.getInstance();
    	SimpleDateFormat sdf = new SimpleDateFormat("HHmmss");
    	return sdf.format(cal.getTime());	
    }
    
	protected String getUserName() {
		/*
		SessionContainer permanentContainer = _requestContext.getRequestContainer().getSessionContainer().getPermanentContainer();
		return (String) permanentContainer.getAttribute("UserId");
		*/ return "userDemo" ;
	}

	protected String getProgramName() {
		return (String) ConfigSingleton.getInstance().getAttribute("COMMON.PROGRAM_NAME") ;
	}
		
	protected String handleUpdate()  throws Exception {
		_flagCancelled = FLG_ACTIVED ;
		loadAuditParameter("U") ;
		return getStatement() ;
	}
	protected String handleInsert()  throws Exception {
		// Verifica se non esiste il record ...
		if (! isExisting(FLG_ACTIVED)) {
			// Se esiste cancellato: questo diventa un update 
			if (isExisting(FLG_DELETED)) {
				return changeToUpdate() ;
			} 
		}
		_flagCancelled = FLG_ACTIVED ;
		loadAuditParameter("I") ;
		return getStatement() ;
	}
	protected String handleSelect()  throws Exception {
		return getStatement() ;
	}
	
	protected String handleDelete()  throws Exception {
		_flagCancelled = FLG_DELETED ;
		addParameter(_dataConnection.createDataField("", 91, getCurrentSqlDate()));
		loadAuditParameter("U") ;
		return getStatement() ;
	}
	
	/**
	 * Verifica l'esistenza di un record.
	 * @param cacelledFlag : Permette di specificare lo stato del record da ricercare
	 * @return
	 */
	protected boolean isExisting(String cancelledFlag) throws Exception {
		SourceBean result = null ;
		if (cancelledFlag.equals(FLG_DELETED)) {
			ArrayList parameterList = getParametersValue(getParametersForCancelledQuery()) ;
			result = (SourceBean)QueryExecutor.executeStatement(
									_dataConnection,
									getStatementFromConfiguration(getCancelledQuery()),
									QueryExecutor.READ,
									parameterList);
		} else {
			ArrayList parameterList = getParametersValue(getParametersForSelectQuery()) ;
			result = (SourceBean)QueryExecutor.executeStatement(
									_dataConnection,
									getStatementFromConfiguration(getSelectQuery()),
									QueryExecutor.READ,
									parameterList);
		}
		
		return result != null && result.getContainedAttributes().size() > 0 ;
	}
	
	/**
	 * Metodo per eseguire Update anzich Insert
	 * @return
	 * @throws Exception
	 */
	protected String changeToUpdate() throws Exception {
		_statementType = "UPDATE_QUERY" ;
		_flagCancelled = FLG_ACTIVED ;
		loadAuditParameter("U") ;
		_parameterList.addAll(getParametersValue(getParametersForUpdateQuery())) ;
		_returnCode = QueryExecutor.executeStatement(
				_dataConnection,
				getStatementFromConfiguration(getUpdateQuery()),
				QueryExecutor.UPDATE,
				_parameterList) ;
		_parameterList = null ;
		
		// Se l'update va a buon fine il QueryExecutor ritorna true
		if ((Boolean)_returnCode != true) {
			TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.CRITICAL, "CLASSICLOGDAO::changeToUpdate: Update non eseguito");
			_requestContext.getResponseContainer().getErrorHandler().addError(new EMFInternalError(EMFErrorSeverity.ERROR, "Update non eseguito"));
		}
		return "" ; // Null query to stopping execution
	}
	
	
	protected void loadAuditParameter(String parameterType) {
		if (parameterType.equalsIgnoreCase("I")) {
			addParameter(_dataConnection.createDataField("", 12,getUserName()));

		}
		if (parameterType.equalsIgnoreCase("U")) {
			addParameter(_dataConnection.createDataField("", 12,getUserName()));

		}
		// Reserve Future Use
		if (parameterType.equalsIgnoreCase("D")) {
			addParameter(_dataConnection.createDataField("", 91,getCurrentSqlDate()));
addParameter(_dataConnection.createDataField("", 12,getUserName()));

		}
	}
}

