/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.base;

import java.io.Serializable;

import it.eng.spago.util.XMLUtil;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class NullValue implements XMLObject, Serializable {
	private static final long serialVersionUID = 1L;
	
	private static final String NULL_VALUE = "null";
	private static final String NULL_VALUE_ELEMENT = "NULL";

	public Document toDocument() {
		return toDocument(null);
	}

	public Document toDocument(XMLSerializer serializer) {
        return XMLUtil.toDocument(this, serializer);
	}

	public Element toElement(Document document) {
        return toElement(document, null);
	}

	public Element toElement(Document document, XMLSerializer serializer) {
		return document.createElement(NULL_VALUE_ELEMENT);
	}

	public String toXML() {
		return NULL_VALUE;
	}

	public String toXML(boolean inlineEntity) {
		return NULL_VALUE;
	}

	public String toXML(int level) {
		return NULL_VALUE;
	}

}
