/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.base;

import java.io.Serializable;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * XML serializer with the toString method
 */
public class StringXMLSerializer implements XMLSerializer, Serializable {

	private static final long serialVersionUID = 1L;

	/* (non-Javadoc)
     * @see it.eng.spago.base.XMLSerializer#serialize(org.w3c.dom.Document, org.w3c.dom.Element, java.lang.String, java.lang.Object)
     */
    public void serialize(Document document, Element element, final String key, final Object value) {
        String attributeValue = value.toString();
        element.setAttribute(key, attributeValue);            
    }
    
}
