/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.base;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * This is the interface to implement by objects that serialize from Java object to XML
 */
public interface XMLSerializer {
    
    /**
     * Serialize the object source putting in the DOM document.
     * @param document Current DOM
     * @param element Current element in DOM
     * @param key Key of the object to serialize
     * @param source Object to serialize
     */
    void serialize(Document document, Element element, final String key, final Object source);

}
