/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.configuration;

import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.InputStream;

import org.xml.sax.InputSource;

/**
 * Oggetto che permette di leggere la configurazione da file, conoscendone il path.
 */
public class FileCreatorConfiguration implements IConfigurationCreator {
	
	private String rootPath = null;
	
	public FileCreatorConfiguration(String rootPath) {
		this.rootPath = rootPath;
	}
    
	public InputStream getInputStream(String resourceName) throws FileNotFoundException {
            return (new FileInputStream(rootPath + resourceName));
	}

	public SourceBean createConfiguration(String configName) throws SourceBeanException {
        SourceBean result = null;
     //   InputStream resourcesStream = null;

        try {
            //resourcesStream = getInputStream(configName);
            result = SourceBean.fromXMLFile(configName);
        }
        catch (Exception ex) {
        	throw new SourceBeanException(ex.getMessage());
        }
  //      finally {
 //       	if (resourcesStream != null) {
  //      		try {
  //      			resourcesStream.close();
  ///      		} catch (Exception ex) {
   //     			throw new SourceBeanException(ex.getMessage());
   //     		}
    //    	}
    //    }
        return result;
    }

}
