/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.dao;

import java.util.ArrayList;
import it.eng.spago.dispatching.service.RequestContextIFace;
import it.eng.spago.util.StatementProvider;

public interface IFaceQueryProvider {
	/**
	 * Ritorna lo Statement utile per la richiesta in atto
	 * @param requestContext
	 * @return
	 */
    public String getQuery(StatementProvider statementProvider);
    public Object getReturnCode() ;
    
    /**
     * Ritorna la lista dei parametri che devono essere aggiunti a quelli 
     * @param requestContext
     * @return
     */
    public ArrayList getParameterList();
} // public interface IFaceQueryProvider
