/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.decorators;

import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.decorators.AbstractDecorator;
import it.eng.spago.util.QueryExecutor;

import java.util.ArrayList;
import java.util.List;

/**
 * @author grassi
 *
 */
public class ComboSceltaModuloDecorator extends AbstractDecorator {

	public ComboSceltaModuloDecorator(SourceBean config, RequestContainer requestContainer) {
		super(config, requestContainer);
	}

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/* (non Javadoc)
	 * @see it.eng.spago.decorators.AbstractDecorator#decorate(java.lang.Object)
	 */
	@Override
	public String decorate(Object in) {
		return null ;
	}

	public List optionList() {
		ArrayList rowsList = new ArrayList() ;
		SourceBean query = (SourceBean) _config.getAttribute("SELECT_QUERY") ;
		
		SourceBean rowsSourceBean = ((SourceBean) QueryExecutor.executeQuery(_requestContainer, null, "", query, "SELECT"));
		if (rowsSourceBean != null) {
			rowsList = (ArrayList)rowsSourceBean.getAttributeAsList("ROW");
		}
		return purgeExisting(rowsList) ;
	}
	
	private List purgeExisting(List rowsList) {
		ArrayList purgedList = new ArrayList() ;
		if (rowsList != null && rowsList.size() > 0) {
			for (int i=0 ; i < rowsList.size() ; i++) {
				SourceBean row = (SourceBean)rowsList.get(i) ;
				String moduleName = (String)row.getAttribute("value") ;
				if (ConfigSingleton.getInstance().getFilteredSourceBeanAttribute("MODULES.MODULE", "name", moduleName) == null)
						purgedList.add(row) ;
			}
		}
		return purgedList ;
	}
}