/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.dispatching.module.detail.impl;

import java.math.BigDecimal;
import java.util.List;
import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;
import it.eng.spago.tracing.TracerSingleton;
import it.eng.spago.util.JavaScript;
import it.eng.spago.util.QueryExecutor;

/**
 * @author scarciello
 *
 */
public class ConfigDetailModule extends DefaultConfigDetailModule {

	/**
	 * 
	 */
	private static final long serialVersionUID = 3341619347919364433L;

	private static final String TPL_WIDGET_NAME = "<?Name?>";
	private static final String TPL_WIDGET_SIZE = "<?FieldSize?>";
	private static final String TPL_WIDGET_LABEL = "<?FieldLabel?>";
	private static final String TPL_WIDGET_DECORATOR = "<?FieldDecorator?>";
	private static final String TPL_WIDGET_TEMPLATE = "<?template?>";
	private static final String TPL_WIDGET_ONKEYPRESS = "<?FieldOnKeyPress?>";
	private static final String TPL_WIDGET_ONKEYUP = "<?FieldOnKeyUp?>";
	private static final String TPL_WIDGET_MAXLENGTH = "<?FieldMaxLength?>";
	private static final String TPL_WIDGET_INSERT_SELECTMODULE = "<?FieldInsertSelectModule?>";
	private static final String TPL_WIDGET_UPDATE_SELECTMODULE = "<?FieldUpdateSelectModule?>";
	private static final String TPL_WIDGET_LOOKUPACTION = "<?FieldLookupAction?>";
	private static final String TPL_WIDGET_INSERT_TEXTAREAROWS = "<?TextAreaInsertRows?>";
	private static final String TPL_WIDGET_UPDATE_TEXTAREAROWS = "<?TextAreaUpdateRows?>";
	private static final String TPL_WIDGET_INSERT_TEXTAREACOLS = "<?TextAreaInsertCols?>";
	private static final String TPL_WIDGET_UPDATE_TEXTAREACOLS = "<?TextAreaUpdateCols?>";
	private static final String TPL_WIDGET_INSERT_READONLY = "<?FieldInsertReadOnly?>";
	private static final String TPL_WIDGET_UPDATE_READONLY = "<?FieldUpdateReadOnly?>";
	private static final String TPL_WIDGET_INSERT_MANDATORY = "<?FieldInsertMandatory?>";
	private static final String TPL_WIDGET_UPDATE_MANDATORY = "<?FieldUpdateMandatory?>";
	private static final String TPL_WIDGET_INSERT_VISIBLE = "<?FieldInsertVisible?>";
	private static final String TPL_WIDGET_UPDATE_VISIBLE = "<?FieldUpdateVisible?>";
	private static final String TPL_WIDGET_LOOKUPALIASNAME = "<?LookupAliasName?>";
	private static final String TPL_WIDGET_ID = "<?ID?>";
	
	public void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception {
		String moduleName = (String) serviceRequest.getAttribute("Name");
		if (moduleName != null && moduleName != "") {
			moduleName = moduleName.replaceFirst("Lista","Dettaglio");
			serviceRequest.updAttribute("NameDett",moduleName);
		}

    	String sortAction = (String) serviceRequest.getAttribute("SortAction");
		String fileFisico = (String) serviceRequest.getAttribute("FileFisico");
		SourceBean templateList = getTemplateList() ;
		if ((sortAction == null) && (fileFisico != null)) {
			// Prepara l'accesso ai dati riempiendo i campi necessari per i moduli
			String pageName = "<?PAGE_NAME?>";
			int fieldNumber = 0;
			String filterParameters = "";
			String orderBy = "<ORDER_BY sql=\"";
			String parametriDelete = "";
			String elencoColonne = "";
			String parametriSelectCaption = "";
			String parametriDeleteCaption = "";
			String parametriDettaglio = "";
			String parametriInsert = "";
			String parametriUpdate = "";
			String elencoFields = "";
			String elencoFilters = "";
			String returnValues = "";
			String name = "<?NameDett?>";
			boolean okSelectCaption = false;
			sortAction = "";
			parametriSelectCaption = "<PARAMETER name=\"PAGE\" type=\"ABSOLUTE\" value=\""+pageName.trim()+"\" scope=\"\" />\n";
			// Gius: non serve pi parametriSelectCaption = parametriSelectCaption+"<PARAMETER name=\"MODULE\" type=\"ABSOLUTE\" value=\""+name+"\" scope=\"\" />\n";
			// Gius: aggiunta PAGE a delete caption
			parametriDeleteCaption =  "<PARAMETER name=\"PAGE\" type=\"ABSOLUTE\" value=\""+pageName.trim()+"\" scope=\"\" />\n";
			String pool = (String)getConfig().getAttribute("pool") ;
	    	SourceBean fieldsQuery = (SourceBean)getConfig().getAttribute("QUERIES.FIELDS_QUERY") ;
	    	SourceBean selectedFieldsBean = (SourceBean)QueryExecutor.executeQuery(getRequestContainer(),getResponseContainer(), pool, fieldsQuery, "SELECT") ;
	    	String prefissoCampi = "";
	    	int idCode = 0;
	    	int idFilters = 0;
	    	
    		//Object inputSize ;
    		String descrizioneCampo, webName,campoChiave,nomeCampo,azioneSort,decoratorType,campoNull,mandatory,readOnlyForUpdate,fieldVisible,useInInsert,useInUpdate,mandatorio ;
	    	for(SourceBean row : (List<SourceBean>) selectedFieldsBean.getAttributeAsList("ROW")) {
	    		++fieldNumber;
				prefissoCampi = (String) row.getAttribute("PREFISSOCAMPI"); 
				if(prefissoCampi!=null && prefissoCampi.trim().length()>0)
					prefissoCampi=prefissoCampi.trim()+"_";
				else 
					prefissoCampi="";
	    		descrizioneCampo = (String) row.getAttribute("DESCRIZIONECAMPO");
	    		webName = (String) row.getAttribute("CAMPOWEB");
	    		webName = prefissoCampi+webName;
	    		campoChiave = (String) row.getAttribute("CAMPOCHIAVE");
	    		nomeCampo = (String) row.getAttribute("NOMECAMPO");
	    		azioneSort = (String) "sortBy"+webName;
	    		decoratorType = (String) row.getAttribute("DECORATORTYPE");
	    		campoNull = (String) row.getAttribute("CAMPONULL");
	    		useInInsert = (String) row.getAttribute("USEININSERT");
	    		useInUpdate = (String) row.getAttribute("USEINUPDATE");
	    		mandatorio = (String) row.getAttribute("MANDATORIO");
	    		mandatory = "FALSE";
	    		readOnlyForUpdate = "FALSE";
	    		fieldVisible = (String) row.getAttribute("FIELDVISIBLE");
	    		//inputSize = row.getAttribute("LUNGHEZZAINPUT");
	    		String validator =((String)row.getAttribute("VALIDATOR")).trim().toUpperCase() ;
	    		String typedService = "";
	    		if ((validator != null) && (validator!="")) 
	    				typedService="TYPED_SERVICE_REQUEST.";
	    		// 2007-10-30 A.G. Metodo per la gestione dei FILTER
	    		filterParameters += getFilterParameter(row, fieldVisible) ;

	    		if(fieldVisible==null || fieldVisible.equalsIgnoreCase("Y")) {
		    		sortAction=sortAction+"<SORT_ACTION name=\""+azioneSort.trim()+"\" sql=\""+webName.trim()+"\" />\n";
	    			elencoColonne=elencoColonne+"<COLUMN name=\""+webName.trim()+"\" type=\"FIELD\" sortaction=\""+azioneSort.trim()+"\" decorator=\""+decoratorType.trim()+"\"/>\n";
	    		}
	    		if(useInInsert==null || useInInsert.length()==0 || useInInsert.equalsIgnoreCase("Y"))
	    			parametriInsert=parametriInsert+"<PARAMETER type=\"RELATIVE\" value=\""+typedService+webName.trim()+"\" scope=\"SERVICE_REQUEST\" />\n";
	    		returnValues=returnValues+"<PARAMETER name=\""+webName.trim()+"\" type=\"RELATIVE\" value=\""+webName.trim()+"\" scope=\"LOCAL\" />\n";
	    		if (campoChiave.equalsIgnoreCase("Y")) {
	    			parametriDelete=parametriDelete+"<PARAMETER type=\"RELATIVE\" value=\""+webName.trim()+"\" scope=\"SERVICE_REQUEST\" />\n";
	    			parametriDeleteCaption=parametriDeleteCaption+"<PARAMETER name=\""+webName.trim()+"\" type=\"RELATIVE\" value=\""+webName.trim()+"\" scope=\"LOCAL\" />\n";
	    			// 2007-11-19 AG: I caption non usano la busta TYPED !! parametriSelectCaption=parametriSelectCaption+"<PARAMETER name=\""+typedService+webName.trim()+"\" type=\"RELATIVE\" value=\""+webName.trim()+"\" scope=\"LOCAL\" />\n";
	    			parametriSelectCaption=parametriSelectCaption+"<PARAMETER name=\""+webName.trim()+"\" type=\"RELATIVE\" value=\""+webName.trim()+"\" scope=\"LOCAL\" />\n";
	    			parametriDettaglio=parametriDettaglio+"<PARAMETER type=\"RELATIVE\" value=\""+typedService+webName.trim()+"\" scope=\"SERVICE_REQUEST\" />\n";
	    			mandatory = "TRUE";
	    			readOnlyForUpdate = "TRUE";
	    			if (fieldNumber>1) orderBy+=",";
	    			orderBy+=webName.trim();
	    		}
	    		else {
		    		if(useInUpdate==null || useInUpdate.length()==0 || useInUpdate.equalsIgnoreCase("Y")) {
		    			parametriUpdate=parametriUpdate+"<PARAMETER type=\"RELATIVE\" value=\""+typedService+webName.trim()+"\" scope=\"SERVICE_REQUEST\" />\n";
		    			okSelectCaption = true;
		    		}
	    		}
	    		if (campoNull.equalsIgnoreCase("N")) {
	    			mandatory = "TRUE";
	    		}
	    		if (mandatorio!=null && mandatorio.equalsIgnoreCase("Y")) {
	    			mandatory = "TRUE";
	    		}
	    		// Sezione dedicata ai fields
	    		String widgetCampo = (String) row.getAttribute("WIDGETCAMPO");
	    		
	    		for(SourceBean tplWidget : (List<SourceBean>) templateList.getAttributeAsList("ROW")) {
	    			String codTemplate = (String) tplWidget.getAttribute("CODTEMPLATE") ;
	    			codTemplate=codTemplate.trim();
	    			if (codTemplate.equalsIgnoreCase(widgetCampo.trim())) {
	    				// esegue la get del template
	    				String refTemplate = (String) tplWidget.getAttribute("REFTEMPLATE") ;
	    	    		Object lunghezzaCampo = row.getAttribute("LUNGHEZZAOUTPUT");
	    				StringBuffer widgetTemplate = readTemplateFile(refTemplate) ;
	    				if (widgetTemplate!=null) {
	    					++idCode;
	    					String visibleInsert = "TRUE";
	    					String visibleUpdate = "TRUE"; 
	    					if(fieldVisible!=null && fieldVisible.equalsIgnoreCase("N")) {
	    						visibleInsert = "FALSE";
	    						visibleUpdate = "FALSE";
	    					}
	    					if(useInInsert!=null && useInInsert.equalsIgnoreCase("N"))
	    						visibleInsert="FALSE";
	    					if(useInUpdate!=null && useInUpdate.equalsIgnoreCase("N"))
	    						visibleUpdate="FALSE";
	    					replaceToken(widgetTemplate,TPL_WIDGET_NAME,webName.trim());
	    					replaceToken(widgetTemplate,TPL_WIDGET_SIZE,lunghezzaCampo.toString());
	    					replaceToken(widgetTemplate,TPL_WIDGET_LABEL,descrizioneCampo.trim());
	    					replaceToken(widgetTemplate,TPL_WIDGET_DECORATOR,decoratorType.trim());
	    					replaceToken(widgetTemplate,TPL_WIDGET_TEMPLATE,widgetCampo.trim());
	    					replaceToken(widgetTemplate,TPL_WIDGET_ONKEYPRESS,"");
	    					replaceToken(widgetTemplate,TPL_WIDGET_ONKEYUP,"");
	    					replaceToken(widgetTemplate,TPL_WIDGET_MAXLENGTH,lunghezzaCampo.toString());
	    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_SELECTMODULE,"");
	    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_SELECTMODULE,"");
	    					replaceToken(widgetTemplate,TPL_WIDGET_LOOKUPACTION,"");
	    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_TEXTAREAROWS,"5");
	    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_TEXTAREAROWS,"5");
	    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_TEXTAREACOLS,"80");
	    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_TEXTAREACOLS,"80");
	    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_READONLY,"FALSE");
	    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_READONLY,readOnlyForUpdate);
	    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_MANDATORY,mandatory);
	    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_MANDATORY,mandatory);
	    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_VISIBLE,visibleInsert);
	    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_VISIBLE,visibleUpdate);
	    					replaceToken(widgetTemplate,TPL_WIDGET_LOOKUPALIASNAME,"");
	    					replaceToken(widgetTemplate,TPL_WIDGET_ID,""+idCode);
	    		    		elencoFields+=widgetTemplate.toString();
	    				}
	    				// Esegue quindi la stessa operazione per i filtri
	    				refTemplate = (String) tplWidget.getAttribute("REFTEMPLATE") ;
	    	    		lunghezzaCampo = row.getAttribute("LUNGHEZZAOUTPUT");
	    				widgetTemplate = readTemplateFile(refTemplate) ;
	    				if (widgetTemplate!=null) {
	    					++idFilters;
	    					String visibleInsert = "TRUE";
	    					String visibleUpdate = "TRUE"; 
	    					if(fieldVisible!=null && fieldVisible.equalsIgnoreCase("N")) {
	    						visibleInsert = "FALSE";
	    						visibleUpdate = "FALSE";
	    					}
	    					if(useInInsert!=null && useInInsert.equalsIgnoreCase("N"))
	    						visibleInsert="FALSE";
	    					if(useInUpdate!=null && useInUpdate.equalsIgnoreCase("N"))
	    						visibleUpdate="FALSE";
	    					replaceToken(widgetTemplate,TPL_WIDGET_NAME,"FILTER_"+webName.trim());
	    					replaceToken(widgetTemplate,TPL_WIDGET_SIZE,lunghezzaCampo.toString());
	    					replaceToken(widgetTemplate,TPL_WIDGET_LABEL,descrizioneCampo.trim());
	    					replaceToken(widgetTemplate,TPL_WIDGET_DECORATOR,decoratorType.trim());
	    					replaceToken(widgetTemplate,TPL_WIDGET_TEMPLATE,widgetCampo.trim());
	    					replaceToken(widgetTemplate,TPL_WIDGET_ONKEYPRESS,"");
	    					replaceToken(widgetTemplate,TPL_WIDGET_ONKEYUP,"");
	    					replaceToken(widgetTemplate,TPL_WIDGET_MAXLENGTH,lunghezzaCampo.toString());
	    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_SELECTMODULE,"");
	    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_SELECTMODULE,"");
	    					replaceToken(widgetTemplate,TPL_WIDGET_LOOKUPACTION,"");
	    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_TEXTAREAROWS,"5");
	    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_TEXTAREAROWS,"5");
	    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_TEXTAREACOLS,"80");
	    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_TEXTAREACOLS,"80");
	    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_READONLY,"FALSE");
	    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_READONLY,readOnlyForUpdate);
	    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_MANDATORY,mandatory);
	    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_MANDATORY,mandatory);
	    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_VISIBLE,visibleInsert);
	    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_VISIBLE,visibleUpdate);
	    					replaceToken(widgetTemplate,TPL_WIDGET_LOOKUPALIASNAME,"");
	    					replaceToken(widgetTemplate,TPL_WIDGET_ID,""+idFilters);
	    		    		elencoFilters+=widgetTemplate.toString();
	    		    		elencoFilters+="<FIELD name=\""+"SELECT_"+webName.trim()+"\" widget=\"TEXT\" template=\"Text\">\n";
	    		    		elencoFilters+="  <INSERT is_readonly=\"TRUE\" is_visible=\"FALSE\" />\n";
	    		    		elencoFilters+="</FIELD>\n";
	    				}
	    			}
	    		}
	    	}
    		orderBy+="\" />\n";
	    	SourceBean campiDecodifica = getDecodingFields();
	    	int contaTabella=1;
	    	String lastFileFisicoRelazionato= " ";
	    	for(SourceBean campo : (List<SourceBean>)campiDecodifica.getAttributeAsList("ROW"))  {
	    		String fileFisicoRelazionato = (String) campo.getAttribute("NOMERELAZIONE");
	    		if (!lastFileFisicoRelazionato.equalsIgnoreCase(fileFisicoRelazionato)) {
	    			++contaTabella;
	    			lastFileFisicoRelazionato = new String(fileFisicoRelazionato);
	    		}
	    		String nomeCampoTabella = (String) campo.getAttribute("NOMECAMPO");
	    		String nomeCampoWeb = (String) campo.getAttribute("NOMECAMPOWEB");
	    		nomeCampoWeb = prefissoCampi+nomeCampoWeb;
	    		String nomeRelazione = (String) campo.getAttribute("NOMERELAZIONE");
	    		String lunghezzaMax = "" + campo.getAttribute("LUNGHEZZACAMPO");
	    		String lunghezzaExt = "" + campo.getAttribute("EXTERNALLENGTH");
	    		++idCode;
	    		elencoFields+="<FIELD id=\""+idCode+"\" name=\""+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" widget=\"TEXT\" SIZE=\""+lunghezzaExt.trim()+"\" MAXLENGTH=\""+lunghezzaMax.trim()+"\" template=\"Text\">\n";
	    		elencoFields+="  <INSERT is_readonly=\"FALSE\" is_visible=\"TRUE\" />\n";
	    		elencoFields+="  <UPDATE is_readonly=\"FALSE\" is_visible=\"TRUE\" />\n";
	    		elencoFields+="</FIELD>\n";
	    		elencoColonne+="<COLUMN name=\""+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" type=\"FIELD\" sortaction=\"sortBy"+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\"/>\n";
	    		returnValues=returnValues+"<PARAMETER name=\""+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" type=\"RELATIVE\" value=\""+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" scope=\"LOCAL\" />\n";
	    		sortAction+="<SORT_ACTION name=\"sortBy"+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" sql=\""+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" />\n";
	    		filterParameters+="<FILTER_PARAMETER type=\"RELATIVE\" scope=\"SERVICE_REQUEST\" uppercase=\"true\" value=\"FILTER_"+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" sql=\"UPPER(T"+nomeRelazione.trim()+"."+nomeCampoTabella.trim()+") LIKE ?\"/>\n";
	    	}

	    	SourceBean campiRelazioni = getRelationsFields();
	    	for(SourceBean relazione : (List<SourceBean>)campiRelazioni.getAttributeAsList("ROW"))  {
	    		String sottoRelazioni = (String) relazione.getAttribute("FLAGIMPORTARELAZIONI");
	    		if(sottoRelazioni!=null)
	    			sottoRelazioni=sottoRelazioni.trim();
	    		String codAmbiente = ((String) relazione.getAttribute("CODAMBIENTERELAZIONATO")).trim();
	    		String fileFisicoRel = ((String) relazione.getAttribute("FILEFISICORELAZIONATO")).trim();
	    		
	    		if(sottoRelazioni!=null && sottoRelazioni.equalsIgnoreCase("S")) {
	    			serviceRequest.updAttribute("SUBAMBIENTE", codAmbiente);
	    			serviceRequest.updAttribute("FILEREL",fileFisicoRel);
	    			
	    	    	SourceBean campiDecodificaSub = getDecodingSubFields();
	    	    	contaTabella=1;
	    	    	lastFileFisicoRelazionato= " ";
	    	    	for(SourceBean campo : (List<SourceBean>)campiDecodificaSub.getAttributeAsList("ROW"))  {
	    	    		String fileFisicoRelazionato = (String) campo.getAttribute("NOMERELAZIONE");
	    	    		if (!lastFileFisicoRelazionato.equalsIgnoreCase(fileFisicoRelazionato)) {
	    	    			++contaTabella;
	    	    			lastFileFisicoRelazionato = new String(fileFisicoRelazionato);
	    	    		}
	    	    		String nomeCampoTabella = (String) campo.getAttribute("NOMECAMPO");
	    	    		String nomeCampoWeb = (String) campo.getAttribute("NOMECAMPOWEB");
	    	    		nomeCampoWeb = prefissoCampi+nomeCampoWeb;
	    	    		String nomeRelazione = (String) campo.getAttribute("NOMERELAZIONE");
	    	    		String lunghezzaMax = "" + campo.getAttribute("LUNGHEZZACAMPO");
	    	    		String lunghezzaExt = "" + campo.getAttribute("EXTERNALLENGTH");
	    	    		++idCode;
	    	    		elencoFields+="<FIELD id=\""+idCode+"\" name=\""+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" widget=\"TEXT\" SIZE=\""+lunghezzaExt.trim()+"\" MAXLENGTH=\""+lunghezzaMax.trim()+"\" template=\"Text\">\n";
	    	    		elencoFields+="  <INSERT is_readonly=\"FALSE\" is_visible=\"TRUE\" />\n";
	    	    		elencoFields+="  <UPDATE is_readonly=\"FALSE\" is_visible=\"TRUE\" />\n";
	    	    		elencoFields+="</FIELD>\n";
	    	    		elencoColonne+="<COLUMN name=\""+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" type=\"FIELD\" sortaction=\"sortBy"+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\"/>\n";
	    	    		returnValues=returnValues+"<PARAMETER name=\""+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" type=\"RELATIVE\" value=\""+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" scope=\"LOCAL\" />\n";
	    	    		sortAction+="<SORT_ACTION name=\"sortBy"+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" sql=\""+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" />\n";
	    	    		filterParameters+="<FILTER_PARAMETER type=\"RELATIVE\" scope=\"SERVICE_REQUEST\" uppercase=\"true\" value=\"FILTER_"+nomeRelazione.trim()+"_"+nomeCampoWeb.trim()+"\" sql=\"UPPER(T"+nomeRelazione.trim()+"."+nomeCampoTabella.trim()+") LIKE ?\"/>\n";
	    	    	}
	    		}
	    	}
	    	
	    	parametriUpdate=parametriUpdate+parametriDettaglio;
	    	serviceRequest.setAttribute("FilterParameters", filterParameters);
			serviceRequest.setAttribute("SortAction", sortAction);
			serviceRequest.setAttribute("OrderBy", orderBy);
			serviceRequest.setAttribute("ParametriDelete", parametriDelete);
			serviceRequest.setAttribute("elencoColonne", elencoColonne);
			if (!okSelectCaption) 
				parametriSelectCaption = "<CONDITION>\n     <PARAMETER />\n</CONDITION>\n"+parametriSelectCaption;
			serviceRequest.setAttribute("ParametriSelectCaption", parametriSelectCaption);
			serviceRequest.setAttribute("ParametriDeleteCaption", parametriDeleteCaption);
	    	serviceRequest.setAttribute("ParametriDettaglio", parametriDettaglio);
	    	serviceRequest.setAttribute("ParametriInsert", parametriInsert);
	    	serviceRequest.setAttribute("ParametriUpdate", parametriUpdate);
	    	//elencoFields="<FIELDSET position=\"left\" name=\"key\" legend=\"FIELDSET\">\n"+elencoFields+"</FIELDSET>";
	    	//elencoFilters="<FIELDSET position=\"left\" name=\"key\" legend=\"FIELDSET\">\n"+elencoFilters+"</FIELDSET>";
	    	serviceRequest.setAttribute("ElencoFields", elencoFields);
	    	serviceRequest.setAttribute("ElencoFilters", elencoFilters);
	    	serviceRequest.setAttribute("ReturnValues", returnValues);
	    	serviceRequest.setAttribute("TitoloModulo", "Module for " + fileFisico);
	    	
		}
    	
		if(! serviceRequest.containsAttribute("FILE_PATH")) {
			serviceRequest.setAttribute("FILE_PATH", ConfigSingleton.getInstance().getAttribute("DAOGEN.pathXMLFile"));
		}

    	super.service(serviceRequest,serviceResponse) ;

		Object row = serviceResponse.getAttribute("ROW") ;
    	if (row != null && row instanceof SourceBean) {
    		serviceResponse.updAttribute(convertModuleConfiguration((SourceBean)row)) ;
    	}
	}
	
	/**
	 * Genera le righe per i FILTER_PARAMETER
	 * 
	 * La regola  che a seconda del tipo di validatore utilizzi il tipo nella service request o quello convertito 
	 *    nella busta typed_service_request (e non faccia la like)
	 * @param row
	 * @return
	 */
	private String getFilterParameter(SourceBean row, String fieldVisible) {
		String filterParameter = "";
		if(fieldVisible==null || fieldVisible.equalsIgnoreCase("Y")) {
			filterParameter = "<FILTER_PARAMETER type=\"RELATIVE\" scope=\"SERVICE_REQUEST\" " ;
			String prefissoCampi = (String) row.getAttribute("PREFISSOCAMPI");
			if(prefissoCampi!=null && prefissoCampi.trim().length()>0)
				prefissoCampi=prefissoCampi.trim()+"_";
			else
				prefissoCampi="";
			String webName = (String) row.getAttribute("CAMPOWEB");
			webName = prefissoCampi+webName;
			String nomeCampo = (String) row.getAttribute("NOMECAMPO");
			String validator =((String)row.getAttribute("VALIDATOR")).trim().toUpperCase() ;
	
			if (validator.equals("DATE") || validator.equals("TIMESTAMP") || validator.equals("DECIMAL") || validator.equals("NUMERIC") || validator.equals("IMPORTO"))
				filterParameter += "value=\"TYPED_SERVICE_REQUEST.FILTER_"+webName.trim()+"\"  sql=\"T1."+nomeCampo.trim()+" = ?\"" ;
			else if (validator.equals("GENERIC"))
				filterParameter += "value=\"TYPED_SERVICE_REQUEST.FILTER_"+webName.trim()+"\" uppercase=\"true\" sql=\"UPPER(T1."+nomeCampo.trim()+") like ?\"" ;  
			else
				filterParameter += "value=\"FILTER_"+webName.trim()+"\" uppercase=\"true\" sql=\"UPPER(T1."+nomeCampo.trim()+") like ?\"" ;
			filterParameter += " />\n";
		}
		else filterParameter="";
		return filterParameter ;
	}
	
	/**
	 * Uniforma i parametri dei moduli ed aggiunge i parametri calcolati (SortAction, FilterParameter, ...)
	 * @param rowBean
	 * @return
	 * @throws SourceBeanException
	 */
	SourceBean convertModuleConfiguration(SourceBean moduleBean) throws SourceBeanException {
		SourceBean rowBean = new SourceBean("ROW") ;
		rowBean.setAttribute("TitoloModulo", moduleBean.getAttribute("CONFIG.TITLE")) ;
		String templateName = (String) moduleBean.getAttribute("TEMPLATE_MOD");
		if (templateName==null)
			templateName="";
		rowBean.setAttribute("Template", templateName) ; 
		rowBean.setAttribute("Name", moduleBean.getAttribute("NAME")) ; 
		rowBean.setAttribute("ParametriSelectCaption", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.CAPTIONS.SELECT_CAPTION"), "PARAMETER")) ; 
		rowBean.setAttribute("ParametriDeleteCaption", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.CAPTIONS.DELETE_CAPTION"), "PARAMETER")) ; 
		rowBean.setAttribute("ElencoColonne", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.COLUMNS"), "COLUMN")) ;
		rowBean.setAttribute("ElencoFields", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.FIELDS"), "FIELDSET")) ; 
		if (moduleBean.containsAttribute("CONFIG.ROW_PROVIDER")) {
			// DefaultSmartListModule
			rowBean.setAttribute("nomeClasse", moduleBean.getAttribute("CONFIG.ROW_PROVIDER.CONFIG.LIST_QUERY.CLASS")) ; 
			rowBean.setAttribute("PoolConnessione", moduleBean.getAttribute("CONFIG.ROW_PROVIDER.CONFIG.pool")) ; 
			SourceBean daoInfo = getDaoInfo((String)moduleBean.getAttribute("CONFIG.ROW_PROVIDER.CONFIG.LIST_QUERY.CLASS")) ; 
			rowBean.setAttribute("FileFisico", daoInfo.getAttribute("FILENAME", "??")) ; 
			rowBean.setAttribute("CodAmbiente", daoInfo.getAttribute("ENVIRONMENTNAME", "??")) ; 
			rowBean.setAttribute("FilterParameters", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.ROW_PROVIDER.CONFIG.LIST_QUERY"), "FILTER_PARAMETER")) ; 
			rowBean.setAttribute("SortAction", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.ROW_PROVIDER.CONFIG.LIST_QUERY"), "SORT_ACTION")) ; 
			rowBean.setAttribute("OrderBy", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.ROW_PROVIDER.CONFIG.LIST_QUERY"), "ORDER_BY")) ; 
			rowBean.setAttribute("ParametriDelete", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.ROW_PROVIDER.CONFIG.DELETE_QUERY"), "PARAMETER")) ;
			rowBean.setAttribute("ParametriDettaglio", "") ; 
			rowBean.setAttribute("ParametriInsert", "") ; 
			rowBean.setAttribute("ParametriUpdate", "") ; 
		} else if (moduleBean.containsAttribute("CONFIG.QUERIES.SELECT_QUERY.KEY")) {
			// DefaultConfigDetailModule
		} else if (moduleBean.containsAttribute("CONFIG.QUERIES.SELECT_QUERY")) {
			// DefaultDetailModule (con o senza DAO)
			rowBean.setAttribute("nomeClasse", moduleBean.getAttribute("CONFIG.QUERIES.SELECT_QUERY.CLASS")) ;
			rowBean.setAttribute("PoolConnessione", moduleBean.getAttribute("CONFIG.POOL")) ;
			SourceBean daoInfo = getDaoInfo((String)moduleBean.getAttribute("CONFIG.QUERIES.SELECT_QUERY.CLASS")) ; 
			rowBean.setAttribute("FileFisico", daoInfo.getAttribute("FILENAME", "??")) ; 
			rowBean.setAttribute("CodAmbiente", daoInfo.getAttribute("ENVIRONMENTNAME", "??")) ; 
			rowBean.setAttribute("FilterParameters", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.SELECT_QUERY"), "FILTER_PARAMETER")) ; 
			rowBean.setAttribute("SortAction", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.SELECT_QUERY"), "SORT_ACTION")) ; 
			rowBean.setAttribute("OrderBy", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.SELECT_QUERY"), "ORER_BY")) ; 
			rowBean.setAttribute("ParametriDelete", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.DELETE_QUERY"), "PARAMETER")) ;
			rowBean.setAttribute("ParametriDettaglio", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.SELECT_QUERY"), "PARAMETER")) ; 
			rowBean.setAttribute("ParametriInsert", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.INSERT_QUERY"), "PARAMETER")) ; 
			rowBean.setAttribute("ParametriUpdate", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.UPDATE_QUERY"), "PARAMETER")) ; 
		} else if (moduleBean.containsAttribute("CONFIG.QUERIES.LIST_QUERY")) {
			// DefaultDetailModule (con o senza DAO)
			rowBean.setAttribute("nomeClasse", moduleBean.getAttribute("CONFIG.QUERIES.LIST_QUERY.CLASS")) ;
			rowBean.setAttribute("PoolConnessione", moduleBean.getAttribute("CONFIG.POOL")) ;
			SourceBean daoInfo = getDaoInfo((String)moduleBean.getAttribute("CONFIG.QUERIES.LIST_QUERY.CLASS")) ; 
			rowBean.setAttribute("FileFisico", daoInfo.getAttribute("FILENAME", "??")) ; 
			rowBean.setAttribute("CodAmbiente", daoInfo.getAttribute("ENVIRONMENTNAME", "??")) ; 
			rowBean.setAttribute("FilterParameters", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.LIST_QUERY"), "FILTER_PARAMETER")) ; 
			rowBean.setAttribute("SortAction", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.LIST_QUERY"), "SORT_ACTION")) ; 
			rowBean.setAttribute("OrderBy", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.LIST_QUERY"), "ORDER_BY")) ; 
			rowBean.setAttribute("ParametriDelete", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.DELETE_QUERY"), "PARAMETER")) ;
			rowBean.setAttribute("ParametriDettaglio", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.SELECT_QUERY"), "PARAMETER")) ; 
			rowBean.setAttribute("ParametriInsert", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.INSERT_QUERY"), "PARAMETER")) ; 
			rowBean.setAttribute("ParametriUpdate", getQueryParameter((SourceBean)moduleBean.getAttribute("CONFIG.QUERIES.UPDATE_QUERY"), "PARAMETER")) ; 
		}
		return rowBean ;
	}

	private String getQueryParameter(SourceBean queryBean, String parameterKey) {
		String parString = "";
		if (queryBean != null) {
			List<SourceBean> queryBeanList = queryBean.getAttributeAsList(parameterKey) ;
			String xmlString ;
			for (SourceBean parBean : queryBeanList) {
				if (parBean != null) {
					xmlString = parBean.toString() ;
					if (xmlString.indexOf("<?xml") == 0)
						xmlString = xmlString.substring(xmlString.indexOf('\n')+1) ;
					parString += xmlString ;
				}
			}
		}
		return parString ;
	}
	
	private SourceBean  getDaoInfo(String classDaoName) throws SourceBeanException {
		SourceBean daoInfo = new SourceBean("DAOINFO") ;
		try {
			Class cls = Class.forName(classDaoName) ;
			String fileName =(String) cls.getMethod("getFileName").invoke(null, new Object[0]);
			daoInfo.setAttribute("FILENAME", fileName) ;
            String environmentName =(String) cls.getMethod("getEnvironmentName").invoke(null, new Object[0]) ;
            daoInfo.setAttribute("ENVIRONMENTNAME", environmentName) ;
         }
         catch (Throwable e) {
				TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG,
				"DefaultDetailModule::Errore durante l'invocazione dei metodi per la class" + classDaoName);
				getErrorHandler().addError(new EMFUserError(EMFErrorSeverity.ERROR, "Class " + classDaoName + " not found or problem in method getFileName(), getEnvironmentName()  invocation"));
         }
		return daoInfo ;
	}
	
	private SourceBean getTemplateList() throws Exception {
    	String pool = (String)getConfig().getAttribute("pool") ;
    	SourceBean templateQuery = (SourceBean)getConfig().getAttribute("QUERIES.TEMPLATE_LIST") ;
    	SourceBean selectedTemplateBean = (SourceBean)QueryExecutor.executeQuery(getRequestContainer(),getResponseContainer(), pool, templateQuery, "SELECT") ;
    	
    	return selectedTemplateBean ;
	}

	private SourceBean getDecodingFields() throws Exception {
    	String pool = (String)getConfig().getAttribute("pool") ;
    	SourceBean templateQuery = (SourceBean)getConfig().getAttribute("QUERIES.SELECT_FIELDS") ;
    	SourceBean selectedTemplateBean = (SourceBean)QueryExecutor.executeQuery(getRequestContainer(),getResponseContainer(), pool, templateQuery, "SELECT") ;
    	
    	return selectedTemplateBean ;
	}
	
	private SourceBean getRelationsFields() throws Exception {
    	String pool = (String)getConfig().getAttribute("pool") ;
    	SourceBean templateQuery = (SourceBean)getConfig().getAttribute("QUERIES.SELECT_RELATIONS") ;
    	SourceBean selectedTemplateBean = (SourceBean)QueryExecutor.executeQuery(getRequestContainer(),getResponseContainer(), pool, templateQuery, "SELECT") ;
    	
    	return selectedTemplateBean ;
	}

	private SourceBean getDecodingSubFields() throws Exception {
    	String pool = (String)getConfig().getAttribute("pool") ;
    	SourceBean templateQuery = (SourceBean)getConfig().getAttribute("QUERIES.SELECT_FIELDS_SUBREL") ;
    	SourceBean selectedTemplateBean = (SourceBean)QueryExecutor.executeQuery(getRequestContainer(),getResponseContainer(), pool, templateQuery, "SELECT") ;
    	
    	return selectedTemplateBean ;
	}
	
}