/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.dispatching.module.detail.impl;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;
import it.eng.spago.tracing.TracerSingleton;
import it.eng.spago.util.QueryExecutor;

import java.math.BigDecimal;
import java.util.List;

public class ConfigTabDetailModule extends DefaultConfigDetailModule {

	/**
	 * 
	 */
	private static final long serialVersionUID = 3341619347919364433L;

	private static final String TPL_WIDGET_PAGENAME = "<?PAGE_NAME?>";
	private static final String TPL_WIDGET_NAME = "<?Name?>";
	private static final String TPL_WIDGET_LABEL = "<?Label?>";
	private static final String TPL_WIDGET_CONDITION = "<?ConditionParameters?>";
	private static final String TPL_WIDGET_POOL = "<?PoolQueryParameter?>";
	private static final String TPL_WIDGET_QUERY = "<?QueryStatement?>";
	private static final String TPL_WIDGET_QUERY_PARAMETERS = "<?QueryParameters?>";
	private static final String TPL_WIDGET_PARAMETERS = "<?Parameters?>";

	
	public void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception {
		super.service(serviceRequest,serviceResponse) ;
		Object row = serviceResponse.getAttribute("ROW") ;
    	if (row != null && row instanceof SourceBean) {
    		serviceResponse.updAttribute(convertTabConfiguration((SourceBean)row)) ;
    	}
	}
	
	
	/**
	 * Uniforma i parametri dei moduli ed aggiunge i parametri calcolati (SortAction, FilterParameter, ...)
	 * @param rowBean
	 * @return
	 * @throws SourceBeanException
	 */
	SourceBean convertTabConfiguration(SourceBean moduleBean) throws SourceBeanException {

		moduleBean.setAttribute("parameters", getQueryParameter(moduleBean, "PARAMETER")) ;
		moduleBean.setAttribute("conditionParameters", getQueryParameter((SourceBean)moduleBean.getAttribute("CONDITION"), "PARAMETER")) ;
		
		if (moduleBean.getAttribute("QUERY_PARAMETER")!=null) {
			moduleBean.setAttribute("queryParameters", getQueryParameter((SourceBean)moduleBean.getAttribute("QUERY_PARAMETER"), "PARAMETER")) ;		
			moduleBean.setAttribute("poolQueryParameter", ((SourceBean)moduleBean.getAttribute("QUERY_PARAMETER")).getAttribute("POOL")) ;
			moduleBean.setAttribute("queryStatement", ((SourceBean)moduleBean.getAttribute("QUERY_PARAMETER")).getAttribute("STATEMENT")) ;
		}
		
		return moduleBean ;
		
	}

	private String getQueryParameter(SourceBean queryBean, String parameterKey) {
		String parString = "";
		if (queryBean != null) {
			List<SourceBean> queryBeanList = queryBean.getAttributeAsList(parameterKey) ;
			String xmlString ;
			for (SourceBean parBean : queryBeanList) {
				if (parBean != null) {
					xmlString = parBean.toString() ;
					if (xmlString.indexOf("<?xml") == 0)
						xmlString = xmlString.substring(xmlString.indexOf('\n')+1) ;
					parString += xmlString ;
				}
			}
		}
		return parString ;
	}
	
}
