/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.dispatching.module.detail.impl;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;
import it.eng.spago.init.InitializerIFace;
import it.eng.spago.tracing.TracerSingleton;
import it.eng.spago.util.ContextScooping;

import java.util.List;

/**
 * @author scarciello
 *
 */
public class LookupConfigDetailModule extends DefaultConfigDetailModule {

	/**
	 * 
	 */
	private static final long serialVersionUID = -1719019459229277538L;
	
	public LookupConfigDetailModule() {
		super();
	} //public LookupConfigDetailModule
	
    public boolean select(SourceBean request, SourceBean response) {
    	InitializerIFace serviceInitializer = (InitializerIFace) this;
		SourceBean statement = (SourceBean) serviceInitializer.getConfig().getAttribute("QUERIES.SELECT_QUERY");
		if (statement == null) {
			TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG,
					"DefaultDetailModule::select: select_query non impostata nel modulo");
			return false;
		}
		
		/*
		Object rowObject = (new ConfigRowHandler()).getConfigRow(statement, getRequestContainer(), getResponseContainer());
		if (rowObject == null) {
			TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG,
					"DefaultDetailModule::select: nessuna riga selezionata");
			getErrorHandler().addError(new EMFUserError(EMFErrorSeverity.WARNING, 10006));
			return false;
		} // if (rowObject == null)
		if (!(rowObject instanceof SourceBean)) {
			TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG, "DefaultDetailModule::select: pi� righe selezionate");
			getErrorHandler().addError(new EMFUserError(EMFErrorSeverity.WARNING, 10006));
			return false;
		} // if (!(rowObject instanceof SourceBean))
		try {
			response.setAttribute((SourceBean) rowObject);
		} // try
		catch (Exception ex) {
			TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.CRITICAL,
					"DefaultDetailModule::select: response.setAttribute((SourceBean)rowObject)", ex);
		} // catch (Exception ex)
		*/
		return true;
    } // public boolean select(SourceBean request, SourceBean response)

	public void handleDetailNew(SourceBean request, SourceBean response) {
		// TODO Stub di metodo generato automaticamente
	}

    public boolean insert(SourceBean request, SourceBean response) {
    	boolean ret = false ;
    	try {
    		String lookupActionAlias = "";
    		List<SourceBean> parametri = (List<SourceBean>) getConfig().getAttributeAsList("QUERIES.INSERT_QUERY.PARAMETER");
    		if (parametri.size()>3) {
    			SourceBean parametro = parametri.get(3);
    			lookupActionAlias = (String) ContextScooping.getScopedParameter(this,parametro);
    			lookupActionAlias += ".";
    		}
    		SourceBean parametro = parametri.get(0);
    		String moduleName = (String) ContextScooping.getScopedParameter(this,parametro);
    		SourceBean module = (SourceBean)ConfigSingleton.getInstance().getFilteredSourceBeanAttribute("MODULES.MODULE","NAME",moduleName) ;
    		parametro = parametri.get(1);
    		String fieldName = (String) ContextScooping.getScopedParameter(this,parametro);
    		parametro = parametri.get(2);
    		String attributeName = (String) parametro.getAttribute("NAME");
    		String attributeValue = (String) ContextScooping.getScopedParameter(this,parametro);
    		for(SourceBean fieldset : (List<SourceBean>)module.getAttributeAsList("CONFIG.FIELDS.FIELDSET")) {
    			for(SourceBean field : (List<SourceBean>)fieldset.getAttributeAsList("FIELD")) {
    				String name = (String) field.getAttribute("NAME");
    				if(name.equalsIgnoreCase(fieldName)) {
    					ret = true;
    					field.updAttribute(attributeName,lookupActionAlias+attributeValue);
    				}
    			}
    		}
			try {
				SourceBean retBean = new SourceBean("RETURN_TO_LIST") ;
				retBean.setAttribute("RETURN_TO_LIST", "true") ;
				getServiceResponse().setAttribute(retBean) ; 
			} catch (SourceBeanException ex) {
				TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.CRITICAL, "DefaultConfigDetailModule::insert:", ex);
			} // catch (Exception ex)
		} catch (Exception ex) {
			TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.CRITICAL,
					"DefaultDetailModule::insert:", ex);
			getErrorHandler().addError(new EMFUserError(EMFErrorSeverity.ERROR, "Errore durante inserimento"));
		} 
        return ret;
    }
    
    public boolean update(SourceBean request, SourceBean response) {
    	boolean ret = false ;
    	try {
    		String lookupActionAlias = "";
    		List<SourceBean> parametri = (List<SourceBean>) getConfig().getAttributeAsList("QUERIES.INSERT_QUERY.PARAMETER");
    		if (parametri.size()>3) {
    			SourceBean parametro = parametri.get(3);
    			lookupActionAlias = (String) ContextScooping.getScopedParameter(this,parametro);
    			lookupActionAlias += ".";
    		}
    		SourceBean parametro = parametri.get(0);
    		String moduleName = (String) ContextScooping.getScopedParameter(this,parametro);
    		SourceBean module = (SourceBean)ConfigSingleton.getInstance().getFilteredSourceBeanAttribute("MODULES.MODULE","NAME",moduleName) ;
    		parametro = parametri.get(1);
    		String fieldName = (String) ContextScooping.getScopedParameter(this,parametro);
    		parametro = parametri.get(2);
    		String attributeName = (String) parametro.getAttribute("NAME");
    		String attributeValue = (String) ContextScooping.getScopedParameter(this,parametro);
    		for(SourceBean fieldset : (List<SourceBean>)module.getAttributeAsList("CONFIG.FIELDS.FIELDSET")) {
    			for(SourceBean field : (List<SourceBean>)fieldset.getAttributeAsList("FIELD")) {
    				String name = (String) field.getAttribute("NAME");
    				if(name.equalsIgnoreCase(fieldName)) {
    					ret = true;
    					field.updAttribute(attributeName,lookupActionAlias+attributeValue);
    				}
    			}
    		}
			try {
				SourceBean retBean = new SourceBean("RETURN_TO_LIST") ;
				retBean.setAttribute("RETURN_TO_LIST", "true") ;
				getServiceResponse().setAttribute(retBean) ; 
			} catch (SourceBeanException ex) {
				TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.CRITICAL, "DefaultConfigDetailModule::insert:", ex);
			} // catch (Exception ex)
		} catch (Exception ex) {
			TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.CRITICAL,
					"DefaultDetailModule::insert:", ex);
			getErrorHandler().addError(new EMFUserError(EMFErrorSeverity.ERROR, "Errore durante inserimento"));
		} 
        return ret;
    }
}
