/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.dispatching.module.list.config.impl;

import java.util.List;
import it.eng.spago.base.SourceBean;
import it.eng.spago.daogen.dispatching.module.detail.impl.DefaultConfigDetailModule;
import it.eng.spago.dispatching.service.detail.impl.DelegatedDetailService;
import it.eng.spago.util.QueryExecutor;

/**
 * @author scarciello
 *
 */
public class ConfigValidationModule extends DefaultConfigDetailModule {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7692724227371960796L;

	public void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception {
		String elencoFieldsValidation = (String) serviceRequest.getAttribute("ELENCOFIELDSVALIDATION");
		String elencoListValidation = "";
		String elencoFiltersValidation = "";
		String elencoListActionValidation = "";
		String elencoInsertValidation = "";
		String elencoUpdateValidation = "";
		// Preparara il campo ElencoFieldsValidation
		if (elencoFieldsValidation == null || elencoFieldsValidation == "") {
/*			
			serviceRequest.updAttribute("MESSAGE", DelegatedDetailService.DETAIL_NEW) ;
			serviceRequest.delAttribute("AF_BUTTON");
			serviceRequest.delAttribute("SUBMIT");
*/			
			getResponseContainer().getServiceResponse().delAttribute("RETURN_TO_LIST") ;
			elencoFieldsValidation="";
	    	String pool = (String)getConfig().getAttribute("pool") ;
	    	SourceBean fieldsQuery = (SourceBean)getConfig().getAttribute("QUERIES.FIELDS_QUERY") ;
	    	SourceBean selectedFieldsBean = (SourceBean)QueryExecutor.executeQuery(getRequestContainer(),getResponseContainer(), pool, fieldsQuery, "SELECT") ;
	    	for(SourceBean row : (List<SourceBean>) selectedFieldsBean.getAttributeAsList("ROW")) {
				String prefissoCampi = (String) row.getAttribute("PREFISSOCAMPI");
				if(prefissoCampi!=null && prefissoCampi.trim().length()>0)
					prefissoCampi=prefissoCampi.trim()+"_";
				else
					prefissoCampi="";
	    		String webName = (String) row.getAttribute("CAMPOWEB");
	    		webName=prefissoCampi+webName.trim();
	    		String campoNull = (String) row.getAttribute("CAMPONULL");
	    		String useInInsert = (String) row.getAttribute("USEININSERT");
	    		String useInUpdate = (String) row.getAttribute("USEINUPDATE");
	    		String mandatory = "FALSE";
	    		String lunghezzaCampo = "" + row.getAttribute("LUNGHEZZAOUTPUT");
	    		String validator = (String) row.getAttribute("VALIDATOR");
	    		if (validator!=null && !validator.trim().equals("")) 
	    			validator="type=\""+validator.trim()+"\"";
	    		else validator="";
	    		String validatorInsert = (String) row.getAttribute("VALIDATORINSERT");
	    		if (validatorInsert!=null && !validatorInsert.trim().equals("")) 
	    			validatorInsert="type=\""+validatorInsert.trim()+"\"";
	    		else validatorInsert="";
	    		String validatorUpdate = (String) row.getAttribute("VALIDATORUPDATE");
	    		if (validatorUpdate!=null && !validatorUpdate.trim().equals("")) 
	    			validatorUpdate="type=\""+validatorUpdate.trim()+"\"";
	    		else validatorUpdate="";
	    		String campoChiave = (String) row.getAttribute("CAMPOCHIAVE");
	    		
	    		if (campoChiave.equalsIgnoreCase("Y")) mandatory="TRUE";
	    		if (campoNull.equalsIgnoreCase("N")) mandatory="TRUE";
	
	    		if(useInInsert!=null && useInInsert.equalsIgnoreCase("N")) 
	    			mandatory="FALSE";
	    		if(useInUpdate!=null && useInUpdate.equalsIgnoreCase("N")) 
	    			mandatory="FALSE";
	    		elencoFieldsValidation+="<FIELD name=\""+webName.trim()+"\" maxlength=\""+lunghezzaCampo.trim()+"\" mandatory=\""+mandatory+"\" "+validator.trim()+"/>\n";
	    		elencoListValidation+="<FIELD name=\"FILTER_"+webName.trim()+"\" "+validator.trim()+"/>\n";
	    		elencoFiltersValidation+="<FIELD name=\"FILTER_"+webName.trim()+"\" "+validator.trim()+"/>\n";
	    		elencoListActionValidation+="<FIELD name=\""+webName.trim()+"\" "+validator.trim()+"/>\n";
	    		elencoListActionValidation+="<FIELD name=\"FILTER_"+webName.trim()+"\" "+validator.trim()+"/>\n";
	    		if (validatorInsert!=null && validatorInsert!="")  
		    		elencoInsertValidation+="<FIELD name=\""+webName.trim()+"\" maxlength=\""+lunghezzaCampo.trim()+"\" mandatory=\"FALSE\" "+validatorInsert.trim()+"/>\n";
	    		if (validatorUpdate!=null && validatorUpdate!="")  
		    		elencoUpdateValidation+="<FIELD name=\""+webName.trim()+"\" maxlength=\""+lunghezzaCampo.trim()+"\" mandatory=\"FALSE\" "+validatorUpdate.trim()+"/>\n";
	    	}
	    	serviceRequest.setAttribute("ElencoFieldsValidation", elencoFieldsValidation);
	    	serviceRequest.setAttribute("ElencoInsertValidation", elencoInsertValidation);
	    	serviceRequest.setAttribute("ElencoUpdateValidation", elencoUpdateValidation);
	    	serviceRequest.setAttribute("ElencoListValidation", elencoListValidation);
	    	serviceRequest.setAttribute("ElencoFiltersValidation", elencoFiltersValidation);
	    	serviceRequest.setAttribute("ElencoListActionValidation", elencoListActionValidation);
		}
		
		// AG: Update Name used for autosave
		//String moduleName = (String)serviceRequest.getAttribute("name") ;
		//if (moduleName != null && moduleName.length() > 3) {
		//	String validationName = moduleName + "Validation" ;
		//	serviceRequest.updAttribute("name", validationName) ;
		//}
		
		super.service(serviceRequest,serviceResponse) ;
		getResponseContainer().getServiceResponse().delAttribute("RETURN_TO_LIST") ;
	}
}
