/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.dispatching.module.list.config.impl;

import java.util.List;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.service.list.basic.impl.DelegatedBasicListService;

/**
 * @author scarciello
 *
 */
public class ConfigVerificaModule extends ConfigListModule {
    public void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception {
    	boolean servizioPresente = false;
    	String pageName = (String) serviceRequest.getAttribute("PAGE_NAME");
    	// Verifica se non  una pagina e quindi prova a trattarlo come action
    	if (pageName == null) 
    		pageName = (String) serviceRequest.getAttribute("NAME");
		//serviceRequest.updAttribute("MESSAGE", DelegatedBasicListService.LIST_FIRST) ;
    	super.service(serviceRequest,serviceResponse) ;
    	SourceBean rows = (SourceBean) serviceResponse.getAttribute("PAGED_LIST.ROWS");
    	for(SourceBean row : (List<SourceBean>)rows.getAttributeAsList("SERVICE")) {
    		String name = (String) row.getAttribute("NAME");
    		if (name.equalsIgnoreCase(pageName))
    			servizioPresente = true;
    	}
    	if (!servizioPresente) {
    		getResponseContainer().getServiceResponse().setAttribute("IS_SERVICE_PRESENT","FALSE");
    	}
    	else {
    		getResponseContainer().getServiceResponse().setAttribute("IS_SERVICE_PRESENT","TRUE");
    	}
    }
}
