/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.dispatching.module.list.config.impl;

import java.util.List;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.lookup.LookupIFace;
import it.eng.spago.dispatching.module.list.basic.AbstractBasicListModule;
import it.eng.spago.dispatching.module.list.config.impl.DefaultConfigListModule;
import it.eng.spago.dispatching.service.RequestContextIFace;
import it.eng.spago.dispatching.service.list.basic.IFaceBasicListService;
import it.eng.spago.error.EMFErrorHandler;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;
import it.eng.spago.init.InitializerIFace;
import it.eng.spago.paginator.basic.ListIFace;
import it.eng.spago.paginator.basic.PaginatorIFace;
import it.eng.spago.paginator.basic.impl.GenericList;
import it.eng.spago.paginator.basic.impl.GenericPaginator;
import it.eng.spago.util.ConfigRowHandler;

/**
 * @author scarciello
 *
 */
public class LookupConfigListModule extends DefaultConfigListModule  {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7327486592548457539L;
	
	public ListIFace getList(SourceBean request, SourceBean response) throws Exception {
		PaginatorIFace paginator = new GenericPaginator();
		InitializerIFace serviceInitializer = (InitializerIFace) this;
		int pagedRows = Integer.parseInt((String) serviceInitializer.getConfig().getAttribute("ROWS"));
		paginator.setPageSize(pagedRows);
		SourceBean statement = (SourceBean) serviceInitializer.getConfig().getAttribute("QUERIES.SELECT_QUERY");
		RequestContextIFace serviceRequestContext = (RequestContextIFace) this;
		List rowsVector = (new ConfigRowHandler()).getConfigList(statement, getRequestContainer(), getResponseContainer());;
		if ((rowsVector == null) || (rowsVector.size() == 0)) {
			EMFErrorHandler engErrorHandler = serviceRequestContext.getErrorHandler();
			engErrorHandler.addError(new EMFUserError(EMFErrorSeverity.INFORMATION, "10001"));
		}
		else {
			String lookupField = (String) statement.getAttribute("LOOKUPFIELD");
			for (int i = 0; i < rowsVector.size(); i++) {
				for(SourceBean field : (List<SourceBean>)((SourceBean)rowsVector.get(i)).getAttributeAsList("FIELD")) {
					String lookupValue = (String)field.getAttribute(lookupField);
					if ((lookupValue != null) && (lookupValue != "")) 
						paginator.addRow(field);
				}
			}
		}
		ListIFace list = new GenericList();
		list.setPaginator(paginator);
		return list;
	}
	
}
