/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.filler;

import it.eng.spago.base.Constants;
import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.tracing.TracerSingleton;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;

import javax.servlet.ServletException;

/**
 * @author Cattiv
 *
 */
public class DetailFiller extends AbstractFiller {

	private static final String TPL_WIDGET_PAGENAME = "<?PAGE_NAME?>";
	private static final String TPL_WIDGET_NAME = "<?Name?>";
	private static final String TPL_WIDGET_SIZE = "<?FieldSize?>";
	private static final String TPL_WIDGET_LABEL = "<?FieldLabel?>";
	private static final String TPL_WIDGET_DECORATOR = "<?FieldDecorator?>";
	private static final String TPL_WIDGET_TEMPLATE = "<?template?>";
	private static final String TPL_WIDGET_ONKEYPRESS = "<?FieldOnKeyPress?>";
	private static final String TPL_WIDGET_ONKEYUP = "<?FieldOnKeyUp?>";
	private static final String TPL_WIDGET_MAXLENGTH = "<?FieldMaxLength?>";
	private static final String TPL_WIDGET_INSERT_SELECTMODULE = "<?FieldInsertSelectModule?>";
	private static final String TPL_WIDGET_UPDATE_SELECTMODULE = "<?FieldUpdateSelectModule?>";
	private static final String TPL_WIDGET_LOOKUPACTION = "<?FieldLookupAction?>";
	private static final String TPL_WIDGET_INSERT_TEXTAREAROWS = "<?TextAreaInsertRows?>";
	private static final String TPL_WIDGET_UPDATE_TEXTAREAROWS = "<?TextAreaUpdateRows?>";
	private static final String TPL_WIDGET_INSERT_TEXTAREACOLS = "<?TextAreaInsertCols?>";
	private static final String TPL_WIDGET_UPDATE_TEXTAREACOLS = "<?TextAreaUpdateCols?>";
	private static final String TPL_WIDGET_INSERT_READONLY = "<?FieldInsertReadOnly?>";
	private static final String TPL_WIDGET_UPDATE_READONLY = "<?FieldUpdateReadOnly?>";
	private static final String TPL_WIDGET_INSERT_MANDATORY = "<?FieldInsertMandatory?>";
	private static final String TPL_WIDGET_UPDATE_MANDATORY = "<?FieldUpdateMandatory?>";
	private static final String TPL_WIDGET_INSERT_VISIBLE = "<?FieldInsertVisible?>";
	private static final String TPL_WIDGET_UPDATE_VISIBLE = "<?FieldUpdateVisible?>";
	private static final String TPL_WIDGET_LOOKUPALIASNAME = "<?LookupAliasName?>";
	private static final String TPL_WIDGET_ID = "<?ID?>";

	public DetailFiller(HashMap startMap, RequestContainer requestContainer, ResponseContainer responseContainer) {
		super(startMap, requestContainer, responseContainer);
		// TODO Stub di costruttore generato automaticamente
	}

	/**
	 * 
	 */
	private static final long serialVersionUID = -4595212298745199711L;

	/* (non Javadoc)
	 * @see it.eng.spago.daogen.filler.AbstractFiller#service(java.lang.String, it.eng.spago.base.SourceBean)
	 */
	@Override
	public StringBuffer service(String templateName, SourceBean step)
			throws ServletException, IOException {
		String fileFisico = (String) _serviceRequest.getAttribute("FILEFISICO");
		StringBuffer moduleTemplate = readTemplateFile(templateName);
		SourceBean fileAmbiente = getRowsAtIndex(0);
		SourceBean rigaFile = (SourceBean) fileAmbiente.getAttribute("ROW");
		SourceBean elencoCampi = (SourceBean) rigaFile.getAttribute("ROWS");
		String descrizioneFile = (String) rigaFile.getAttribute("DESCRIZIONEFILE"); 
		if(descrizioneFile==null || descrizioneFile.length()==0)
			descrizioneFile=fileFisico;
		String packageFile = (String)rigaFile.getAttribute("PACKAGEFILE");

		String prefissoCampi = ((String)rigaFile.getAttribute("PREFISSOCAMPI")).trim();
		if(prefissoCampi!=null && prefissoCampi.trim().length()>0)
			prefissoCampi=prefissoCampi.trim()+"_";
		else
			prefissoCampi="";
		
		String parametriInsert = "";
		String parametriUpdate = "";
		String parametriSelect = "";
		String elencoFields = "";
		
		String poolName = (String) _serviceRequest.getAttribute("POOLCONNESSIONE");

		int idCode = 0;
		for(SourceBean field : (List<SourceBean>)elencoCampi.getAttributeAsList("ROW")) {
			String webName = prefissoCampi+((String) field.getAttribute("CAMPOWEB")).trim();
			String useInsert = (String) field.getAttribute("USEININSERT");
			String useUpdate = (String) field.getAttribute("USEINUPDATE");
			String chiave = ((String) field.getAttribute("CAMPOCHIAVE")).trim();
    		String widgetCampo = ((String) field.getAttribute("WIDGETCAMPO")).trim();
			String fieldVisible = (String) field.getAttribute("FIELDVISIBLE");
    		String descrizioneCampo = (String) field.getAttribute("DESCRIZIONECAMPO");
    		String decoratorType = (String) field.getAttribute("DECORATORTYPE");
    		String validator =((String)field.getAttribute("VALIDATOR")).trim().toUpperCase() ;
    		String typedService = "";
    		if ((validator != null) && (validator!="")) 
    				typedService="TYPED_SERVICE_REQUEST.";
    		String readOnlyForUpdate = "FALSE";

    		if(useInsert==null || useInsert.equalsIgnoreCase(" ") || useInsert.equalsIgnoreCase("Y")) {
				parametriInsert+="<PARAMETER type=\"RELATIVE\" scope=\"SERVICE_REQUEST\" value=\""+typedService+webName+"\" />\n";
			}
			if((useUpdate==null || useUpdate.equalsIgnoreCase(" ") || useUpdate.equalsIgnoreCase("Y")) && (chiave!=null && chiave.equalsIgnoreCase("N"))) {
				parametriUpdate+="<PARAMETER type=\"RELATIVE\" scope=\"SERVICE_REQUEST\" value=\""+typedService+webName+"\" />\n";
			}
			if(chiave==null || chiave.equalsIgnoreCase("Y")) {
				parametriSelect+="<PARAMETER type=\"RELATIVE\" scope=\"SERVICE_REQUEST\" value=\""+typedService+webName+"\" />\n";
				readOnlyForUpdate="TRUE";
			}
			
			String visibleInsert = "TRUE";
			String visibleUpdate = "TRUE"; 
			if(fieldVisible!=null && fieldVisible.equalsIgnoreCase("N")) {
				visibleInsert = "FALSE";
				visibleUpdate = "FALSE";
			}
			if(useInsert!=null && useInsert.equalsIgnoreCase("N"))
				visibleInsert="FALSE";
			if(useInsert!=null && useUpdate.equalsIgnoreCase("N"))
				visibleUpdate="FALSE";

			SourceBean templateList = getRowsAtIndex(2);
			
    		for(SourceBean tplWidget : (List<SourceBean>) templateList.getAttributeAsList("ROW")) {
    			String codTemplate = ((String) tplWidget.getAttribute("CODTEMPLATE")).trim() ;
				String refTemplate = (String) tplWidget.getAttribute("REFTEMPLATE") ;
				StringBuffer widgetTemplate = readTemplateFile(refTemplate) ;
    			if (codTemplate.equalsIgnoreCase(widgetCampo.trim())) {
    	    		Object lunghezzaCampo = (Object) field.getAttribute("LUNGHEZZAOUTPUT");
    				if (widgetTemplate!=null) {
    					++idCode;
    					replaceToken(widgetTemplate,TPL_WIDGET_NAME,webName.trim());
    					replaceToken(widgetTemplate,TPL_WIDGET_SIZE,lunghezzaCampo.toString());
    					replaceToken(widgetTemplate,TPL_WIDGET_LABEL,descrizioneCampo.trim());
    					replaceToken(widgetTemplate,TPL_WIDGET_DECORATOR,decoratorType.trim());
    					replaceToken(widgetTemplate,TPL_WIDGET_TEMPLATE,widgetCampo.trim());
    					replaceToken(widgetTemplate,TPL_WIDGET_ONKEYPRESS,"");
    					replaceToken(widgetTemplate,TPL_WIDGET_ONKEYUP,"");
    					replaceToken(widgetTemplate,TPL_WIDGET_MAXLENGTH,lunghezzaCampo.toString());
    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_SELECTMODULE,"");
    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_SELECTMODULE,"");
    					replaceToken(widgetTemplate,TPL_WIDGET_LOOKUPACTION,"");
    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_TEXTAREAROWS,"5");
    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_TEXTAREAROWS,"5");
    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_TEXTAREACOLS,"80");
    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_TEXTAREACOLS,"80");
    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_READONLY,"FALSE");
    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_READONLY,readOnlyForUpdate);
    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_MANDATORY,"");
    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_MANDATORY,"");
    					replaceToken(widgetTemplate,TPL_WIDGET_INSERT_VISIBLE,visibleInsert);
    					replaceToken(widgetTemplate,TPL_WIDGET_UPDATE_VISIBLE,visibleUpdate);
    					replaceToken(widgetTemplate,TPL_WIDGET_LOOKUPALIASNAME,"");
    					replaceToken(widgetTemplate,TPL_WIDGET_ID,""+idCode);
    		    		elencoFields+=widgetTemplate.toString();
    				}
    			}
    		}
		}
		// Sezione di preparazione dei campi di decodifica
		SourceBean campiDecodifica = getRowsAtIndex(3);
		for(SourceBean campo : (List<SourceBean>)campiDecodifica.getAttributeAsList("ROW")) {
			String campoWeb = prefissoCampi+campo.getAttribute("NOMECAMPOWEB");
    		String nomeRelazione = (String) campo.getAttribute("NOMERELAZIONE");
    		String lunghezzaMax = "" + campo.getAttribute("LUNGHEZZACAMPO");
    		String lunghezzaExt = "" + campo.getAttribute("EXTERNALLENGTH");
    		elencoFields+="<FIELD name=\""+nomeRelazione.trim()+"_"+campoWeb.trim()+"\" widget=\"TEXT\" SIZE=\""+lunghezzaExt.trim()+"\" MAXLENGTH=\""+lunghezzaMax.trim()+"\" template=\"Text\">\n";
    		elencoFields+="  <INSERT is_readonly=\"TRUE\" is_visible=\"TRUE\" />\n";
    		elencoFields+="  <UPDATE is_readonly=\"TRUE\" is_visible=\"TRUE\" />\n";
    		elencoFields+="</FIELD>\n";
		}
		
		// Sezione di estrazione dei campi di decodifica delle SubRelazioni
		SourceBean mainRelations = getRowsAtIndex(4);
		for(SourceBean singleRelation : (List<SourceBean>)mainRelations.getAttributeAsList("ROW")) {
			for(SourceBean subRelation : (List<SourceBean>)singleRelation.getAttributeAsList("ROWS.ROW")) {
				for(SourceBean subDecodingField : (List<SourceBean>)subRelation.getAttributeAsList("ROWS.ROW")) {
					//String fieldName = (String) subDecodingField.getAttribute("NOMECAMPO");
					String fieldWebName = (String) subDecodingField.getAttribute("NOMECAMPOWEB");
					String relationName = (String) subDecodingField.getAttribute("NOMERELAZIONE");
					relationName="T"+relationName;
		    		elencoFields+="<FIELD name=\""+relationName.trim()+"_"+fieldWebName.trim()+"\" widget=\"TEXT\" template=\"Text\">\n";
		    		elencoFields+="  <INSERT is_readonly=\"TRUE\" is_visible=\"TRUE\" />\n";
		    		elencoFields+="  <UPDATE is_readonly=\"TRUE\" is_visible=\"TRUE\" />\n";
		    		elencoFields+="</FIELD>\n";
				}
			}
		}
		_variablesMap.put("poolDetailName",poolName);
		_variablesMap.put("templateDetailName", templateName);
		_variablesMap.put("descrizioneDetailFile", descrizioneFile);
		_variablesMap.put("packageDetailFile", packageFile.trim());
		_variablesMap.put("detailSelect", parametriSelect);
		_variablesMap.put("parametriInsert", parametriInsert);
		_variablesMap.put("parametriUpdate", parametriUpdate+parametriSelect);
		_variablesMap.put("elencoFields", elencoFields);

		for(SourceBean parametro : (List<SourceBean>) step.getAttributeAsList("PARAMETER")) {
			String tplParName = (String) parametro.getAttribute("TPLPARNAME");
			String value = (String) parametro.getAttribute("VALUE");
			
			value = replaceMatches(value);
			replaceToken(moduleTemplate,"<"+tplParName+">",value);
		}

		// Inserimento formattatore
		try {
			SourceBean xmlFmt = SourceBean.fromXMLString(moduleTemplate.toString());
			moduleTemplate = new StringBuffer(xmlFmt.toXML());
		} catch (SourceBeanException e) {
			TracerSingleton.log(Constants.NOME_MODULO,TracerSingleton.CRITICAL,"DetailFiller::service::Error",e);
			//e.printStackTrace();
		}

		moduleTemplate.insert(0,"<textarea name=\"detail\" cols=92 rows=15 wrap=\"off\">\n");
		moduleTemplate.append("</textarea><br>\n");
		String fileName=(String)ConfigSingleton.getInstance().getAttribute("DAOGEN.pathXMLFile");
		String relativePath=(String)_serviceRequest.getAttribute("XMLPATH");
		if(relativePath!=null && relativePath.length()>0  && !relativePath.equals("xmlPath")) 
			fileName+=File.separatorChar+relativePath;
		fileName+=File.separatorChar+"mod"+fileFisico+"Detail.xml";
		moduleTemplate.insert(0,"<input type=\"text\" name=\"detailmodulefilename\" size=\"115\" value=\""+fileName+"\"><br>");
		return moduleTemplate;
	}

}
