/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.filler;

import it.eng.spago.base.Constants;
import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.tracing.TracerSingleton;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;

import javax.servlet.ServletException;

/**
 * @author Cattiv
 *
 */
public class ListFiller extends AbstractFiller {

	public ListFiller(HashMap startMap, RequestContainer requestContainer, ResponseContainer responseContainer) {
		super(startMap, requestContainer, responseContainer);
		// TODO Stub di costruttore generato automaticamente
	}

	/**
	 * 
	 */
	private static final long serialVersionUID = -8069935121390284546L;

	/* (non Javadoc)
	 * @see it.eng.spago.daogen.filler.AbstractFiller#service(java.lang.String, it.eng.spago.base.SourceBean)
	 */
	@Override
	public StringBuffer service(String templateName, SourceBean step)
			throws ServletException, IOException {
		String fileFisico = (String) _serviceRequest.getAttribute("FILEFISICO");
		StringBuffer moduleTemplate = readTemplateFile(templateName);
		SourceBean fileAmbiente = getRowsAtIndex(0);
		SourceBean rigaFile = (SourceBean) fileAmbiente.getAttribute("ROW");
		SourceBean elencoCampi = (SourceBean) rigaFile.getAttribute("ROWS");
		String descrizioneFile = (String) rigaFile.getAttribute("DESCRIZIONEFILE"); 
		if(descrizioneFile==null || descrizioneFile.length()==0)
			descrizioneFile=fileFisico;
		boolean orderByAddedField = false;
		
		String prefissoCampi = ((String)rigaFile.getAttribute("PREFISSOCAMPI")).trim();
		if(prefissoCampi!=null && prefissoCampi.trim().length()>0)
			prefissoCampi=prefissoCampi.trim()+"_";
		else
			prefissoCampi="";
		
		String sortAction = "";
		String orderBy = "<ORDER_BY sql=\"";
		String colonne = "";
		String selectCaption = "";
		String deleteCaption = "";
		String deleteParameters = "";
		String filterParameters = "";
		
		selectCaption = "<PARAMETER name=\"PAGE\" type=\"ABSOLUTE\" value=\"Pag"+fileFisico+"\" scope=\"\" />\n";
		//selectCaption += "<PARAMETER name=\"MODULE\" type=\"ABSOLUTE\" value=\"Mod"+fileFisico+"Detail\" scope=\"\" />\n";
		deleteCaption = "<PARAMETER name=\"PAGE\" type=\"ABSOLUTE\" value=\"Pag"+fileFisico+"\" scope=\"\" />\n";

		
		String poolName = (String) _serviceRequest.getAttribute("POOLCONNESSIONE");
		String packageFile = (String)rigaFile.getAttribute("PACKAGEFILE");
		for(SourceBean field : (List<SourceBean>)elencoCampi.getAttributeAsList("ROW")) {
			String webName = prefissoCampi+((String) field.getAttribute("CAMPOWEB")).trim();
			String nomeCampo = (String) field.getAttribute("NOMECAMPO");
			String chiave = (String) field.getAttribute("CAMPOCHIAVE");
			String decoratorType = ((String) field.getAttribute("DECORATORTYPE")).trim();
			String visible = (String) field.getAttribute("FIELDVISIBLE");
			String validator =((String)field.getAttribute("VALIDATOR")).trim().toUpperCase() ;
			
			if(chiave!=null && chiave.equalsIgnoreCase("Y")) {
				orderBy+=webName+",";
				orderByAddedField=true;
				selectCaption+="<PARAMETER name=\""+webName+"\" scope=\"LOCAL\" type=\"RELATIVE\" value=\""+webName+"\" />";
				deleteCaption+="<PARAMETER name=\""+webName+"\" scope=\"LOCAL\" type=\"RELATIVE\" value=\""+webName+"\" />";
				deleteParameters+="<PARAMETER scope=\"SERVICE_REQUEST\" type=\"RELATIVE\" value=\""+webName+"\" />";;
			}
			if(visible==null || visible.equalsIgnoreCase("Y") || visible.length()==0) {
				sortAction+="<SORT_ACTION name=\"sortBy"+webName+"\" sql=\""+webName+"\" />\n";
    			colonne+="<COLUMN name=\""+webName+"\" type=\"FIELD\" sortaction=\"sortBy"+webName+"\" decorator=\""+decoratorType+"\"/>\n";    			
				filterParameters+="<FILTER_PARAMETER type=\"RELATIVE\" scope=\"SERVICE_REQUEST\" ";
				if(validator==null || validator.length()==0)
					filterParameters += "value=\"FILTER_"+webName.trim()+"\" uppercase=\"true\" sql=\"UPPER(T1."+nomeCampo.trim()+") like ?\"" ;
				else if (validator.equals("GENERIC"))
					filterParameters += "value=\"TYPED_SERVICE_REQUEST.FILTER_"+webName.trim()+"\" uppercase=\"true\" sql=\"UPPER(T1."+nomeCampo.trim()+") like ?\"" ;  
				else filterParameters += "value=\"TYPED_SERVICE_REQUEST.FILTER_"+webName.trim()+"\"  sql=\"T1."+nomeCampo.trim()+" = ?\"" ;
				filterParameters += " />\n";
			}
		}
		if(orderByAddedField) 
			orderBy=orderBy.substring(0, orderBy.length()-1);
		orderBy+="\" />\n";

		// Sezione di preparazione dei campi di decodifica
		SourceBean campiDecodifica = getRowsAtIndex(3);
		for(SourceBean campo : (List<SourceBean>)campiDecodifica.getAttributeAsList("ROW")) {
			String nomeCampo = (String)campo.getAttribute("NOMECAMPO");
			String campoWeb = prefissoCampi+campo.getAttribute("NOMECAMPOWEB");
    		String nomeRelazione = (String) campo.getAttribute("NOMERELAZIONE");
    		colonne+="<COLUMN name=\""+nomeRelazione.trim()+"_"+campoWeb.trim()+"\" type=\"FIELD\" sortaction=\"sortBy"+nomeRelazione.trim()+"_"+campoWeb.trim()+"\"/>\n";
    		sortAction+="<SORT_ACTION name=\"sortBy"+nomeRelazione.trim()+"_"+campoWeb.trim()+"\" sql=\""+nomeRelazione.trim()+"_"+campoWeb.trim()+"\" />\n";
    		filterParameters+="<FILTER_PARAMETER type=\"RELATIVE\" scope=\"SERVICE_REQUEST\" uppercase=\"true\" value=\"FILTER_"+nomeRelazione.trim()+"_"+campoWeb.trim()+"\" sql=\"UPPER(T"+nomeRelazione.trim()+"."+nomeCampo.trim()+") LIKE ?\"/>\n";
		}
		
		// Sezione di estrazione dei campi di decodifica delle SubRelazioni
		SourceBean mainRelations = getRowsAtIndex(4);
		for(SourceBean singleRelation : (List<SourceBean>)mainRelations.getAttributeAsList("ROW")) {
			for(SourceBean subRelation : (List<SourceBean>)singleRelation.getAttributeAsList("ROWS.ROW")) {
				for(SourceBean subDecodingField : (List<SourceBean>)subRelation.getAttributeAsList("ROWS.ROW")) {
					String fieldName = (String) subDecodingField.getAttribute("NOMECAMPO");
					String fieldWebName = (String) subDecodingField.getAttribute("NOMECAMPOWEB");
					String relationName = (String) subDecodingField.getAttribute("NOMERELAZIONE");
					relationName="T"+relationName;
		    		colonne+="<COLUMN name=\""+relationName.trim()+"_"+fieldWebName.trim()+"\" type=\"FIELD\" sortaction=\"sortBy"+relationName.trim()+"_"+fieldWebName.trim()+"\"/>\n";
		    		sortAction+="<SORT_ACTION name=\"sortBy"+relationName.trim()+"_"+fieldWebName.trim()+"\" sql=\""+relationName.trim()+"_"+fieldWebName.trim()+"\" />\n";
		    		filterParameters+="<FILTER_PARAMETER type=\"RELATIVE\" scope=\"SERVICE_REQUEST\" uppercase=\"true\" value=\"FILTER_"+relationName.trim()+"_"+fieldWebName.trim()+"\" sql=\"UPPER(T"+relationName.trim()+"."+fieldName.trim()+") LIKE ?\"/>\n";
				}
			}
		}

		_variablesMap.put("poolListName",poolName);
		_variablesMap.put("templateListName", templateName);
		_variablesMap.put("descrizioneListFile", descrizioneFile);
		_variablesMap.put("packageListFile", packageFile.trim());
		_variablesMap.put("sortAction",sortAction);
		_variablesMap.put("orderBy",orderBy);
		_variablesMap.put("columns",colonne);
		_variablesMap.put("selectCaption",selectCaption);
		_variablesMap.put("deleteCaption",deleteCaption);
		_variablesMap.put("deleteParameters",deleteParameters);
		_variablesMap.put("filterParameters", filterParameters);
		
		for(SourceBean parametro : (List<SourceBean>) step.getAttributeAsList("PARAMETER")) {
			String tplParName = (String) parametro.getAttribute("TPLPARNAME");
			String value = (String) parametro.getAttribute("VALUE");
			
			value = replaceMatches(value);
			replaceToken(moduleTemplate,"<"+tplParName+">",value);
		}

		// Inserimento formattatore
		try {
			SourceBean xmlFmt = SourceBean.fromXMLString(moduleTemplate.toString());
			moduleTemplate = new StringBuffer(xmlFmt.toXML());
		} catch (SourceBeanException e) {
			TracerSingleton.log(Constants.NOME_MODULO,TracerSingleton.CRITICAL,"ListFiller::service::Error",e);
			//e.printStackTrace();
		}
		
		moduleTemplate.insert(0,"<textarea name=\"list\" cols=92 rows=15 wrap=\"off\">\n");
		moduleTemplate.append("</textarea><br>\n");
		String fileName=(String)ConfigSingleton.getInstance().getAttribute("DAOGEN.pathXMLFile");
		String relativePath=(String)_serviceRequest.getAttribute("XMLPATH");
		if(relativePath!=null && relativePath.length()>0  && !relativePath.equals("xmlPath")) 
			fileName+=File.separatorChar+relativePath;
		fileName+=File.separatorChar+"mod"+fileFisico+"List.xml";
		moduleTemplate.insert(0,"<input type=\"text\" name=\"listmodulefilename\" size=\"115\" value=\""+fileName+"\"><br>");
		
		return moduleTemplate;
	}

}
