/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.filler;

import it.eng.spago.base.Constants;
import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.tracing.TracerSingleton;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;

import javax.servlet.ServletException;

/**
 * @author scarciello
 *
 */
public class MasterFiller extends AbstractFiller {

	public MasterFiller(HashMap startMap, RequestContainer requestContainer, ResponseContainer responseContainer) {
		super(startMap, requestContainer, responseContainer);
		// TODO Stub di costruttore generato automaticamente
	}

	/**
	 * 
	 */
	private static final long serialVersionUID = 3233809481333827563L;

	
	/* (non Javadoc)
	 * @see it.eng.spago.daogen.filler.AbstractFiller#service(java.lang.String, it.eng.spago.base.SourceBean)
	 */
	@Override
	public StringBuffer service(String templateName, SourceBean step)
			throws ServletException, IOException {
		String fileFisico = (String) _serviceRequest.getAttribute("FILEFISICO");
		String configuratorParams = "";
		StringBuffer masterTemplate = readTemplateFile(templateName);
		String pathXML = (String)ConfigSingleton.getInstance().getAttribute("DAOGEN.pathForMasterConfigurationFiles");
		String relativePath=(String)_serviceRequest.getAttribute("XMLPATH");
		if(relativePath!=null && relativePath.length()>0  && !relativePath.equals("xmlPath")) 
			pathXML+=File.separatorChar+relativePath;
		for(SourceBean parametro : (List<SourceBean>) step.getAttributeAsList("PARAMETER")) {
			String fileName = (String) parametro.getAttribute("FILENAME");
			if(fileName!=null) {
				fileName=pathXML+File.separatorChar+fileName.replace("?fileFisico?", fileFisico);
				configuratorParams +="<CONFIGURATOR path=\""+fileName+"\" />\n";
			}
		}
		
		_variablesMap.put("configuratorParams",configuratorParams);

		for(SourceBean parametro : (List<SourceBean>) step.getAttributeAsList("PARAMETER")) {
			String tplParName = (String) parametro.getAttribute("TPLPARNAME");
			String value = (String) parametro.getAttribute("VALUE");
			
			if(tplParName!=null) {
				value = replaceMatches(value);
				replaceToken(masterTemplate,"<"+tplParName+">",value);
			}
		}

		// Inserimento formattatore
		try {
			SourceBean xmlFmt = SourceBean.fromXMLString(masterTemplate.toString());
			masterTemplate = new StringBuffer(xmlFmt.toXML());
		} catch (SourceBeanException e) {
			TracerSingleton.log(Constants.NOME_MODULO,TracerSingleton.CRITICAL,"MasterFiller::service::Error",e);
			//e.printStackTrace();
		}

		masterTemplate.insert(0,"<textarea name=\"master\" cols=92 rows=15 wrap=\"off\">\n");
		masterTemplate.append("</textarea><br>\n");
		String fileName=(String)ConfigSingleton.getInstance().getAttribute("DAOGEN.pathXMLFile");
		if(relativePath!=null && relativePath.length()>0  && !relativePath.equals("xmlPath")) 
			fileName+=File.separatorChar+relativePath;
		fileName+=File.separatorChar+"master_"+fileFisico+".xml";
		masterTemplate.insert(0,"<input type=\"text\" name=\"masterfilename\" size=\"115\" value=\""+fileName+"\"><br>");
		return masterTemplate;
	}

}
