/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.servlet;

import it.eng.spago.publishers.AbstractServletPublisher;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;

/**
 * @author grassi
 *
 */
public abstract class AbstractServletFileCreate extends AbstractServletPublisher {

	/**
	 * Write a File
	 * @param httpRequest
	 * @param out
	 * @param sourceParName
	 * @param filenameParName
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void saveFile(HttpServletRequest httpRequest, PrintWriter out, String sourceParName, String filenameParName) throws ServletException {
		String source = "" +httpRequest.getParameter(sourceParName) ;
		String fileName = "" +httpRequest.getParameter(filenameParName) ;
		if (fileName != null && source != null) {
			try {
				makeDir(fileName) ;
				writeFile(fileName, source) ;
				out.println("<html><body><h2>"+fileName+"</h2><h1>written successfully</h1>") ;
		    } catch (IOException e) {
				out.println("<html><body><h1>Error in writing  file </h1>\n<h2>"+fileName+"</h2>\n") ;
				e.printStackTrace(out) ;
		    }
			out.println("<input type=\"button\" name=\"Close\" value=\"Close\" onClick=\"window.close()\" />") ;
			out.println("</body>\n</html>") ;
			out.flush();
		}
	}
	
	/**
	 * Make require directory
	 * @param fileName
	 * @throws IOException
	 */
	protected void makeDir(String fileName) throws IOException {
		File file = new File(fileName) ;
		// String dirName = file.getAbsolutePath().substring(0, fileName.lastIndexOf(File.separator)) ;
		String dirName = file.getParent() ;
		if (dirName != null)
			new File(dirName).mkdirs() ; 
	}
	
	/**
	 * Write a String into specify fullpath filename
	 * @param fileName
	 * @param source
	 * @throws IOException
	 */
	protected void writeFile(String fileName, String source) throws IOException {
        BufferedWriter outFile = new BufferedWriter(new FileWriter(fileName));
        outFile.write(source);
        outFile.close();
	}
}