/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.servlet;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.tracing.TracerSingleton;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author grassi
 *
 */
public class ServletCreateJavaSource extends AbstractServletFileCreate {
	private static final long serialVersionUID = 1L;
	public final static String JAVA_TYPE_FILE = "File" ;
	public final static String JAVA_TYPE_AMBIENTE = "Ambiente" ;
	public final static String TPLKEY_PACKAGE = "<?Package?>" ;
	public final static String TPLKEY_PACKAGE_ENV = "<?PackageAmbiente?>" ;
	public final static String TPLKEY_FILENAME = "<?NomeFile?>";
	public final static String TPLKEY_NOME_AMBIENTE = "<?NomeAmbiente?>" ;
	public final static String TPLKEY_AUDIT_INSERT_PARAMETER = "<?AuditInsertParameter?>" ;
	public final static String TPLKEY_AUDIT_UPDATE_PARAMETER = "<?AuditUpdateParameter?>" ;
	public final static String TPLKEY_AUDIT_DELETE_PARAMETER = "<?AuditDeleteParameter?>" ;
	public final static String TPLKEY_INSERT_PARAMETERS = "<?ParametriInsert?>" ;
	public final static String TPLKEY_UPDATE_PARAMETERS = "<?ParametriUpdate?>" ;
	public final static String TPLKEY_DELETE_PARAMETERS = "<?ParametriDelete?>" ;
	public final static String TPLKEY_DETAIL_PARAMETERS = "<?ParametriDetail?>" ;
	public final static String TPLKEY_CANCELLED_PARAMETERS = "<?ParametriCancelled?>" ;
	private String _nomeAmbiente = null ;
	private String _packageAmbiente = null ;
	private String _packageAmbienteSuFile = null ;
	private String _nomeTemplate = null ;
	private String _nomeFile = null;
	private String _prefissoCampi = null;
	private String _templatePath = (String)ConfigSingleton.getInstance().getAttribute("DAOGEN.pathTemplate") ;
	private List<SourceBean> _campiTabella = null;
	private List<SourceBean> _campiLog = null;

	/**
	 * Local initialization
	 */
	protected void init(HttpServletRequest httpRequest) throws ServletException {
		
		super.init(httpRequest);
		_nomeAmbiente = (String)getServiceRequest(httpRequest).getAttribute("NOME") ;
		_packageAmbiente = (String)getServiceRequest(httpRequest).getAttribute("PCKG") ;
		_packageAmbienteSuFile = (String)getServiceRequest(httpRequest).getAttribute("PKGA") ;
		_nomeFile = (String)getServiceRequest(httpRequest).getAttribute("FILE") ;
		_prefissoCampi = (String)getServiceRequest(httpRequest).getAttribute("PFLD") ;
		if(_prefissoCampi!=null && _prefissoCampi.trim().length()>0)
			_prefissoCampi=_prefissoCampi.trim()+"_";
		else 
			_prefissoCampi="";
		
		String sourceType = (String)_config.getAttribute("java_type", JAVA_TYPE_FILE) ;
		if (sourceType.equalsIgnoreCase(JAVA_TYPE_AMBIENTE)) {
			_nomeTemplate = (String)getRowsAtIndex(0).getAttribute("ROW.REFTEMPLATE") ;
			_campiLog = getRowsAtIndex(1).getAttributeAsList("ROW");
		} else if (sourceType.equalsIgnoreCase(JAVA_TYPE_FILE)) {
			// TODO: Prevedere template differenti per i files
//			_nomeTemplate = "FileDao";
			_nomeTemplate = (String)getRowsAtIndex(0).getAttribute("ROW.REFTEMPLATE") ;			
			_campiTabella = getRowsAtIndex(1).getAttributeAsList("ROW"); 
		}
	}
	
	protected SourceBean getRowsAtIndex(int index) {
		return ((SourceBean)_content.getAttributeAsList("ROWS").get(index)) ;
	}

	protected void service(HttpServletRequest httpRequest, HttpServletResponse httpResponse) throws ServletException, IOException {
		PrintWriter out = httpResponse.getWriter() ;
		setHeader(httpResponse) ;
		if (httpRequest.getParameter("WRITE") != null) {
			saveFile(httpRequest,  out, "source", "filename") ;
			out.flush() ;
			return ;
		}
		
		init(httpRequest);
		StringBuffer templateFile = readTemplateFile() ;
		String sourceType = (String)_config.getAttribute("java_type", JAVA_TYPE_FILE) ;
		String fileName = ""; 
		if (sourceType.equalsIgnoreCase(JAVA_TYPE_AMBIENTE)) {
			fileName=ConfigSingleton.getInstance().getAttribute("DAOGEN.pathJavaSrc")+File.separator+ _packageAmbiente.replace('.', File.separatorChar) + File.separator + _nomeAmbiente+"DAO.java";
			replaceForAmbiente(templateFile) ;
		} else if (sourceType.equalsIgnoreCase(JAVA_TYPE_FILE)) {
			fileName=ConfigSingleton.getInstance().getAttribute("DAOGEN.pathJavaSrc")+File.separator+ _packageAmbiente.replace('.', File.separatorChar) + File.separator + _nomeFile+"DAO.java";
			replaceForFile(templateFile) ;
		}
		String action = "http://" + httpRequest.getServerName() + ":" + httpRequest.getServerPort()+ httpRequest.getContextPath()+"/servlet/"+getServletName() ;
		out.println("<html><body><form name=\"f1\" method=\"post\" action=\""+action+"\">");
		out.println("<input type=\"submit\" name=\"WRITE\" value=\"WRITE\">") ;
		out.println("<input type=\"text\" name=\"filename\" size=\"105\" value=\""+fileName+"\"><br>");
		out.println("<textarea name=\"source\" cols=92 rows=30>");
		DateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
        Date date = new Date();
        out.println("// Creation date and time: "+dateFormat.format(date)+" Source Template : "+_nomeTemplate+" \n");
		out.println(templateFile.toString()) ;
		out.println("</textarea>");
		out.println("</form></body></html>") ;
		out.flush() ;
	}
	
	protected int replaceForAmbiente(StringBuffer templateFile) throws IOException {
		// Elaborazione campiLog
		String auditInsertParameter = "";
		String auditUpdateParameter = "";
		String auditDeleteParameter = "";
		for(SourceBean logField : _campiLog) {
			String usato = (String) logField.getAttribute("USATO");
			String codiceJava = (String) logField.getAttribute("CODICEJAVA");
			Object codTipoSQL = logField.getAttribute("CODTIPOSQL");
			
			String parametro = "addParameter(_dataConnection.createDataField(\"\", " ;
			parametro+=codTipoSQL.toString()+","+codiceJava+"));\n";
			if (usato.equalsIgnoreCase(" ") || usato.length()==0) {
				auditInsertParameter += parametro;
				auditUpdateParameter += parametro;
				auditDeleteParameter += parametro;
			}
			if (usato.equalsIgnoreCase("I")) {
				auditInsertParameter += parametro;
			}
			if (usato.equalsIgnoreCase("A")) {
				auditUpdateParameter += parametro;
			}
			if (usato.equalsIgnoreCase("D")) {
				auditDeleteParameter += parametro;
			}
		}
		replaceToken(templateFile, TPLKEY_AUDIT_INSERT_PARAMETER, auditInsertParameter) ;
		replaceToken(templateFile, TPLKEY_AUDIT_UPDATE_PARAMETER, auditUpdateParameter) ;
		replaceToken(templateFile, TPLKEY_AUDIT_DELETE_PARAMETER, auditDeleteParameter) ;
		replaceToken(templateFile, TPLKEY_NOME_AMBIENTE, _nomeAmbiente) ;
		return replaceToken(templateFile, TPLKEY_PACKAGE, _packageAmbiente) ;
	}
	
	protected int replaceForFile(StringBuffer templateFile) throws IOException {
		String campiChiave = "";
		String campiNormali = "";
		String campiInsert = "";
		String campiUpdate = "";
		replaceToken(templateFile, TPLKEY_NOME_AMBIENTE, _nomeAmbiente) ;
		replaceToken(templateFile, TPLKEY_FILENAME, _nomeFile) ;
		for(SourceBean riga : _campiTabella) {
			String campoWeb = ((String) riga.getAttribute("CAMPOWEB")).trim();
			campoWeb=_prefissoCampi.trim()+campoWeb;
			String chiave = (String) riga.getAttribute("CAMPOCHIAVE");
			String validator = (String) riga.getAttribute("VALIDATOR");
			String useInInsert = (String) riga.getAttribute("USEININSERT");
			String useInUpdate = (String) riga.getAttribute("USEINUPDATE");
			String typedString = "TYPED_SERVICE_REQUEST.";
			if (validator == "") typedString = "";
			if(chiave.equalsIgnoreCase("Y")) {
				campiChiave=campiChiave+"\""+typedString+campoWeb+"\",";
				if(useInInsert==null || useInInsert.length()==0 || useInInsert.equalsIgnoreCase("Y"))
					campiInsert=campiInsert+"\""+typedString+campoWeb+"\",";
			}
			else {
				if(useInInsert==null || useInInsert.length()==0 || useInInsert.equalsIgnoreCase("Y"))
					campiNormali=campiNormali+"\""+typedString+campoWeb+"\",";
				if(useInUpdate==null || useInUpdate.length()==0 || useInUpdate.equalsIgnoreCase("Y"))
					campiUpdate=campiUpdate+"\""+typedString+campoWeb+"\",";
			}
		}
		if (campiChiave.length() != 0) { 
			campiChiave=campiChiave.substring(0,campiChiave.length()-1);
		}
		else {
			templateFile.insert(0, "/*******************************************************\n" +
					               " * ATTENZIONE: La tabella non ha definiti campi chiave\n" +
			                       " *******************************************************/\n") ;
		}
		if (campiNormali.length() != 0) { 
			campiNormali=campiNormali.substring(0,campiNormali.length()-1);
		}
		else {
			templateFile.insert(0, "/*******************************************************\n" +
					               " * ATTENZIONE: La tabella non ha definiti campi \"normali\"\n" +
			                       " *******************************************************/\n") ;
		}
		if (campiInsert.length() != 0) { 
			campiInsert=campiInsert.substring(0,campiInsert.length()-1);
		}
		if (campiUpdate.length() != 0) { 
			campiUpdate=campiUpdate.substring(0,campiUpdate.length()-1);
		}
		String c1,c2;
		if(campiInsert=="" || campiNormali=="")
			c1=campiInsert+campiNormali;
		else 
			c1=campiInsert+","+campiNormali;
		if(campiUpdate=="" || campiChiave=="")
			c2=campiUpdate+campiChiave;
		else 
			c2=campiUpdate+","+campiChiave;
		replaceToken(templateFile, TPLKEY_INSERT_PARAMETERS, c1);
		replaceToken(templateFile, TPLKEY_UPDATE_PARAMETERS, c2);
		replaceToken(templateFile, TPLKEY_DELETE_PARAMETERS, campiChiave);
		replaceToken(templateFile, TPLKEY_DETAIL_PARAMETERS, campiChiave);
		replaceToken(templateFile, TPLKEY_CANCELLED_PARAMETERS, campiChiave);
		replaceToken(templateFile, TPLKEY_PACKAGE_ENV, _packageAmbienteSuFile) ;
		return replaceToken(templateFile, TPLKEY_PACKAGE, _packageAmbiente) ;
	}

	/**
	 * Sostiutisce "parti" all'interno dello StringBufferd passato
	 * 
	 * @param templateFile StringBuffer contenente il template da modificare
	 * @param tplkey       String contiene la chiave da ricercare all'interno del template
	 * @param newString    String con la nuova parte da sostituire alla tplkey trovata
	 * @return count       Numero di blocchi sostituiti
	 * 
	 * @throws IOException
	 */
	protected int replaceToken(StringBuffer templateFile, String tplkey, String newString) throws IOException {
		int countReplace = 0, index = 0, tplKeySize = tplkey.length() ;
		while ((index = templateFile.indexOf(tplkey, index)) != -1) {
			countReplace++ ;
			templateFile.replace(index, index+tplKeySize,newString) ;
		}
		return countReplace ;
	}
	
	
	/**
	 * Legge e carica nello StringBuffer ritornato il contenuto del template
	 * @return
	 * @throws Exception
	 */
	private StringBuffer readTemplateFile() throws IOException {
		StringBuffer fileContent = new StringBuffer() ;
		_nomeTemplate=_nomeTemplate.trim();
		File file = new File(ConfigSingleton.getRootPath() +_templatePath, _nomeTemplate);
		FileReader fr=null;
		try {
			fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			String riga;
			while ((riga = br.readLine()) != null )
				fileContent.append(riga+"\n") ;
			br.close() ;
		} catch (FileNotFoundException e) {
			TracerSingleton.log(Constants.NOME_MODULO,TracerSingleton.CRITICAL,"ServletCreateJavaSource::readTemplateFile::Error",e);
			//e.printStackTrace(); // TODO: Da gestire log, messageHandler e redirect a PaginaStandard
			throw e ;
		} catch (IOException e) {
			TracerSingleton.log(Constants.NOME_MODULO,TracerSingleton.CRITICAL,"ServletCreateJavaSource::readTemplateFile::Error",e);
			//e.printStackTrace(); // TODO: Da gestire log, messageHandler e redirect a PaginaStandard
			throw e ;
		} finally {
			if (fr != null)
				fr.close() ;
		}
		
		return fileContent ;
	}
	
	/**
	 * Imposta gli HeaderHttp per il browser
	 * @param httpResponse
	 * @throws ServletException
	 */
	private void setHeader(HttpServletResponse httpResponse) throws ServletException{
		httpResponse.setHeader("Expires", "0");
		httpResponse.setHeader("Cache-Control",	"must-revalidate, post-check=0, pre-check=0");
		httpResponse.setHeader("Pragma", "public");
		httpResponse.setContentType("text/html");
	}
}
