/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.servlet;

import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author scarciello
 *
 */
public class ServletCreateResourceBundle extends AbstractServletFileCreate {

	private StringBuffer _templateFile = null;
	
	protected void service(HttpServletRequest httpRequest, HttpServletResponse httpResponse) throws ServletException, IOException {
		init(httpRequest);

		setHeader(httpResponse);
		PrintWriter out = httpResponse.getWriter();
		if (httpRequest.getParameter("WRITE") != null) {
			saveFile(httpRequest, out, "source", "filename") ;
			out.flush() ;
			return ;
		}

		RequestContainer requestContainer =  getRequestContainer(httpRequest);
		SourceBean serviceRequest = requestContainer.getServiceRequest();
		String codAmbiente = (String)serviceRequest.getAttribute("codAmbiente");
		
		// Prepara la stringa del ResourceBundle
		_templateFile = new StringBuffer();
		SourceBean queryPrincipali = (SourceBean) _content.getAttribute("ROWS");
		for(SourceBean tabelle : (List<SourceBean>) queryPrincipali.getAttributeAsList("ROW")) {
			String prefissoCampi = (String) tabelle.getAttribute("PREFISSOCAMPI");
			if (prefissoCampi.trim().length()>0)
				prefissoCampi=prefissoCampi.trim()+"_";
			else
				prefissoCampi="";
			String descrizioneFile = (String) tabelle.getAttribute("DESCRIZIONEFILE");
			
			_templateFile.append("# "+descrizioneFile.trim()+"\n");
			SourceBean sottoQuery = (SourceBean) tabelle.getAttributeAsList("ROWS").get(0);
			for(SourceBean campiTabelle : (List<SourceBean>) sottoQuery.getAttributeAsList("ROW")) {
				String campoWeb = (String) campiTabelle.getAttribute("CAMPOWEB");
				String descrizioneCampo = (String) campiTabelle.getAttribute("DESCRIZIONECAMPO");
				
				_templateFile.append(prefissoCampi+campoWeb.trim()+"="+descrizioneCampo.trim()+"\n");
			}
			sottoQuery = (SourceBean) tabelle.getAttributeAsList("ROWS").get(1);
			for(SourceBean relazioni : (List<SourceBean>)sottoQuery.getAttributeAsList("ROW")) {
				SourceBean relazione = (SourceBean) relazioni.getAttributeAsList("ROWS").get(0);
				for(SourceBean campiDecodifica : (List<SourceBean>) relazione.getAttributeAsList("ROW")) {
					String nomeRelazione = (String) campiDecodifica.getAttribute("NOMERELAZIONE");
					String nomeCampoWeb = (String) campiDecodifica.getAttribute("NOMECAMPOWEB");
					String descrizioneCampoRelazionato = (String) campiDecodifica.getAttribute("DESCRIZIONECAMPORELAZIONATO");
					_templateFile.append(nomeRelazione.trim()+"_"+prefissoCampi+nomeCampoWeb.trim()+"="+descrizioneCampoRelazionato.trim()+"\n");
				}
			}
			_templateFile.append("\n");
		}
		
		// Prepara il testo HTML per la pagina di PopUP
		String fileName=ConfigSingleton.getInstance().getAttribute("DAOGEN.pathResourceBundle")+"/"+ codAmbiente +".properties";
		String action = "http://" + httpRequest.getServerName() + ":" + httpRequest.getServerPort()+ httpRequest.getContextPath()+"/servlet/"+getServletName() ;
		out.println("<html><body><form name=\"f1\" method=\"post\" action=\""+action+"\">");
		out.println("<input type=\"submit\" name=\"WRITE\" value=\"WRITE\">") ;
		out.println("<input type=\"text\" name=\"filename\" size=\"105\" value=\""+fileName+"\"><br>");
		out.println("<textarea name=\"source\" cols=92 rows=32 wrap=\"off\">");
		out.println(_templateFile.toString()) ;
		out.println("</textarea>");
		out.println("</form></body></html>") ;
		out.flush();
		
	}

	/**
	 * Imposta gli HeaderHttp per il browser
	 * @param httpResponse
	 * @throws ServletException
	 */
	private void setHeader(HttpServletResponse httpResponse) throws ServletException{
		httpResponse.setHeader("Expires", "0");
		httpResponse.setHeader("Cache-Control","must-revalidate, post-check=0, pre-check=0");
		httpResponse.setHeader("Pragma", "public");
		httpResponse.setContentType("text/html");
	}


}
