/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.servlet;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.tracing.TracerSingleton;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.StringTokenizer;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author scarciello Servlet per la creazione degli statements
 */
public class ServletCreateStatements extends AbstractServletFileCreate {
	private static final long serialVersionUID = -5161391272967213552L;

	private final static String TPL_SQL_TABLENAME = "<?TableName?>";
	private final static String TPL_SQL_DELETETABLE = "<?DeleteTable?>";
	private final static String TPL_SQL_UPDATETABLE = "<?UpdateTable?>";
	private final static String TPL_SQL_INSERTTABLE = "<?InsertTable?>";
	private final static String TPL_SQL_DELETEFIELDS = "<?DeleteFields?>";
	private final static String TPL_SQL_UPDATEFIELDS = "<?UpdateFields?>";
	private final static String TPL_SQL_INSERTFIELDS = "<?InsertFields?>";
	private final static String TPL_SQL_SELECTFIELDS = "<?SelectFields?>";
	private final static String TPL_SQL_DETAILFIELDS = "<?DetailFields?>";
	private final static String TPL_SQL_UPDATEKEYS = "<?UpdateKeys?>";
	private final static String TPL_SQL_DELETEKEYS = "<?DeleteKeys?>";
	private final static String TPL_SQL_INSERTPARAMETERS = "<?InsertParameters?>";
	private final static String TPL_SQL_SELECTTABLES = "<?SelectTables?>";
	private final static String TPL_SQL_DETAILTABLES = "<?DetailTables?>";
	private final static String TPL_SQL_DETAILKEYS = "<?DetailKeys?>";
	private final static String TPL_SQL_DELETEDFLAG = "<?DeletedFlag?>";
	private final static String TPL_SQL_DELETEDFIELDS = "<?DeletedFields?>";
	private final static String TPL_SQL_DELETEDTABLES = "<?DeletedTables?>";
	private final static String TPL_SQL_DELETEDKEYS = "<?DeletedKeys?>";
	private final static String TPL_SQL_SELECTKEYS = "<?SelectKeys?>";
	private final static String TPL_SQL_REMARKS = "<?Remarks?>";

	private String _tableName = "";

	private SourceBean _tabella = null;

	private List<SourceBean> _campiTabella = null;

	private List<SourceBean> _campiLog = null;

	private List<SourceBean> _relazioni = null;

	private String _nomeTemplate = null;

	private String _templatePath = (String)ConfigSingleton.getInstance().getAttribute("DAOGEN.pathTemplate");

	private StringBuffer _templateFile = null;

	private void preparaCampiSostituzione() throws ServletException,
			IOException {
		String deleteTable = (String) _tabella
				.getAttribute("INDICEAGGIORNAMENTO");
		String updateTable = (String) _tabella
				.getAttribute("INDICEAGGIORNAMENTO");
		String insertTable = (String) _tabella
				.getAttribute("INDICEAGGIORNAMENTO");
		String selectTables = _tableName + " T1";
		String deletedTables = ((String) _tabella
				.getAttribute("INDICELETTURASA")).trim()
				+ " T1";
		String updateFields = "";
		String deleteFields = "";
		String insertFields = "";
		String updateKeys = "";
		String deleteKeys = "";
		String insertParameters = "";
		String selectFields = "";
		String detailKeys = "";
		String deletedFlag = "";
		String deletedFields = "";
		String deletedKeys = "";
		String selectKeys = "";
		String remarksCampi = "";
		String remarksLog = "";
		String remarksGen = "";
		String rigaAppoggio = "";
		
		DateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
        Date date = new Date();
        
        remarksGen = "<!-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX -->\n";
		rigaAppoggio ="<!-- X TABELLA FILE ("+ _tableName.trim()+ ")";
		rigaAppoggio = String.format("%-104s", rigaAppoggio)+"X -->\n"; 
		remarksGen += rigaAppoggio;
		remarksGen += "<!-- X                                                                                                  X -->\n";
		remarksGen += "<!-- X Creation date and time: "+dateFormat.format(date)+"                                                      X -->\n";
		remarksGen += "<!-- X                                                                                                  X -->\n";
		rigaAppoggio = "<!-- X " + String.format("%-97s", ((String)_tabella.getAttribute("INDICELETTURASV")).trim()+": vista per inquiry dei soli dati validi")+"X -->\n"; 
		remarksGen += rigaAppoggio;
		rigaAppoggio = "<!-- X " + String.format("%-97s", updateTable.trim()+": vista per Update / Insert")+"X -->\n"; 
		remarksGen += rigaAppoggio;
		rigaAppoggio = "<!-- X " + String.format("%-97s", ((String)_tabella.getAttribute("INDICELETTURASA")).trim()+": vista per inquity dei soli dati annullati")+"X -->\n";
		remarksGen += rigaAppoggio;
		remarksGen += "<!-- X                                                                                                  X -->\n";
		int contCampo = 0;
		int contChiave = 0;
		int contCampoI = 0;
		int contCampoS = 0;
		int contCampoD = 0;
		
		String prefissoCampi = (String) _tabella.getAttribute("PREFISSOCAMPI");
		String prefissoLog = prefissoCampi.toString();
		if (prefissoCampi != null && prefissoCampi.trim().length() > 0)
			prefissoCampi = prefissoCampi.trim() + "_";
		else
			prefissoCampi = "";

		for (SourceBean elemento : _campiLog) {
			String nomeCampo = (String) elemento.getAttribute("NOMECAMPO");
			String usoCampo = (String) elemento.getAttribute("USATO");
			String descrizione = (String) elemento.getAttribute("DESCRIZIONE");
			String descrizioneTipo = (String) elemento.getAttribute("DESCRIZIONETIPO");
			String appoggio = prefissoLog.trim() + nomeCampo.trim() + ", " + descrizioneTipo.trim();

			if(usoCampo==null || usoCampo.length()==0)
				usoCampo=" ";
			remarksLog += String.format("<!-- X %-35s: %-59s X -->\n",
					descrizione.trim(), appoggio);
			if (usoCampo.equalsIgnoreCase("A") || usoCampo.equalsIgnoreCase(" ")) {
				++contCampo;
				if (contCampo != 1) {
					updateFields += ",\n         ";
				}
				updateFields += prefissoLog.trim() + nomeCampo.trim() + " = ?";
			}
			if (usoCampo.equalsIgnoreCase("I") || usoCampo.equalsIgnoreCase(" ")) {
				++contCampoI;
				if (contCampoI != 1)
					insertFields += ", ";
				insertFields += prefissoLog.trim() + nomeCampo.trim();
			}
			if (usoCampo.equalsIgnoreCase("D") || usoCampo.equalsIgnoreCase(" ")) {
				++contCampoD;
				if (contCampoD != 1)
					deleteFields += ",\n         ";
				deleteFields += prefissoLog.trim() + nomeCampo.trim() + " = ?";
			}
			if (usoCampo.equalsIgnoreCase(" "))
				deletedFlag = "T1." + prefissoLog.trim() + nomeCampo.trim()
						+ " = ?";
		}
		//deleteFields = updateFields;
		contChiave = 0;
		for (SourceBean elemento : _campiTabella) {
			String nomeCampo = (String) elemento.getAttribute("NOMECAMPO");
			String campoChiave = (String) elemento.getAttribute("CAMPOCHIAVE");
			String campoWeb = (String) elemento.getAttribute("CAMPOWEB");
			campoWeb = prefissoCampi + campoWeb;
			String descrizioneCampo = (String) elemento.getAttribute("DESCRIZIONECAMPO");
			String descrizioneTipo = (String) elemento.getAttribute("DESCRIZIONETIPO");
			String lunghezzaCampo = "" + elemento.getAttribute("LUNGHEZZACAMPO");
			String useInInsert = (String) elemento.getAttribute("USEININSERT");
			String useInUpdate = (String) elemento.getAttribute("USEINUPDATE");
			String appoggio = nomeCampo.trim() + ", " + descrizioneTipo.trim() + ", " + lunghezzaCampo;

			remarksCampi += String.format("<!-- X %-35s: %-59s X -->\n",descrizioneCampo.trim(), appoggio);
			if (campoChiave.equalsIgnoreCase("Y")) {
				++contChiave;
				if (contChiave > 1) {
					updateKeys += "  AND    ";
					detailKeys += "\n  AND    ";
				}
				updateKeys += nomeCampo.trim() + " = ?\n";
				detailKeys += "T1." + nomeCampo.trim() + " = ?";
			} else {
				if(useInUpdate==null || useInUpdate.length()==0 || useInUpdate.equalsIgnoreCase("Y")) {
					++contCampo;
					if (contCampo != 1)
						updateFields += ",\n         ";
					updateFields += nomeCampo.trim() + " = ?";
				}
			}
			++contCampoS;
			if (contCampoS != 1) {
				selectFields += ",\n         ";
			}
			selectFields += "T1." + nomeCampo.trim() + " AS " + campoWeb.trim();
			if(useInInsert==null || useInInsert.length()==0 || useInInsert.equalsIgnoreCase("Y")) {
				++contCampoI;
				if (contCampoI != 1) {
					insertFields += ", ";
				}
				insertFields += nomeCampo.trim();
			}
		}
		deletedFields = selectFields;
		deleteKeys = updateKeys;
		deletedKeys = detailKeys;
		int contJoin = 0;
		contCampo = 1;

		String[] out = elaboraRelazioni("T1", prefissoCampi, selectFields,
				selectTables, _relazioni);
		selectFields = out[0];
		selectTables = out[1];

		for (contCampo = 1; contCampo <= contCampoI; contCampo++) {
			if (contCampo != 1)
				insertParameters += ", ";
			insertParameters += "?";
		}

		/*
		if(updateKeys.length()==0) 
			updateKeys="1 = 1";
		if(deleteKeys.length()==0) 
			deleteKeys="1 = 1";
		if(detailKeys.length()==0) 
			detailKeys="1 = 1";
		if(deletedKeys.length()==0) 
			deletedKeys="1 = 1";
		*/
		if(selectKeys.length()==0) 
			selectKeys="1 = 1";
		_templateFile = readTemplateFile();
		remarksGen += remarksCampi + remarksLog;
		remarksGen += "<!-- X                                                                                                  X -->\n";
		remarksGen += "<!-- X These statements have been generated using "
				+ String.format("%-54s", _nomeTemplate.trim() + " template.")
				+ "X -->\n";
		remarksGen += "<!-- X Please pay attention by modifing the statements, because we can't grant that they could work     X -->\n";
		remarksGen += "<!-- X properly in case of any change.                                                                  X -->\n";
		remarksGen += "<!-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX -->\n";
		replaceToken(_templateFile, TPL_SQL_TABLENAME, _tableName);
		replaceToken(_templateFile, TPL_SQL_DELETETABLE, deleteTable);
		replaceToken(_templateFile, TPL_SQL_INSERTTABLE, insertTable);
		replaceToken(_templateFile, TPL_SQL_UPDATETABLE, updateTable);
		replaceToken(_templateFile, TPL_SQL_UPDATEFIELDS, updateFields);
		replaceToken(_templateFile, TPL_SQL_DELETEFIELDS, deleteFields);
		replaceToken(_templateFile, TPL_SQL_DELETEKEYS, deleteKeys);
		replaceToken(_templateFile, TPL_SQL_UPDATEKEYS, updateKeys);
		replaceToken(_templateFile, TPL_SQL_INSERTFIELDS, insertFields);
		replaceToken(_templateFile, TPL_SQL_INSERTPARAMETERS, insertParameters);
		replaceToken(_templateFile, TPL_SQL_SELECTFIELDS, selectFields);
		replaceToken(_templateFile, TPL_SQL_DETAILFIELDS, selectFields);
		replaceToken(_templateFile, TPL_SQL_SELECTTABLES, selectTables);
		replaceToken(_templateFile, TPL_SQL_DETAILTABLES, selectTables);
		replaceToken(_templateFile, TPL_SQL_DETAILKEYS, detailKeys);
		replaceToken(_templateFile, TPL_SQL_DELETEDFLAG, deletedFlag);
		replaceToken(_templateFile, TPL_SQL_DELETEDTABLES, deletedTables);
		replaceToken(_templateFile, TPL_SQL_DELETEDFIELDS, deletedFields);
		replaceToken(_templateFile, TPL_SQL_DELETEDKEYS, deletedKeys);
		replaceToken(_templateFile, TPL_SQL_SELECTKEYS, selectKeys);
		replaceToken(_templateFile, TPL_SQL_REMARKS, remarksGen);
	}

	protected void service(HttpServletRequest httpRequest,
			HttpServletResponse httpResponse) throws ServletException,
			IOException {
		init(httpRequest);
		
		
		
		setHeader(httpResponse);
		PrintWriter out = httpResponse.getWriter();

		String nomeTabella;
		
		// nomeTabella = (String) getServiceRequest(httpRequest).getAttribute("fileFisico");

		if (httpRequest.getParameter("WRITE") != null) {
			saveFile(httpRequest, out, "source", "filename") ;
			out.flush() ;
			return ;
		}
		
		if (_tabella!=null) {
			nomeTabella = (String)_tabella.getAttribute("fileFisico");
		} else {
			nomeTabella = (String) getServiceRequest(httpRequest).getAttribute("fileFisico");
		}
		
		if (nomeTabella != null) {
			_tableName = nomeTabella.trim();
		}

		preparaSourceBean();
		preparaCampiSostituzione();
		String fileName=(String)ConfigSingleton.getInstance().getAttribute("DAOGEN.pathXMLFile");
		if(_tabella.getAttribute("XMLPATH")!=null)
			fileName+=File.separatorChar+(String)_tabella.getAttribute("XMLPATH");
		fileName+=File.separatorChar+"statements_"+_tableName+".xml";
		String action = "http://" + httpRequest.getServerName() + ":" + httpRequest.getServerPort()+ httpRequest.getContextPath()+"/servlet/"+getServletName() ;
		out.println("<html><body><form name=\"f1\" method=\"post\" action=\""+action+"\">");
		out.println("<input type=\"submit\" name=\"WRITE\" value=\"WRITE\">") ;
		out.println("<input type=\"text\" name=\"filename\" size=\"105\" value=\""+fileName+"\"><br>");
		out.println("<textarea name=\"source\" cols=92 rows=32 wrap=\"off\">");
		out.println(_templateFile.toString()) ;
		out.println("</textarea>");
		out.println("</form></body></html>") ;
		out.flush();
		
		// Resetta i valori post generazione
		_tableName = "";
		_tabella = null;
		_campiTabella = null;
		_campiLog = null;
		_relazioni = null;
		_nomeTemplate = null;
		_templateFile = null;
	}

	private void preparaSourceBean() {
		SourceBean queryEstratte = (SourceBean) _content.getAttributeAsList(
				"ROWS").get(0);
		_tabella = (SourceBean) queryEstratte.getAttribute("ROW");
		_campiTabella = ((SourceBean) _tabella.getAttributeAsList("ROWS")
				.get(0)).getAttributeAsList("ROW");
		_relazioni = ((SourceBean) _tabella.getAttributeAsList("ROWS").get(1))
				.getAttributeAsList("ROW");
		queryEstratte = (SourceBean) _content.getAttributeAsList("ROWS").get(1);
		_campiLog = queryEstratte.getAttributeAsList("ROW");
		_nomeTemplate = (String) getRowsAtIndex(2).getAttribute(
				"ROW.REFTEMPLATE");
	}

	protected SourceBean getRowsAtIndex(int index) {
		return ((SourceBean) _content.getAttributeAsList("ROWS").get(index));
	}

	/**
	 * Sostiutisce "parti" all'interno dello StringBufferd passato
	 * 
	 * @param templateFile
	 *            StringBuffer contenente il template da modificare
	 * @param tplkey
	 *            String contiene la chiave da ricercare all'interno del
	 *            template
	 * @param newString
	 *            String con la nuova parte da sostituire alla tplkey trovata
	 * @return count Numero di blocchi sostituiti
	 * 
	 * @throws IOException
	 */
	protected int replaceToken(StringBuffer templateFile, String tplkey,
			String newString) throws IOException {
		int countReplace = 0, index = 0, tplKeySize = tplkey.length();
		while ((index = templateFile.indexOf(tplkey, index)) != -1) {
			countReplace++;
			templateFile.replace(index, index + tplKeySize, newString);
		}
		return countReplace;
	}

	/**
	 * Legge e carica nello StringBuffer ritornato il contenuto del template
	 * 
	 * @return
	 * @throws Exception
	 */
	private StringBuffer readTemplateFile() throws IOException {
		StringBuffer fileContent = new StringBuffer();
		_nomeTemplate = _nomeTemplate.trim();
		File file = new File(ConfigSingleton.getRootPath() +_templatePath, _nomeTemplate);
		FileReader fr = null;
		try {
			fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			String riga;
			while ((riga = br.readLine()) != null)
				fileContent.append(riga + "\n");
			br.close();
		} catch (FileNotFoundException e) {
			TracerSingleton.log(Constants.NOME_MODULO,TracerSingleton.CRITICAL,"ServletCreateStatements::readTemplateFile::Error",e);
			//e.printStackTrace(); // TODO: Da gestire log, messageHandler e
			// redirect a PaginaStandard
			throw e;
		} catch (IOException e) {
			TracerSingleton.log(Constants.NOME_MODULO,TracerSingleton.CRITICAL,"ServletCreateStatements::readTemplateFile::Error",e);
			//e.printStackTrace(); // TODO: Da gestire log, messageHandler e
			// redirect a PaginaStandard
			throw e;
		} finally {
			if (fr != null)
				fr.close();
		}

		return fileContent;
	}

	/**
	 * Imposta gli HeaderHttp per il browser
	 * 
	 * @param httpResponse
	 * @throws ServletException
	 */
	private void setHeader(HttpServletResponse httpResponse)
			throws ServletException {
		httpResponse.setHeader("Expires", "0");
		httpResponse.setHeader("Cache-Control",
				"must-revalidate, post-check=0, pre-check=0");
		httpResponse.setHeader("Pragma", "public");
		httpResponse.setContentType("text/html");
	}

	private String[] elaboraRelazioni(String nomeTabella, String prefissoCampi,
			String selectFields, String selectTables,
			List<SourceBean> _relazioni) {
		int contJoin = 0;
		int contCampo = 1;
		for (SourceBean elemento : _relazioni) {
			String tipoJoin = "INNER";
			++contCampo;
			String nomeTabRel = (String) elemento
					.getAttribute("FILEFISICORELAZIONATO");
			Integer tipoRel = (Integer) elemento.getAttribute("TIPORELAZIONE");
			String nomeRel = getValidRelName((String) elemento
					.getAttribute("NOMERELAZIONE"));

			if (tipoRel == null)
				tipoRel = 0;
			switch (tipoRel) {
			case 0:
				tipoJoin = "INNER";
				break;
			case 1:
				tipoJoin = "LEFT";
				break;
			case 2:
				tipoJoin = "RIGHT";
				break;
			case 3:
				tipoJoin = "OUTER";
				break;
			}
			int posizione = 0;
			List<SourceBean> campiRelazioni = ((SourceBean) elemento
					.getAttributeAsList("ROWS").get(1))
					.getAttributeAsList("ROW");

			if (campiRelazioni.size() > 0) {
				String toInsert = tipoJoin + " JOIN "
				+ nomeTabRel.trim() + " T" + nomeRel.trim() + " ON ";
				if (selectTables.indexOf(toInsert) < 0) {
					selectTables += "\n         " + toInsert;
				}
				
				//selectTables += ;
			}
			for (SourceBean subElemento : campiRelazioni) {
				++posizione;
				
				String nomeCampo = (String) subElemento
						.getAttribute("NOMECAMPO");
				String nomeCampoRelazionato = (String) subElemento
						.getAttribute("NOMECAMPORELAZIONATO");
				String nomeRelazione = getValidRelName((String) subElemento
						.getAttribute("NOMERELAZIONE"));
				//selectTables += "\n  " + condizione + " " + nomeTabella + "."
				//		+ nomeCampo.trim() + " = T" + nomeRelazione.trim()
				//		+ "." + nomeCampoRelazionato.trim();
				
				
				String toInsert = nomeTabella + "."
				+ nomeCampo.trim() + " = T" + nomeRelazione.trim()
				+ "." + nomeCampoRelazionato.trim();
				
				String condizione = (posizione == 1 ? "   " : "AND");
				
				if (posizione==1 || selectTables.indexOf(toInsert) < 0) {
					selectTables += "\n         " + condizione +" "+ toInsert;
				}
				
			}
			List<SourceBean> campiDecodifica = ((SourceBean) elemento
					.getAttributeAsList("ROWS").get(0))
					.getAttributeAsList("ROW");
			for (SourceBean subElemento : campiDecodifica) {
				String nomeCampo = (String) subElemento
						.getAttribute("NOMECAMPO");
				String nomeCampoWeb = (String) subElemento
						.getAttribute("NOMECAMPOWEB");
				nomeCampoWeb = prefissoCampi + nomeCampoWeb;
				String nomeRelazione = getValidRelName((String) subElemento
						.getAttribute("NOMERELAZIONE"));

				String toInsert = "T" + nomeRelazione.trim() + "."
						+ nomeCampo.trim() + " AS " + nomeRelazione.trim()
						+ "_" + nomeCampoWeb.trim();
				if (selectFields.indexOf(toInsert) < 0) {
					selectFields += ",\n         " + toInsert;
				}

			}

			if (elemento.getAttributeAsList("ROWS").size() > 2) {
				List<SourceBean> relazioniSottoTabella = ((SourceBean) elemento
						.getAttributeAsList("ROWS").get(2))
						.getAttributeAsList("ROW");
				String[] out = elaboraRelazioni("T" + nomeRel.trim(),
						prefissoCampi, selectFields, selectTables,
						relazioniSottoTabella);
				selectFields = out[0];
				selectTables = out[1];

			}

		}

		return new String[] { selectFields, selectTables };
	}

	private String getValidRelName(String nameRel) {

		if (nameRel == null) {
			return null;
		} else {

			StringTokenizer tokenizer = new StringTokenizer(nameRel, "/");
			StringBuffer buff = new StringBuffer();
			while (tokenizer.hasMoreTokens()) {
				buff.append(tokenizer.nextToken());
			}
			return buff.toString();

		}
	}

}