/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.daogen.servlet;

import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.publishers.AbstractServletPublisher;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author grassi
 *
 */
public class ServletCreateXMLSourceWithoutSave extends AbstractServletPublisher {
	private static final long serialVersionUID = 1L;
	
	/**
	 * Local initialization
	 */
	protected void init(HttpServletRequest httpRequest) throws ServletException {
		super.init(httpRequest);
	}
	
	protected void service(HttpServletRequest httpRequest, HttpServletResponse httpResponse) throws ServletException, IOException {
		setHeader(httpResponse) ;
		PrintWriter out = httpResponse.getWriter() ;
		if (httpRequest.getParameter("WRITE") != null) {
			saveFile(httpRequest, httpResponse, out) ;
			out.flush() ;
			return ;
		}
		

		init(httpRequest);
		SourceBean xmlData = null;
		String key = (String) httpRequest.getParameter("KEY"); // PAGES.PAGE
		int pos =key.indexOf(".");
		String blockHead = key.substring(0, pos);
		String name = (String) httpRequest.getParameter("NAME"); // PagQuerySMF
		if (key.equalsIgnoreCase("FIELD-VALIDATORS.FIELD-VALIDATOR")) {
			xmlData = (SourceBean) ConfigSingleton.getInstance().getFilteredSourceBeanAttribute(key, "FIELDTYPE", name) ;
		}
		else {
			xmlData = (SourceBean) ConfigSingleton.getInstance().getFilteredSourceBeanAttribute(key, "NAME", name) ;
		}
		String fieldsetName = (String) httpRequest.getParameter("FIELDSETNAME");
		if (fieldsetName != null && fieldsetName.trim().length() > 0) {
			xmlData = (SourceBean)xmlData.getFilteredSourceBeanAttribute("CONFIG.FIELDS.FIELDSET", "NAME", fieldsetName) ;

			String fieldName = (String) httpRequest.getParameter("FIELDNAME");
			if (fieldName != null && fieldName.trim().length() > 0) {
				xmlData = (SourceBean)xmlData.getFilteredSourceBeanAttribute("FIELD", "NAME", fieldName) ;
			}
		}
		String xmlOut = xmlData.toString(true, true) ;
		xmlOut = xmlOut.substring(xmlOut.indexOf('\n')) ;

		String fileName = ConfigSingleton.getInstance().getAttribute("DAOGEN.pathXMLFile")+"/"+name+blockHead+".xml"; 
		String action = "http://" + httpRequest.getServerName() + ":" + httpRequest.getServerPort()+ httpRequest.getContextPath()+"/servlet/"+getServletName() ;
		out.println("<html><body><form name=\"f1\" method=\"post\" action=\""+action+"\">");
		out.println("<textarea name=\"source\" cols=92 rows=30>");
		out.println("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>");
		DateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
        Date date = new Date();
        out.println("<!-- Creation date and time :"+dateFormat.format(date)+" -->\n");
		out.println("<"+blockHead+">");
		out.write(xmlOut) ;
		out.println("</"+blockHead+">");
		out.println("</textarea>");
		out.println("</form></body></html>") ;
		out.flush() ;
	}
	
	private void saveFile(HttpServletRequest httpRequest, HttpServletResponse httpResponse, PrintWriter out) throws ServletException, IOException {
		String source = "" +httpRequest.getParameter("source") ;
		String fileName = "" +httpRequest.getParameter("filename") ;
		try {
	        BufferedWriter outFile = new BufferedWriter(new FileWriter(fileName));
	        outFile.write(source);
	        outFile.close();
	    } catch (IOException e) {
	    }
		out.println("<html><body><h1>File "+fileName+" scritto con successo</h1></body></html>") ;
		out.flush();
	}

	/**
	 * Imposta gli HeaderHttp per il browser
	 * @param httpResponse
	 * @throws ServletException
	 */
	private void setHeader(HttpServletResponse httpResponse) throws ServletException{
		httpResponse.setHeader("Expires", "0");
		httpResponse.setHeader("Cache-Control",	"must-revalidate, post-check=0, pre-check=0");
		httpResponse.setHeader("Pragma", "public");
		httpResponse.setContentType("text/html");
	}
}
