/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.decorators;

import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.SourceBean;

/**
 * @author grassi
 *
 */
public class StringDecorator extends AbstractDecorator {
	private static final long serialVersionUID = 1L;
	private String _pattern ;
	/**
	 * @param config
	 * @param requestContainer
	 */
	public StringDecorator(SourceBean config, RequestContainer requestContainer) {
		super(config, requestContainer);
		_pattern = (String)config.getAttribute("FORMAT.pattern") ;
	}

	@Override
	public String decorate(Object in) {
		if (in == null) {
			return "" ;
		}
		String out = String.format(_pattern, in) ;
		if (out.length() < ((String)in).length())
			out += "  ..." ;
		return out ;
	}
}
