/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.dispatching.jmschannel;

import java.io.Serializable;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.DeliveryMode;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class AdapterJMSProxyWAS implements Serializable{
	/**
     * 
     */
    private static final long serialVersionUID = 1L;

    private String  _jndi_CF=null;    
    private String _jndi_queue=null;
    
	private InitialContext iniCtx = null;
 
	public  AdapterJMSProxyWAS() throws JMSException, NamingException {
		create();
	}

	private void setConnectionFactory(String CF) {
		_jndi_CF=CF;
	}
	private void setQueue(String queue) {
		_jndi_queue=queue;
	}
	public void create() throws NamingException {
		/**
		Hashtable env = new Hashtable();
		env.put(Context.INITIAL_CONTEXT_FACTORY,
		     "com.ibm.websphere.naming.WsnInitialContextFactory");
		env.put(Context.PROVIDER_URL, "iiop://localhost:2812");
		iniCtx = new InitialContext(env);
        **/
		iniCtx = new InitialContext();
	}
	
	/**
	 * Inserisce un messaggio di testo nella coda.
	 * @param queue String nome della coda JMS
	 * @param message String messaggio di testo da inserire in coda
	 * @throws JMSException
	 * @throws NamingException
	 */
	public void sendMessage(String connectionFactory,String queue,String message) throws JMSException,NamingException {
		 setConnectionFactory(connectionFactory);
		 setQueue(queue);

		 /*
		 XAConnectionFactory qCF=(XAConnectionFactory) iniCtx.lookup(this._jndi_CF);
		 Destination qDest=(Destination) iniCtx.lookup(_jndi_queue);
		 XAConnection connection=qCF.createXAConnection() ;
		 XASession session=connection.createXASession() ;
		*/

		 ConnectionFactory qCF=(ConnectionFactory) iniCtx.lookup(this._jndi_CF);
		 Destination qDest=(Destination) iniCtx.lookup(_jndi_queue);
		 Connection connection=qCF.createConnection();

		 Session session=connection.createSession(false,Session.AUTO_ACKNOWLEDGE);
		 MessageProducer queueSender=session.createProducer(qDest);
		 TextMessage outMessage=session.createTextMessage();
		 outMessage.setText(message);
		 outMessage.setJMSDestination(qDest);
		 queueSender.setDeliveryMode(DeliveryMode.NON_PERSISTENT);
		 queueSender.send(outMessage);
		
		queueSender.close();
		session.close();
		connection.close();
	}

}
