/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.dispatching.module.impl;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Iterator;
import java.util.List;

import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.module.AbstractModule;

public class CurrentDateModule extends AbstractModule {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception {
		
		List<SourceBean> parameters = getConfig().getAttributeAsList("PARAMETER");
		
		if (parameters!=null && parameters.size()>0 ) {
			
			Calendar cal = Calendar.getInstance();
	    	SimpleDateFormat sdf;
	    	
			for (SourceBean bean : parameters) {
			
				sdf = new SimpleDateFormat((String)bean.getAttribute("FORMAT","dd/MM/yyyy"));
		    	
				String date = sdf.format(cal.getTime());	
				String name = (String)bean.getAttribute("NAME");
				String scope = (String) bean.getAttribute("SCOPE","SERVICE_REQUEST");
				
				if (scope.equals("SERVICE_REQUEST")) {
					serviceRequest.updAttribute(name,date);
				} else if (scope.equals("SERVICE_RESPONSE")) {
					serviceResponse.updAttribute(name,date);
				} 
			}
			
		}
	}

}
