/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.dispatching.module.impl;

import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.impl.ActGatewayRPG;
import it.eng.spago.dispatching.module.AbstractModule;
import it.eng.spago.error.EMFErrorHandler;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;

/**
 * @author grassi
 *
 */
public class GatewayRPGModule extends AbstractModule {
	private static final long serialVersionUID = 7677999425711204388L;

	/**
	 * @see ActGatewayRPG
	 */
	public void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception {
		int CodErr = 12206;
		String pcmlName = (String)getConfig().getAttribute("pcml") ;
		SourceBean pcmlBean = SourceBean.fromXMLFile("WEB-INF/pcml/"+pcmlName+".pcml", true, true) ;
		SourceBean returnFromInvoke = ActGatewayRPG.invoke(this, pcmlName, pcmlBean);
		if(returnFromInvoke!=null)
			CodErr = 12205;
		serviceResponse.setAttribute(returnFromInvoke) ;
		EMFErrorHandler engErrorHandler = getErrorHandler();
		engErrorHandler.addError(new EMFUserError(EMFErrorSeverity.WARNING, CodErr));
	}
}
