/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.dispatching.module.impl;

import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.module.AbstractModule;
import it.eng.spago.dispatching.service.util.DelegateIfsService;

public class IfsModule extends AbstractModule {
	private static final long serialVersionUID = 1L;

	/**
	 * Execution of I/O service into Integrate File System (AS/400 file system)
	 * Sample configuration:
	 *          <CONFIG ..>
	 *             <WRITE_TO filename="/arcafile/excel/FileComuni/FSFP_G_BPU_2007-03-07-13_23_38_161000.zip">
	 *                 <PARAMETER type="RELATIVE" value="ROWS" scope="SERVICE_REQUEST" />
	 *                 <FORMATTING type="csv" separator="|" />
	 *             </WRITE_TO>
	 *             ...
	 *          </CONFIG>
	 * @param service
	 * @param request
	 * @param response
	 * @throws Exception
	 */
	public void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception {
		DelegateIfsService.service(this, serviceRequest, serviceResponse) ;
	}
}
