/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.dispatching.service.util;

import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.service.RequestContextIFace;
import it.eng.spago.dispatching.service.ServiceIFace;
import it.eng.spago.init.InitializerIFace;
import java.io.Serializable;

public abstract class AbstractDelegateService implements Serializable {
	private static final long serialVersionUID = 1L;
	
	/**
	 * Standard service method for Actions or Modules pourpose
	 * @param service
	 * @param request
	 * @param response
	 * @throws Exception
	 */
	public static void service(ServiceIFace service, SourceBean request, SourceBean response) throws Exception {
	}
	
	protected static InitializerIFace getServiceInitializer(ServiceIFace service) {
		return (InitializerIFace) service;
	}
	
	protected static SourceBean getConfig(ServiceIFace service) {
		return getServiceInitializer(service).getConfig() ;
	}
	
	protected static RequestContextIFace getServiceRequestContext(ServiceIFace service) {
		return (RequestContextIFace) service;
	}
	
	protected static SourceBean getServiceResponse(ServiceIFace service) {
		return getServiceRequestContext(service).getServiceResponse() ;
	}

	protected static SourceBean getServiceRequest(ServiceIFace service) {
		return getServiceRequestContext(service).getServiceRequest() ;
	}

	protected static RequestContainer getRequestContainer(ServiceIFace service) {
		return getServiceRequestContext(service).getRequestContainer() ;
	}

	protected static ResponseContainer getResponseContainer(ServiceIFace service) {
		return getServiceRequestContext(service).getResponseContainer() ;
	}
}