/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.event;

import it.eng.spago.base.ApplicationContainer;
import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.tracing.TracerSingleton;

public class EventNotifierFactory {

	 private static String EVENT_NOTIFIER = "EVENT_NOTIFIER";
	 
	 public static IEventNotifier getEventNotifier(){
	    	
	    	ApplicationContainer application = ApplicationContainer.getInstance();
	    	
	    	IEventNotifier eventNotifier = null;
	    	if (application.getAttribute(EVENT_NOTIFIER) != null){
	    	    eventNotifier =  (IEventNotifier)application.getAttribute(EVENT_NOTIFIER);
	    	}else{
	    		try{
	    			
	    			ConfigSingleton configurator = ConfigSingleton.getInstance();
	    			boolean eventNotificationEnabled = false;
	    			String notifierClass = "it.eng.spago.event.NullEventNotifier";
	    			if (configurator.getAttribute("EVENTS") != null){
	    				
	    				SourceBean eventNotificationEnabledSourceBean = (SourceBean)configurator.getAttribute("EVENTS.EVENTS-NOTIFICATION-ENABLED");
	    				
	    				if (eventNotificationEnabledSourceBean != null){
	    					try{
	    						
	    						eventNotificationEnabled = Boolean.valueOf(eventNotificationEnabledSourceBean.getCharacters().trim()).booleanValue();
	    					
	    						notifierClass = (String)ConfigSingleton.getInstance().getAttribute("EVENTS.EVENTS-NOTIFIER.notifierClass");
	    					
	    					}catch(Exception e){
	    					
	    						TracerSingleton.log(
	        		                    Constants.NOME_MODULO,
	        		                    TracerSingleton.CRITICAL,
	        		                    "AbstractCoordinator::getEventNotifier: Exception", (Exception)e);
	    					
	    					}
	    					
	    				}else{
	    					
	    					TracerSingleton.log(
	    		                    Constants.NOME_MODULO,
	    		                    TracerSingleton.CRITICAL,
	    		                    "AbstractCoordinator::getEventNotifier: Busta EVENT.EVENT-NOTIFICATION-ENABLED non trovata NOTIFICA EVENTI DISABILITATA" );
	    					
	    					eventNotificationEnabled = false;
	    				
	    				}
	    				
	    			}else{
	    				
	    				TracerSingleton.log(
			                    Constants.NOME_MODULO,
			                    TracerSingleton.CRITICAL,
			                    "AbstractCoordinator::getEventNotifier: Busta EVENT non trovata NOTIFICA EVENTI DISABILITATA" );
	    				eventNotificationEnabled = false;
	    			
	    			}
	    			
	    			if (notifierClass == null || !eventNotificationEnabled){
	    				notifierClass = "it.eng.spago.event.NullEventNotifier";
	    			}
	    			
	    			eventNotifier = (IEventNotifier)Class.forName(notifierClass).newInstance();
	    			
	    			application.setAttribute(EVENT_NOTIFIER, eventNotifier);
	    		
	    		}catch(Exception e){
	    		
	    			TracerSingleton.log(
	                    Constants.NOME_MODULO,
	                    TracerSingleton.CRITICAL,
	                    "AbstractCoordinator::notifyEvent: Exception",e);
			
	    		}
	    	}
	    	
	    	return eventNotifier;
	    
	    }
}
