/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.listeners;

import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.event.ISpagoEvent;
import it.eng.spago.event.ServiceEndEvent;
import it.eng.spago.event.ServiceStartEvent;
import it.eng.spago.listeners.ISpagoListener;

import javax.servlet.http.HttpSession;

import org.apache.log4j.MDC;

public class SessionIdTracerListener implements ISpagoListener {

    private static final String LOG_SESSION_ID = "SessionID";

    public void onEvent(ISpagoEvent event, RequestContainer requestContainer,
			ResponseContainer responseContainer) {
        if (event instanceof ServiceStartEvent) {
            MDC.put(LOG_SESSION_ID, ((HttpSession)((ServiceStartEvent)event).getSource()).getId());
        } else if (event instanceof ServiceEndEvent) {
            MDC.remove(LOG_SESSION_ID); 
        }
	}

}
