/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.lookup;

import java.util.List;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.tracing.TracerSingleton;

/**
 * @author scarciello
 *
 */
public class LookupConfigurator {
	
	public static SourceBean returnCaption(String lookupName) {
		SourceBean lookup = (SourceBean)ConfigSingleton.getInstance().getFilteredSourceBeanAttribute("LOOKUPS.LOOKUP", "NAME", lookupName);
		SourceBean captionBean = null;
		try {
			captionBean = new SourceBean("CAPTION");
			captionBean.setAttribute("CLASS","SCEGLI");
			captionBean.setAttribute("LABEL","SCEGLI");
			
			// Prepara i parametri
			SourceBean parameter = new SourceBean("PARAMETER");
			parameter.setAttribute("NAME","RET_LUP");
			parameter.setAttribute("TYPE","ABSOLUTE");
			parameter.setAttribute("VALUE","TRUE");
			captionBean.setAttribute(parameter);
			for(SourceBean field : (List<SourceBean>) lookup.getAttributeAsList("CONFIG.FIELD")) {
				String destID = (String)field.getAttribute("DESTID");
				parameter = new SourceBean("PARAMETER");
				parameter.setAttribute("NAME",destID);
				parameter.setAttribute("TYPE","RELATIVE");
				parameter.setAttribute("SCOPE","LOCAL");
				parameter.setAttribute("VALUE",destID);
				captionBean.setAttribute(parameter);
			}
			
		} catch (SourceBeanException e) {
			TracerSingleton.log(Constants.NOME_MODULO,TracerSingleton.CRITICAL,"LookupConfigurator::returnCaption::Error",e);
			//e.printStackTrace();
		}

		return captionBean;
	}
}
