/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.message;

import java.util.Iterator;
import java.util.List;

import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.init.InitializerIFace;

public class MessageBundleInitializer implements InitializerIFace {
    private SourceBean _config = null;

    public MessageBundleInitializer() {
        super();
        _config = null;
    } // public DataAccessInitializer()

    public void init(SourceBean config) {
        _config = config;

        ConfigSingleton configuration = ConfigSingleton.getInstance();
        List bundlesNames = configuration.getAttributeAsList("MESSAGES.BUNDLE");
        for (Iterator it = bundlesNames.iterator(); it.hasNext();) {
            SourceBean sb = (SourceBean)it.next();
            String bundleName = (String)sb.getAttribute("NAME");
            MessageBundle.addBundleName(bundleName);
        }
    }

    public SourceBean getConfig() {
        return _config;
    }

}
