/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.message;

import java.util.ArrayList;
import java.util.List;

public class MessageBundleReference {

	private String bundleName = null;

	public MessageBundleReference(String bundleName) {
		super();
		this.bundleName = bundleName;
	}

	public String getBundleName() {
		return bundleName;
	}

	public void setBundleName(String bundleName) {
		this.bundleName = bundleName;
	}
	
	public String getMessage(String code) {
		return MessageBundle.getMessage(code, bundleName);
	}
	
	public String getMessage(String code, String arg0) {
		List params = new ArrayList(1);
		params.add(arg0);
		return MessageBundle.getMessage(code, bundleName, params);
	}
	
	public String getMessage(String code, String arg0, String arg1) {
		List params = new ArrayList(2);
		params.add(arg0);
		params.add(arg1);
		return MessageBundle.getMessage(code, bundleName, params);
	}

	public String getMessage(String code, String arg0, String arg1, String arg2) {
		List params = new ArrayList(3);
		params.add(arg0);
		params.add(arg1);
		params.add(arg2);
		return MessageBundle.getMessage(code, bundleName, params);
	}
}
