/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.presentation;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;

import java.util.ArrayList;
import java.util.List;

public class PublisherConfiguration {
    
    public static final String AF_PUBLISHER_NAME = "AF_PUBLISHER_NAME";
    
    private String _name = null;

    private String _channel = null;

    private String _type = null;

    private String _mode = null;

    private List _resources = null;
    
    private SourceBean _renderingConfig = null;

    public PublisherConfiguration() {
        super();
        _name = null;
        _channel = null;
        _type = Constants.NOTHING_PUBLISHER_TYPE;
        _mode = null;
        _resources = new ArrayList();
        _renderingConfig = null;
    } // public Publisher()

    public PublisherConfiguration(String name, String channel, String type, String mode, final List resources, final SourceBean renderingConfig) {
		super();
		this._name = name;
		this._channel = channel;
		this._type = type;
		this._mode = mode;
		this._resources = resources;
		this._renderingConfig = renderingConfig;
	}
    
    public void release() {
        _name = null;
        _channel = null;
        _type = null;
        _mode = null;
        _resources = null;
        _renderingConfig = null;
    }

	public String getName() {
        return _name;
    } // public String getName()

    public void setName(String name) {
        _name = name;
    } // public void setName(String name)

    public String getChannel() {
        return _channel;
    } // public String getChannel()

    public void setChannel(String channel) {
        _channel = channel;
    } // public void setChannel(String channel)

    public String getType() {
        return _type;
    } // public String getType()

    public void setType(String type) {
        if (type == null)
            _type = Constants.NOTHING_PUBLISHER_TYPE;
        else
            _type = type;
    } // public void setType(String type)

    public String getMode() {
        return _mode;
    } // public String getMode()

    public void setMode(String mode) {
        _mode = mode;
    } // public void setMode(String mode)

    public List getResources() {
        return _resources;
    } // public List getResources()

    public void addResource(SourceBean resource) {
        if (resource == null)
            return;
        _resources.add(resource);
    } // public void addResource(String resource)

	public SourceBean getRenderingConfig() {
		return _renderingConfig;
	}

	public void setRenderingConfig(SourceBean config) {
		_renderingConfig = config;
	}    
    
} // public class Publisher
