/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.security;

import it.eng.spago.error.EMFInternalError;

import java.util.Collection;



 /**
 * @author Andrea Zoppello
 *
 * Define extended interface to query the user profile about a user access
 * on a particular resource
 *
 */
public interface IExtendedEngUserProfile extends IEngUserProfile {
	
	public boolean canAccessResource(String resourceID) throws EMFInternalError;
	
	public Collection getAccessibleResources() throws EMFInternalError;

	public boolean canExecuteFunctionality(String functionalityID) throws EMFInternalError;
}
