/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.services;

import java.io.Serializable;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.service.RequestContextIFace;

/**
 */
public abstract class AbstractService implements ServiceInterface, Serializable {

	private String _scope = null;

	/**
	 * Basic constructor.
	 */
	public AbstractService() {
	} // public AbstractService()

	/**
	 * Method used to initialize a service after its instantiation.
	 * @param props the properties
	 * @throws ServiceException on any error
	 */
	//  public void init(Properties props) throws ServiceException {
	// TODO check if you can throw a specific exception
	public void init(SourceBean config) throws Exception {
		// void
	}// public void init(SourceBean config) throws Exception

	/**
	 * Methods for generic invocation
	 * @param requestContext
	 * @return
	 * @throws Exception
	 */
	public Object invoke(RequestContextIFace requestContext) throws Exception {
		return null ;
	}
	
	public String getScope() {
		return _scope;
	}// public String getScope()

	public void setScope(String scope) {
		this._scope = scope;
	}// public void setScope(String scope)

}// public abstract class AbstractService implements ServiceInterface
