/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.services;

import it.eng.spago.dispatching.service.RequestContextIFace;


/**
 * Interface for the service catalog manager.
 */
public interface ServiceCatalogIFace {
     /**
     *  Return an instance of the service registered with <code>name</code>
     *
     *@param reqCtx. Context used to retrive and store services.
     *@param  name. Name of the registered service.
     *@return The service instance.
     *@exception Exception.
     */
//    public ServiceInterface getService(String name) throws ServiceException;
    public ServiceInterface getService(RequestContextIFace reqCtx, String name) throws Exception;


    /**
     *  Say if a service with the given name is registered.
     *
     *@param  name  Description of the Parameter
     *@return       The serviceAvailable value
     */
    public boolean isServiceAvailable(String name);

    /**
     *  Gets the serviceList attribute of the ServiceCatalogIFace object
     *
     *@return    The serviceList value
     */
//    public Enumeration getServiceList();

}
