/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.services;

import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.service.RequestContextIFace;

/**
 * Interface to be implemented by any service that is in the service catalog.
 * 
 * Managed scopes are <code>REQUEST, SESSION, APPLICATION</code>
 */
//public interface ServiceInterface extends RuntimeUserInterface {
public interface ServiceInterface {
	
	/**
	 * Method used to initialize a service after its instantiation.
	 * @param config. A <code>SourceBean</code> containing configuration attributes.
	 * @throws Exception on any error
	 */
	//  public void init(Properties props) throws ServiceException;
	// TODO check if you can throw a specific exception
	public void init(SourceBean config) throws Exception;

	/**
	 * Methods for generic invocation
	 * @param requestContext
	 * @return
	 * @throws Exception
	 */
	public Object invoke(RequestContextIFace requestContext) throws Exception ;
	
	/**
	 * Return the lifecycle scope of this service.
	 * 
	 * @return
	 */
	public String getScope();
	
	/**
	 * Set the lifecycle scope of this service.
	 * 
	 * @param scope.
	 */
	public void setScope(String scope);
}
