/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.services.alias;

import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.dispatching.service.RequestContextIFace;
import it.eng.spago.services.AbstractService;
import it.eng.spago.tracing.TracerSingleton;

import org.apache.commons.validator.GenericValidator;

/**
 * Retrive alias information from configuration file.
 */
public class AliasService extends AbstractService {
	private static final long serialVersionUID = -431682760245698753L;
	/**
	 * Path for aliases in configuration file (aliases.xml).
	 */
	private static final String ALIAS_PATH = "ALIASES.ALIAS";
	
    /**
     *  Constructor for the AliasService object
     */
    public AliasService() { }


/* ######
 * nothing to "init". maintain abstractservice void method
 * ###### */

    public String getAlias(String aliasName) {
    	String configAlias = null;
        if (!GenericValidator.isBlankOrNull(aliasName)) {
        	SourceBean sbAlias = (SourceBean)ConfigSingleton.getInstance()
        		.getFilteredSourceBeanAttribute(ALIAS_PATH, "NAME", aliasName); 
	        if (sbAlias != null) {
	        	configAlias = (String)sbAlias.getAttribute("VALUE");
	        } else {
	        	TracerSingleton.log(it.eng.spago.base.Constants.NOME_MODULO, TracerSingleton.WARNING,
	        		"AliasService::getAlias: Can't find alias ["+aliasName+"] passed to tag.");
	        }//if (sbAlias != null)
        }//if (!GenericValidator.isBlankOrNull(aliasName))
        return configAlias;
   }//public String getAlias(String aliasName)


	public Object invoke(RequestContextIFace requestContext) throws Exception {
		// TODO Stub di metodo generato automaticamente
		return null;
	}

}
