/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.services.http;

public class HttpBean {

    private long _expiredTime;
    private String _response;


    /**
     *  Constructor for the HttpBean object
     *
     *@param  expiration  Description of the Parameter
     */
    public HttpBean(long expiration) {
        if (expiration == -1) {
            this._expiredTime = -1;
        } else {

            this._expiredTime = System.currentTimeMillis() + expiration;
        }
    }



    /**
     *  Gets the expiration attribute of the HttpBean object
     *
     *@return    The expiration value
     */
    public boolean isExpired() {
        if (_expiredTime == -1) {
            return false;
        } else {
            return _expiredTime < System.currentTimeMillis();
        }
    }


    /**
     *  Sets the _response attribute of the HttpBean object
     *
     *@param  _response  The new _response value
     */
    public void setResponse(String response) {
        this._response = response;
    }


    /**
     *  Gets the _response attribute of the HttpBean object
     *
     *@return    The _response value
     */
    public String getResponse() {
        return _response;
    }
}
