/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.servlet;

import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.configuration.SkeletonsManager;
import it.eng.spago.dbaccess.DataConnectionManager;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServlet;

/**
 * @author grassi
 *
 */
public class ReloadServlet extends HttpServlet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public void service(ServletRequest request, ServletResponse response) throws ServletException, IOException {
	    PrintWriter out = response.getWriter();
	    String listAction = (String)request.getParameter("list") ;
	    String dump = (String)request.getParameter("dump") ;
	    if (listAction != null && listAction.trim().length() > 0){
	    	listData(listAction, out) ;
	    }
	    else {
	    	reloadConfig(out,dump) ;
		}
	    out.close();
	}
	
	/**
	 * Visualizza dati in configurazione
	 * @param listAction
	 * @param out
	 */
	private void listData(String listAction, PrintWriter out) {
		if (listAction.trim().equalsIgnoreCase("MODULE_NAME")) {
			List<SourceBean> pageList = ConfigSingleton.getInstance().getAttributeAsList("PAGES.PAGE") ;
			String moduleIndexKey ;
			for (SourceBean pageBean : pageList) {
				if (pageBean.containsAttribute("GRAPH")) {
					moduleIndexKey = "GRAPH.MODULES.MODULE" ;
				} else {
					moduleIndexKey = "MODULES.MODULE" ;
				}
				List<SourceBean>moduleList = pageBean.getAttributeAsList(moduleIndexKey) ;
				for (SourceBean moduleBean : moduleList){
					out.println(pageBean.getAttribute("name") + " - " + moduleBean.getAttribute("name")) ;
				}
			}
		} else {
			out.println("Parametro "+listAction + " NON implementato.") ;
			out.println("Vedere il mentodo ReloadServlet:listData per quelli implementati.") ;
		}
	}
	
	/**
	 * Ricarica la configurazione
	 * @param out
	 */
	private void reloadConfig(PrintWriter out,String dump) {
		try {
			DataConnectionManager.release() ;
			ConfigSingleton.release() ;
	        if (! SkeletonsManager.mergeConfiguration()) {
		        System.out.println("ConfigServlet::init: Error in add Skeletons"); 
	        }
		}catch (Exception ex) {
		    out.println(ex.getMessage()) ;
		}
		
		if (dump!=null && dump.equalsIgnoreCase("true")) {
			out.println(ConfigSingleton.getInstance().toXML());
		} else {
			out.println("Configuration reloaded successfully");
		}
	}
}
