/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.soap.axis.client;

public class AdapterAxisProxy implements it.eng.spago.soap.axis.client.AdapterAxis {
	private String _endpoint = null;
	private it.eng.spago.soap.axis.client.AdapterAxis adapterAxis = null;
	private Long sessionId = null;

	public AdapterAxisProxy() {
		_initAdapterAxisProxy();
	}

	public AdapterAxisProxy(Long sessionId) {
		_initAdapterAxisProxy();
		this.sessionId = sessionId;
	}

	private void _initAdapterAxisProxy() {
		try {
			AdapterAxisServiceLocator adapterAxisServicelocator = (new it.eng.spago.soap.axis.client.AdapterAxisServiceLocator());
			adapterAxis = adapterAxisServicelocator.getAdapterAxis();
			if (adapterAxis != null) {
				if (_endpoint != null)
					((javax.xml.rpc.Stub) adapterAxis)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
				else
					_endpoint = (String) ((javax.xml.rpc.Stub) adapterAxis)._getProperty("javax.xml.rpc.service.endpoint.address");
			}
		} catch (javax.xml.rpc.ServiceException serviceException) {
		}
	}

	public String getEndpoint() {
		return _endpoint;
	}

	public void setEndpoint(String endpoint) {
		_endpoint = endpoint;
		if (adapterAxis != null)
			((javax.xml.rpc.Stub) adapterAxis)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
	}

	public it.eng.spago.soap.axis.client.AdapterAxis getAdapterAxis() {
		if (adapterAxis == null)
			_initAdapterAxisProxy();
		return adapterAxis;
	}

	public java.lang.String service(java.lang.String request) throws java.rmi.RemoteException {
		if (adapterAxis == null)
			_initAdapterAxisProxy();
		if (this.sessionId != null) {
			((AdapterAxisSoapBindingStub) adapterAxis).setSessionId(this.sessionId);
		}
		String response = adapterAxis.service(request);
		this.sessionId = ((AdapterAxisSoapBindingStub) adapterAxis).getSessionId();
		return response;
	}

	public Long getSessionId() {
		return sessionId;
	}

	public void setSessionId(Long sessionId) {
		this.sessionId = sessionId;
	}
}