/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/

package it.eng.spago.soap.axis.client;

public class AdapterAxisServiceLocator extends org.apache.axis.client.Service implements it.eng.spago.soap.axis.client.AdapterAxisService {

    public AdapterAxisServiceLocator() {
    }


   

//  Use to get a proxy class for AdapterAxis
    private java.lang.String AdapterAxis_address = "http://localhost:8080/SpagoAxisService/services/AdapterAxis";

    public java.lang.String getAdapterAxisAddress() {
        return AdapterAxis_address;
    }

    // The WSDD service name defaults to the port name.
    private java.lang.String AdapterAxisWSDDServiceName = "AdapterAxis";

    public java.lang.String getAdapterAxisWSDDServiceName() {
        return AdapterAxisWSDDServiceName;
    }

    public void setAdapterAxisWSDDServiceName(java.lang.String name) {
        AdapterAxisWSDDServiceName = name;
    }

    public it.eng.spago.soap.axis.client.AdapterAxis getAdapterAxis() throws javax.xml.rpc.ServiceException {
       java.net.URL endpoint;
        try {
            endpoint = new java.net.URL(AdapterAxis_address);
        }
        catch (java.net.MalformedURLException e) {
            throw new javax.xml.rpc.ServiceException(e);
        }
        return getAdapterAxis(endpoint);
    }

    public it.eng.spago.soap.axis.client.AdapterAxis getAdapterAxis(java.net.URL portAddress) throws javax.xml.rpc.ServiceException {
        try {
            it.eng.spago.soap.axis.client.AdapterAxisSoapBindingStub _stub = new it.eng.spago.soap.axis.client.AdapterAxisSoapBindingStub(portAddress, this);
            _stub.setPortName(getAdapterAxisWSDDServiceName());
            return _stub;
        }
        catch (org.apache.axis.AxisFault e) {
            return null;
        }
    }

    public void setAdapterAxisEndpointAddress(java.lang.String address) {
        AdapterAxis_address = address;
    }

    /**
     * For the given interface, get the stub implementation.
     * If this service has no port for the given interface,
     * then ServiceException is thrown.
     */
    public java.rmi.Remote getPort(Class serviceEndpointInterface) throws javax.xml.rpc.ServiceException {
        try {
            if (it.eng.spago.soap.axis.client.AdapterAxis.class.isAssignableFrom(serviceEndpointInterface)) {
                it.eng.spago.soap.axis.client.AdapterAxisSoapBindingStub _stub = new it.eng.spago.soap.axis.client.AdapterAxisSoapBindingStub(new java.net.URL(AdapterAxis_address), this);
                _stub.setPortName(getAdapterAxisWSDDServiceName());
                return _stub;
            }
        }
        catch (java.lang.Throwable t) {
            throw new javax.xml.rpc.ServiceException(t);
        }
        throw new javax.xml.rpc.ServiceException("There is no stub implementation for the interface:  " + (serviceEndpointInterface == null ? "null" : serviceEndpointInterface.getName()));
    }

    /**
     * For the given interface, get the stub implementation.
     * If this service has no port for the given interface,
     * then ServiceException is thrown.
     */
    public java.rmi.Remote getPort(javax.xml.namespace.QName portName, Class serviceEndpointInterface) throws javax.xml.rpc.ServiceException {
        if (portName == null) {
            return getPort(serviceEndpointInterface);
        }
        java.lang.String inputPortName = portName.getLocalPart();
        if ("AdapterAxis".equals(inputPortName)) {
            return getAdapterAxis();
        }
        else  {
            java.rmi.Remote _stub = getPort(serviceEndpointInterface);
            ((org.apache.axis.client.Stub) _stub).setPortName(portName);
            return _stub;
        }
    }

    public javax.xml.namespace.QName getServiceName() {
        return new javax.xml.namespace.QName("http://axis.soap.spago.eng.it", "AdapterAxisService");
    }

    private java.util.HashSet ports = null;

    public java.util.Iterator getPorts() {
        if (ports == null) {
            ports = new java.util.HashSet();
            ports.add(new javax.xml.namespace.QName("http://axis.soap.spago.eng.it", "AdapterAxis"));
        }
        return ports.iterator();
    }

    /**
    * Set the endpoint address for the specified port name.
    */
    public void setEndpointAddress(java.lang.String portName, java.lang.String address) throws javax.xml.rpc.ServiceException {
        
    	if ("AdapterAxis".equals(portName)) {
            setAdapterAxisEndpointAddress(address);
        } else { 	
        	// Unknown Port Name
            throw new javax.xml.rpc.ServiceException(" Cannot set Endpoint Address for Unknown Port" + portName);
        }
    }

    /**
    * Set the endpoint address for the specified port name.
    */
    public void setEndpointAddress(javax.xml.namespace.QName portName, java.lang.String address) throws javax.xml.rpc.ServiceException {
        setEndpointAddress(portName.getLocalPart(), address);
    }

}
