/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.tags;

/**
 * This tag sets in the form the parameters needed by the lookups to function
 * properly and other things
 * @todo reorganize with other similar tags
 * @author salerno
 */
public class ActionUrlTag extends AbstractStandardTag {
	private static final long serialVersionUID = -2172937239160920606L;

	protected StringBuffer getHtmlStream() throws Exception {

		StringBuffer urlHiddenField = new StringBuffer();

		// These tell the lookups where we came from
		if (_actionName != null && _actionName.trim().length() > 0) {
			urlHiddenField.append(getHiddenField("CURRENT_ACTION_NAME", "" + _actionName));
		} else {
			urlHiddenField.append(getHiddenField("CURRENT_PAGE", "" + _responseContainer.getBusinessName()));
			urlHiddenField.append(getHiddenField("CURRENT_MODULE", "" + _moduleName));
		}

		if (_serviceRequest != null) {
			// this tells if we came from a lookup and which one
			if (_serviceRequest.getAttribute("LOOKUPNAME") != null) {
				urlHiddenField.append(getHiddenField("LOOKUPNAME", "" + _serviceRequest.getAttribute("LOOKUPNAME")));
			}

			// this tells to the list to show the select with which we can go back to the calling page
			if (_serviceRequest.getAttribute("SHOWLOOKUP") != null) {
				urlHiddenField.append(getHiddenField("SHOWLOOKUP", "" + _serviceRequest.getAttribute("SHOWLOOKUP")));
			}
		} // if (_serviceRequest!=null)

		return urlHiddenField;
	}
}
