/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.tags;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanAttribute;
import it.eng.spago.tracing.TracerSingleton;

import java.util.List;

import javax.servlet.jsp.JspException;

public class ComboTag extends AbstractStandardTag {

	private static final long serialVersionUID = 1L;
    protected String _actionName = null;
    protected String _moduleName = null;
    protected Boolean _blankValue = null ;
    protected String _value = null;
    protected String _label = null;
    protected String _style = null;
	protected String _selectAction = null;
	protected String _name = null;

    
    
	protected StringBuffer _htmlStream = null ;
    protected SourceBean _layout = null;
    protected String _providerURL = null;
    protected String _serviceName = null;
    protected SourceBean _content = null;

	/* (non-Javadoc)
	 * @see it.arca.common.tags.AbstractArcaTag#getHtmlStream()
	 */
	protected StringBuffer getHtmlStream() throws Exception {
        _htmlStream = new StringBuffer();

        // Inizializzazione TAG
        initTag() ;

        makeCombo() ;
/* Fatto dalla RestoreTag        
        //Ciclo per riproporre indietro i valori nella request
        // utilizzato per azioni dinamiche tra combo
		List requestList = _serviceRequest.getContainedAttributes() ;
		String excludeKeyword = "MODULE,PAGE,NEW_SESSION" ; 
		for (int i=0; requestList != null && i < requestList.size() ; i++) {
			SourceBeanAttribute attr = (SourceBeanAttribute)requestList.get(i) ;
			if (excludeKeyword.indexOf(attr.getKey()) == -1)
				_serviceResponse.setAttribute(attr.getKey(), attr.getValue()) ;
		}
*/         
        
        return _htmlStream;
	}
	
	/**
	 * 
	 * @throws Exception
	 */
	private void makeCombo() throws Exception {
        _htmlStream.append("<select class=\"combo\" name=\""+_name+"\" ");

		if (_style != null && _style.length() >0) {
            _htmlStream.append(" style=\"" + _style + "\" ") ;
        }
		if (_selectAction != null && _selectAction.trim().length() > 0) {
            _htmlStream.append(" onchange=\"" +_selectAction + "\" ") ;
		}
        _htmlStream.append(">\n") ;
        
        if (_blankValue.booleanValue()) {
    		_htmlStream.append("\t<option value=\"\"></option>\n") ;
		}
        if (_content != null) {
	        SourceBean rowsBean = (SourceBean) _content.getAttribute("PAGED_LIST.ROWS");
	        if (rowsBean != null) {
	        	String selected ="" ;
	        	String oldValue = (String)_serviceRequest.getAttribute(_name) ;
	        	if (oldValue == null) {
	        		oldValue = (String)_serviceResponse.getAttribute(_name) ;
	        	}
	        	if (oldValue == null)
	        		oldValue = "" ;
	        	
		        List rows = rowsBean.getAttributeAsList("ROW") ;
		        for (int i = 0; i < rows.size(); i++) {
		        	SourceBean rowBean = (SourceBean)rows.get(i) ;
		
		        	String value = (_value != null && _value.trim().length() > 0) ? (String)rowBean.getAttribute(_value) : "" ;
		        	String label = (_label != null && _label.trim().length() > 0) ? (String)rowBean.getAttribute(_label) : "" ;
		        	if (oldValue.equalsIgnoreCase(value)) {
		        		selected = " selected " ;
		        	} else {
		        		selected = " " ;
		        	}
//	        		_htmlStream.append(" selected ") ;
		    		_htmlStream.append("\t<option value=\"" + value + "\" "+ selected+" >") ;
		    		_htmlStream.append(label+"</option>\n") ;
		        }
	        }
        }
	
        _htmlStream.append("</select>\n");
	}
	
	/**
	 * Inizializzazioni: verifica se per Action o Modulo, predispone variabili per il rendenring
	 * @throws JspException
	 */
	protected int initTag() throws JspException {
		if (_actionName != null) {
            _serviceName = _actionName;
            _content = _serviceResponse;
            SourceBean actionBean = (SourceBean) configure.getFilteredSourceBeanAttribute("ACTIONS.ACTION", "NAME", _actionName);
            _layout = (SourceBean) actionBean.getAttribute("CONFIG");
            _providerURL = "ACTION_NAME=" + _actionName + "&";
        } // if (_actionName != null)
        else if (_moduleName != null) {
            _serviceName = _moduleName;
            if (_serviceResponse != null)
            	_content = (SourceBean) _serviceResponse.getAttribute(_moduleName);
            SourceBean moduleBean = (SourceBean) configure.getFilteredSourceBeanAttribute("MODULES.MODULE", "NAME", _moduleName);
            _layout = (SourceBean) moduleBean.getAttribute("CONFIG");
            String pageName = (String) _serviceRequest.getAttribute("PAGE");
            _providerURL = "PAGE=" + pageName + "&MODULE=" + _moduleName + "&";
        } // if (_moduleName != null)
        else {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.CRITICAL,
                "DefaultDetailTag::doStartTag:: service name non specificato !");
            throw new JspException("Business name non specificato !");
        } // if (_content == null)
		
		return 0 ;
	}
	
	/**
	 * Impostata nella JSP: Nome della Action
	 * @param actionName
	 */
    public void setActionName(String actionName) {
        TracerSingleton.log(
            Constants.NOME_MODULO,
            TracerSingleton.DEBUG,
            this.getClass().getName() + "::setActionName: actionName [" + actionName + "]");
        _actionName = actionName;
    } // public void setActionName(String actionName)

    /**
     * Impostata nella JSP: Nome del Modulo
     * @param moduleName
     */
    public void setModuleName(String moduleName) {
        TracerSingleton.log(
            Constants.NOME_MODULO,
            TracerSingleton.DEBUG,
            this.getClass().getName() + "::setModuleName: moduleName [" + moduleName + "]");
        _moduleName = moduleName;
    } // public void setModuleName(String moduleName)

    /**
     * Impostata nella JSP: Se "true" allora inserisce una riga con valore vuoto (default value unselected)
     * @param blankValue
     */
    public void setBlankValue(Boolean blankValue) {
        TracerSingleton.log(
            Constants.NOME_MODULO,
            TracerSingleton.DEBUG,
            this.getClass().getName() + "::setblankValue: blankValue [" + blankValue + "]");
        _blankValue = blankValue;
    } // public void setBlankValue(boolean label)

    /**
     * Impostata nella JSP: Indica il nome dell'attributo contenuto nella collezione ROW da utilizzare per label
     * @param label
     */
    public void setLabel(String label) {
        TracerSingleton.log(
            Constants.NOME_MODULO,
            TracerSingleton.DEBUG,
            this.getClass().getName() + "::setLabel: label [" + label + "]");
        _label = label;
    } // public void setlabel(String label)

    /**
     * Impostata nella JSP: Indica il nome dell'attributo contenuto nella collezione ROW da utilizzare per value
     * @param value
     */
    public void setValue(String value) {
        TracerSingleton.log(
            Constants.NOME_MODULO,
            TracerSingleton.DEBUG,
            this.getClass().getName() + "::setValue: value [" + value + "]");
        _value = value;
    } // public void setValue(String value))


    /**
     * Impostata nella JSP: Attributi di stile per la comboes: "width: 300px"
     * @param moduleName
     */
    public void setStyle(String style) {
        TracerSingleton.log(
            Constants.NOME_MODULO,
            TracerSingleton.DEBUG,
            this.getClass().getName() + "::setStyle: style [" + style + "]");
        _style = style;
    } // public void setStyle(String style)

    /**
	 * Impostata nella JSP: Action da scatenare alla selezione di un elemento della lista 
	 * 
	 * @param name
	 */
	public void setSelectAction(String selectAction) {
		TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG, this.getClass().getName()
				+ "::setSelectAction: selectAction [" + selectAction + "]");
		_selectAction = selectAction;
	}

	/**
	 * Impostata nella JSP: Nome HTML della combo 
	 * 
	 * @param name
	 */
	public void setName(String name) {
		TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG, this.getClass().getName()
				+ "::setName: name [" + name + "]");
		_name = name;
	}
}
