/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.tags;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;

import java.io.IOException;
import java.util.Iterator;
import java.util.List;

/**
 * Adds an include js directive. Loads both publisher-specific scripts and page/action ones
 * @author grassi 
 */
public class JavascriptIncludeTag extends AbstractStandardTag {
	private static final long serialVersionUID = 3913155000071129464L;

	protected StringBuffer getHtmlStream() throws Exception {
		StringBuffer sbuff = new StringBuffer();

		SourceBean resources = (SourceBean) _requestContainer.getAttribute(Constants.RESOURCES);
		
		String stringUrl = getServerUrl() + "/js/" + _responseContainer.getBusinessName() + ".js";
		try {
			java.io.InputStream mys = new java.net.URL(stringUrl).openConnection().getInputStream();
			mys.close();
			sbuff.append("<script type=\"text/javascript\" src=\"" + stringUrl + "\"></script>\r\n");
		} catch (IOException ex) {
		//	; // File da includere non esistente
		//	sbuff.append("<script type=\"text/javascript\">function inizializzaPagina(){ ;}</script>\r\n");
		}
		
		if (resources != null) {
			String rootPath = (String) resources.getAttribute("rootPath");
			
			sbuff.append("<script type=\"text/javascript\">var _resourcesRoot = \""+rootPath+"\";</script>\r\n");
			
			List scripts = resources.getAttributeAsList("SCRIPT");
			SourceBean script;
			boolean isRelativePath = false;
			
			for (Iterator iter = scripts.iterator(); iter.hasNext();) {
				script = (SourceBean) iter.next();
				isRelativePath = script.getAttribute("relative").equals("YES");
				sbuff.append("" + "<script " + "type=\"" + script.getAttribute("type") + "\" " + "src=\"" + ((isRelativePath) ? rootPath : "") + script.getAttribute("src") + "\">" + "</script>" + "\r\n");
			}
			
			sbuff.append("<script type=\"text/javascript\">");
			sbuff.append("$(document).ready(function() {");
			sbuff.append("initPage();");
			sbuff.append("});");
			sbuff.append("</script>");
			
		}

		return sbuff;
	}
}
