/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.tags;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanAttribute;
import it.eng.spago.base.XMLObject;
import it.eng.spago.decorators.AbstractDecorator;
import it.eng.spago.dispatching.service.detail.impl.DelegatedDetailService;
import it.eng.spago.dispatching.service.list.basic.impl.DelegatedBasicListService;
import it.eng.spago.lookup.LookupConfigurator;
import it.eng.spago.message.MessageBundle;
import it.eng.spago.paginator.smart.IFaceListItemAdapter;
import it.eng.spago.tracing.TracerSingleton;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

import javax.servlet.jsp.JspException;

/**
 * Default implementation of the view of a List module/action
 * @author salerno
 */
public class ListTag extends AbstractStandardTag {
	private static final long serialVersionUID = 1L;
	protected IFaceListItemAdapter _adapter = null;
	protected String _serviceName = null;
	//protected List _columns = null;
	protected StringBuffer _htmlStream = new StringBuffer();
	
	public final static String SELECT_CAPTION = "SELECT_CAPTION";
	public final static String CHECKBOX_CAPTION = "CHECKBOX_CAPTION";
	public final static String GENERIC_CAPTION = "CAPTION";
	public final static String DELETE_CAPTION = "DELETE_CAPTION";
	
	private List<Column> columns = null;
	
	public ListTag() {
		super();
	}

	@Override
	protected int initTag() throws JspException {
		if (_layout == null) {
			TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.WARNING, "DefaultDetailTag::doStartTag:: layout nullo");
			return -1;
		}
		return 0;
	}
	
	/**
	 * 
	 */
	protected StringBuffer getHtmlStream() throws Exception {
		List _columns = _layout.getAttributeAsList("COLUMNS.COLUMN");
		// Modifica per evitare l'ingresso ai moduli di dettaglio (non hanno
		// l'attributo COLUMNS
		
		if (_content!=null && (_columns != null) && (_columns.size() > 0)) {
			
			
//			Inizializzo la collection di Column			
			makeColumns(_columns);
//			_htmlStream.append("\t<div>\n");
			_htmlStream.append("<table cellspacing=\"0\" name=\"TB_Detail\" id=\"TB_Detail\" >\r\n");
			
			try {	
				String pageNumberString = (String) _content.getAttribute("PAGED_LIST.PAGE_NUMBER");
				String pagesNumberString = (String) _content.getAttribute("PAGED_LIST.PAGES_NUMBER");
				if (pageNumberString!=null && pagesNumberString!=null) {
					_htmlStream.append("<input type=\"hidden\" name=\"PAGACT\" id=\"PAGACT\" value=\""+ pageNumberString + "\">\n") ;
					_htmlStream.append("<input type=\"hidden\" name=\"PAGMAX\" id=\"PAGMAX\" value=\""+ pagesNumberString + "\">\n") ;

					String rowSize = "0" ;
					SourceBean rowsBean = (SourceBean) _content.getAttribute("PAGED_LIST.ROWS");
					if (rowsBean != null) {
						rowSize = "" + rowsBean.getContainedAttributes().size() ;
					}						
					_htmlStream.append("<input type=\"hidden\" name=\"rowSize\" id=\"rowSize\" value=\""+ rowSize + "\">\n") ;
				}
			} // / try
			catch (NumberFormatException ex) {
				// Evidentemente il chiamante non ha pagine (pagina di dettaglio):
			} // catch (NumberFormatException ex)
			catch (NullPointerException ex) {
				// Evidentemente il chiamante non ha pagine (pagina di dettaglio):
			} // catch (NumberFormatException ex)

			
			
			_htmlStream.append("<tr>\r\n");
			
			
			String innerHtml = "<th id=\"caption"+ _layout.getAttributeAsList("CAPTIONS").size()+"\" />\r\n";
//			Se c' una colonna con filtro, ci va il Wwwwwwwwwwizard
			for (Iterator iter = columns.iterator(); iter.hasNext();) {
				Column element = (Column) iter.next();
				if (element.isNoFilter()) {
					
					//innerHtml = "<th id = \"wizard\" class=\"wizard\" name=\"wizard\" width=\"eval(document.getElementById('TB_Detail').rows(0).cells(0).offsetWidth-4)\" height=\"eval(document.getElementById('TB_Detail').rows(0).cells(0).offsetHeight-4)\" style=\"position: relative; top: 2; left: 2\" alt=\"Wwwwwwwwwwizard.......\" title=\"Wwwwwwwwwwizard.......\" onmouseover=\"javascript:document.getElementById('wizard').className='wizardOver';\" onmouseout=\"javascript:document.getElementById('wizard').className='wizard';\" onclick=\"javascript:WizardArcaStart('site');\" />";
					innerHtml = "<th id = \"wizard\" class=\"wizard\" name=\"wizard\" alt=\"Wwwwwwwwwwizard.......\" onmouseover=\"javascript:document.getElementById('wizard').className='wizardOver';\" onmouseout=\"javascript:document.getElementById('wizard').className='wizard';\" onclick=\"javascript:WizardArcaStart('site');\" title=\"Wwwwwwwwwwizard.......\"> ";
					innerHtml +="<img border=\"0\" alt=\"Wwwwwwwwwwizard.......\" src=\""+getResourcePath()+"/spago/img/trasparente.gif\" width=\"eval(document.getElementById('TB_Detail').rows(0).cells(0).offsetWidth-4)\" height=\"eval(document.getElementById('TB_Detail').rows(0).cells(0).offsetHeight-4)\" style=\"position: relative; top: 2; left: 2\" /></th>";
					break;
				}
			}
			
			_htmlStream.append(innerHtml);
			
			//Stampo la riga di intestazione
			for (Iterator iter = columns.iterator(); iter.hasNext();) {
				Column element = (Column) iter.next();
				element.drawHeader(_htmlStream);
			}

			_htmlStream.append("</tr>\r\n");
			
			
			/**
			 * <tr>
			 * <td><input type="text" name="FILTER_nomeDellaColonna" value="" /></td>
			 * <td><input type="text" name="FILTER_nomeDellaColonna" value="" /></td>
			 * <td><input type="text" name="FILTER_nomeDellaColonna" value="????" /></td>
			 * </tr>
			 */
			_htmlStream.append("<tr id=\"selettori\">\r\n");
//			Stampa la riga di intestazione per i caption //FIXME
			makeIntestazioneCaption() ;

//			Stampa la riga con i campi di filtro/ordinamento
			for (Iterator iter = columns.iterator(); iter.hasNext();) {
				Column element = (Column) iter.next();
				element.drawFilterBox(_htmlStream);
			}
			_htmlStream.append("</tr>\r\n");
//			Stampa le righe			
			makeRows();

			_htmlStream.append("</table>\r\n");
//			_htmlStream.append("</div>\r\n");
			
//			Stampa i campi hidden  //FIXME
			makeHiddenFields() ;
		}

		return _htmlStream;
	}
	
	/**
	 * Prints the table headers row
	 * @throws JspException
	 */
	protected void makeColumns(List _columns) throws JspException {
		
		columns = new ArrayList<Column>(_columns.size());
		SourceBean element;
		Column column;
		
		
		/* Calcola il numero delle colonne in accordo anche ai possibili colspan */
		int colNumber = _columns.size() ;
		String colspan ;
		for (int i = 0; i < _columns.size(); i++) {
			colspan = (String)((SourceBean)_columns.get(i)).getAttribute("colspan") ;
			if (colspan != null && colspan.trim().length() > 0) {
				int spanValue = Integer.parseInt(colspan) ;
				if (spanValue > 0)
					colNumber -= (spanValue -1) ;
			}
		}
	
		int prevColspan = -1 ;
		int prevTitle = -1;
		int countColspan = 0;
		
		boolean colspanned = false;
		
		for (int i = 0; i < _columns.size(); i++) {
			element = (SourceBean) _columns.get(i);		
			column = new Column(pageContext,element);
			
			/* Associa il colspan per le intestazioni delle colonne */
			String columnWidth = (String) (element).getAttribute("WIDTH");
			
			String colspanStr = (String) (element).getAttribute("COLSPAN","1");

			int curColspan = Integer.parseInt(colspanStr);
			
			if (curColspan>1) {
				prevTitle = i;
				countColspan = curColspan;
				colspanned = false;
			} else {
				
				if (prevTitle>=0 &&  prevTitle < columns.size()) {
					columns.get(prevTitle).resizeTitle(columnWidth);	
				}
				
			}
			
			
			if (countColspan==0) {
				colspanned = false;
				prevTitle = -1;
			}
			countColspan--;
			
			
			if (prevColspan  <= 1) { 
				if (columnWidth != null && columnWidth.trim().length() > 0) {
					//columnWidth = "width=\"" + columnWidth + "\"" ;
				} else if (colNumber > 0){
					
					if (colNumber == 6) {
						columnWidth = "17%";//XXX 
					} else 
					columnWidth = 100/(colNumber) + "%" ;
				}
			}

			column.setPrevColspan(prevColspan);
			column.setColspanned(colspanned);
			column.setWidth(columnWidth);
			column.setTitleWidth(columnWidth);
			column.setCurColspan(curColspan);
			
			columns.add(column);
			
			
			if (colspanStr!=null && !"".equals(colspanStr) && Integer.parseInt(colspanStr)>1) {
				colspanned = true;
			}
			
			prevColspan = curColspan;
		}

	} // protected void makeColumns() throws JspException


	/**
	 * Prepares the caption's column
	 * @throws JspException
	 */
	protected void makeIntestazioneCaption()  throws JspException{
		_htmlStream.append("<td>\n");
		if (_layout.getAttribute("CAPTIONS.SELECT_CAPTION") != null) {
			_htmlStream.append("\t<img class=\"trasparente\" src=\""+getResourcePath()+"/spago/img/trasparente.gif\" alt=\"dettaglio\"/>\n");
		}

		SourceBean deleteCaption = (SourceBean) _layout.getAttribute("CAPTIONS.DELETE_CAPTION");
		if (deleteCaption != null) {
			
			SourceBean headerDelete = (SourceBean)deleteCaption.getAttribute("HEADER_DELETE") ;
			if (headerDelete != null) {
				List parameters = headerDelete.getAttributeAsList("PARAMETER");
				StringBuffer parametersStr = getParametersList(parameters, null);
				if (_actionName != null && _actionName.length() > 0) {
					parametersStr.append("ACTION_NAME="+_actionName) ;
				} else {
					parametersStr.append("PAGE="+_pageName) ;
					if (_moduleName != null && _moduleName.length() > 0) {
						parametersStr.append("&MODULE="+_moduleName) ;
					}
				}
				parametersStr.append("&"+ getMessage(DELETE_CAPTION)) ;
				String label = (String) deleteCaption.getAttribute("LABEL", getDefaultLabel(DELETE_CAPTION));
				String styleClass = (String) deleteCaption.getAttribute("CLASS", getStyleClass(DELETE_CAPTION));
				_htmlStream.append("<a href=\"#\" class=\""+ styleClass +"\" onclick=\"");
				_htmlStream.append("goConfirm('" 
						+ getQuestion(DELETE_CAPTION) + "','"	// Question 
						+ parametersStr.toString() + "',"	// url
						+ "'TRUE'," 					// alertFlag
						+ "'FALSE'," 					// ajaxFlag
						+ "'"+_form+"'," 					// formName
						+ "'PLAIN'); return false;");	// usaPopUp
				_htmlStream.append("\"><img class=\"trasparente\" src=\""+getResourcePath()+"/spago/img/trasparente.gif\" alt=\"" + label + "\"/></a>\n");
			} else {
				_htmlStream.append("\t<img class=\"trasparente\" src=\""+getResourcePath()+"/spago/img/trasparente.gif\" alt=\"elimina\"/>\n");
			}
		}
		SourceBean checkboxCaption = (SourceBean) _layout.getAttribute("CAPTIONS.CHECKBOX_CAPTION");
		if (checkboxCaption != null) {
			SourceBean headerCheckbox = (SourceBean)checkboxCaption.getAttribute("HEADER_CHECKBOX") ;
			if (headerCheckbox != null) {
				headerCheckbox.setDefaultPath("DEFAULT."+getRequestType()+".CONFIG.CAPTIONS.CHECKBOX_CAPTION.HEADER_CHECKBOX");
				String onClick = (String)headerCheckbox.getAttributeWithDefault("onClick") ;
				String nomeCheckBox = (String)headerCheckbox.getAttributeWithDefault("name") ;
				String value =(String)_content.getAttribute(nomeCheckBox, "N") ;
				String checked = "" ;
				if (value.equalsIgnoreCase("Y"))
					checked = "checked" ;
				
				_htmlStream.append("\t<input name=\"" + nomeCheckBox + "\" type=\"checkbox\" " + checked + " onclick=\"" + onClick + "\"" + ">\n");
				
			} else {
				_htmlStream.append("\t<img class=\"trasparente\" src=\""+getResourcePath()+"/spago/img/trasparente.gif\" alt=\"seleziona/deseleziona tutto\"/>\n");
			}
		}

		for (Object genCap : _layout.getAttributeAsList("CAPTIONS.CAPTION")) {
			_htmlStream.append("\t<img class=\"trasparente\" src=\""+getResourcePath()+"/spago/img/trasparente.gif\" alt=\"caption\"/>\n");
		}
		_htmlStream.append("</td>\n");
	}
	
	/**
	 * Saves LIST_QUERY hidden parameters for reload actions
	 * @throws JspException
	 */
	protected void makeHiddenFields() throws JspException {
		// Handle Basic Module/Action types
		SourceBean queryBean = (SourceBean)_layout.getAttribute("QUERIES.SELECT_QUERY");
		if (queryBean == null) {
			// Handle Smart Module/Action types
			queryBean = (SourceBean)_layout.getAttribute("ROW_PROVIDER.CONFIG.LIST_QUERY");
		}
		if (queryBean != null) {
			// Chiude il div Site e ne apre uno nuovo
			// _htmlStream.append("</div><div id=\"nascosto\">\n") ;
			addParameterHiddenFields(queryBean.getAttributeAsList("PARAMETER")) ;
			addParameterHiddenFields(queryBean.getAttributeAsList("FILTER_PARAMETER")) ;
		}
		
		//if (isLookupAction()) { 
		//	_htmlStream.append(getHiddenField("SHOWLOOKUP", ""+_requestContainer.getServiceRequest().getAttribute("SHOWLOOKUP"))) ;
		//	//_htmlStream.append(getHiddenField("RET_PAGE", ""+_requestContainer.getServiceRequest().getAttribute("RET_PAGE"))) ;
		//	//_htmlStream.append(getHiddenField("RET_MOD", ""+_requestContainer.getServiceRequest().getAttribute("RET_MOD"))) ;
		//}
		
		addHiddens() ;
	}

	/**
	 * Prints hidden input fields
	 *   es:  <HIDDENS>
	 *            <PARAMETER ...>
	 *        </HIDDENS>
	 */
	private void addHiddens() {
		for (Object hid : _layout.getAttributeAsList("HIDDENS.PARAMETER")) {
			String parameterName = (String)((SourceBean)hid).getAttribute("NAME") ;
			Object parameterValue = getParameterValue((SourceBean)hid)  ;
			_htmlStream.append(getHiddenField(parameterName, parameterValue.toString())) ;
		}
	}
	
	/**
	 * Costruisce i campi hidden per la lista dei parametri passati
	 * @param parameterList
	 */
	private void addParameterHiddenFields(List parameterList)  {
		if (parameterList == null)
			return ;
		Iterator it = parameterList.iterator() ;
		SourceBean parameterBean ;
		String parameterName,  parameterScope ;
		Object parameterValue ;
		while (it.hasNext()) {
			parameterBean = (SourceBean)it.next() ;
			parameterScope =  (String)parameterBean.getAttribute("scope") ;
			// I paramteri con scope SERVICE_REQUEST vanno salvati nel form per il tasto RICARICA
			if (parameterScope != null && parameterScope.trim().equalsIgnoreCase("SERVICE_REQUEST")) {
				parameterName = ((String)parameterBean.getAttribute("value")).toUpperCase() ;
				// Se il valore contiene la chiave "FILTER_" significa che questo campo
				// non va trattato in quanto gi presente negli appositi campi in testa alle colonne
				if (parameterName.indexOf("FILTER_") < 0) {
					if (parameterName.indexOf("TYPED_SERVICE_REQUEST.") >= 0) {
						parameterName = parameterName.substring(parameterName.indexOf("TYPED_SERVICE_REQUEST.")+22) ;
					}
					parameterValue = _requestContainer.getServiceRequest().getAttribute(parameterName);
					if (parameterValue != null && parameterValue.toString().trim().length() > 0) {
						// Va tolta l'eventuale busta "TYPED_SERVICE_REQUEST."
						_htmlStream.append("\n\t\t"+getHiddenField(parameterName, parameterValue.toString())) ;
					}
				}
			}
		}
		_htmlStream.append("\n") ;
	}

	/**
	 * Prints the rows
	 * @throws JspException
	 */
	protected void makeRows() throws JspException {
		SourceBean selectCaption = (SourceBean) _layout.getAttribute("CAPTIONS.SELECT_CAPTION");
		SourceBean deleteCaption = (SourceBean) _layout.getAttribute("CAPTIONS.DELETE_CAPTION");
		SourceBean checkboxCaption = (SourceBean) _layout.getAttribute("CAPTIONS.CHECKBOX_CAPTION");
		List genericCaption = _layout.getAttributeAsList("CAPTIONS.CAPTION");

		// Prepara la caption per la lookup
		boolean makeLookupCaption = true;
		for(SourceBean capt : (List<SourceBean>) genericCaption) {
			String classe = (String) capt.getAttributeWithDefault("CLASS");
			if (classe!=null && classe.equalsIgnoreCase("SCEGLI")) 
				makeLookupCaption = false;
		}
		String showLookup = (String)_serviceRequest.getAttribute("SHOWLOOKUP");
		if(showLookup!=null && showLookup.equalsIgnoreCase("TRUE") && makeLookupCaption) {
			String lookupName = (String)_serviceRequest.getAttribute("LOOKUPNAME");
			genericCaption.add(LookupConfigurator.returnCaption(lookupName));
		}
		
		if (selectCaption!=null) {
			genericCaption.add(selectCaption);	
		}
		
		if (deleteCaption!=null) {
			genericCaption.add(deleteCaption);
		}
		SourceBean rowsBean = (SourceBean) _content.getAttribute("PAGED_LIST.ROWS");
		if (rowsBean == null)
			return;
		List rows = rowsBean.getContainedAttributes();
		if (rows != null) {
/*			String flash = (String) _serviceRequest.getAttribute("FLASH");
			int flashRow = -1;
			if (flash != null) {
				flashRow = Integer.parseInt(flash);
			}
*/
			SourceBean row = null;
			//AbstractDecorator[] decorator = new AbstractDecorator[0] ;
			for (int i = 0; i < rows.size(); i++) {
				String rowStyle = (i % 2 == 0) ? "pari" : "dispari";
/* 				if (flashRow == i) {
					rowStyle = "listasel";
				}
*/
				Object rowObject = ((SourceBeanAttribute) rows.get(i)).getValue();
				if (_adapter != null)
					row = _adapter.adapt(rowObject);
				else if (rowObject instanceof SourceBean)
					row = (SourceBean) rowObject;
				else if (rowObject instanceof XMLObject) {
					try {
						row = SourceBean.fromXMLString(((XMLObject) rowObject).toXML(false));
					} // try
					catch (Exception ex) {
						TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.CRITICAL,
								"DefaultListTag::makeRows: oggetto riga non valido", ex);
						throw new JspException(ex);
					} // catch (Exception ex)
				} // if (rowObject instanceof XMLObject)
				else {
					TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.CRITICAL,
							"DefaultListTag::makeRows: oggetto riga non valido !");
					throw new JspException("Oggetto riga non valido");
				} // if (rowObject instanceof XMLObject) else
				_htmlStream.append("<tr class=\"" + rowStyle + "\">\n");
				_htmlStream.append("<td>\n");
				// _htmlStream.append("<table border=0 cellpadding=0
				// cellspacing=0><tr>\n");
				
		
				makeGenericCaption(genericCaption, row, i);
				//makeCaption(selectCaption, row, i, SELECT_CAPTION);
				//makeCaption(deleteCaption, row, i, DELETE_CAPTION);
				makeCaptionCheckBox(checkboxCaption, row);
				// _htmlStream.append("</tr></table>\n");
				_htmlStream.append("</td>\n");
				
				
				for (Iterator iter = columns.iterator(); iter.hasNext();) {
					Column element = (Column) iter.next();
					
					if (element.getType() != null && element.getType().equalsIgnoreCase("checkbox")) {
						makeCheckBoxes(_htmlStream,element, row, i);
					} else  {
						element.drawRow(_htmlStream, row, i);
					}
				}
				_htmlStream.append("</tr>\n");
			} // for (int j = 0; j < rows.size(); j++)
		}// if (rows != null)
	}
	
	/**
	 * Prints checkbox's rows
	 * @todo move this into <code>Column</code>
	 * @param bufferToWriteInto
	 * @param column
	 * @param rowBean
	 * @param rowIndex
	 */
	protected void makeCheckBoxes(StringBuffer bufferToWriteInto,Column column, SourceBean rowBean, int rowIndex) {	
		String protetto = "return false";
		String nomeCheckBox = column.getName() + "_" + rowIndex + "_" + _moduleName; // Default
		Object fieldObject = rowBean.getAttribute(column.getName());
		
		AbstractDecorator decoratorName = column.getDecorator();
		String field = fieldFormat(fieldObject,decoratorName);
		String checked = " " ;
		if (field != null) {
			String trimField = field.trim() ;
			if (trimField.equalsIgnoreCase("S") ||
				trimField.equalsIgnoreCase("Y") ||
				trimField.equalsIgnoreCase("TRUE"))
				checked = " checked " ;
		}
		// Name
		if (column.getKeyName() != null && column.getKeyName().length() > 0) {
			nomeCheckBox = "" + rowBean.getAttribute(column.getKeyName());
		}
		if (!column.isReadonly()) {
			bufferToWriteInto.append("      <td><input name=\"" + nomeCheckBox + "\" type=\"" + column.getType() + "\""
					+ checked + "></TD>\n");
		} else {
			bufferToWriteInto.append("      <td align=\"center\"><input name=\"" + nomeCheckBox + "\" type=\""
					+ column.getType() + "\"" + checked
					+ " onclick=\"" + protetto + "\"" + "></td>\n");
		}
	}
	/**
	 * 
	 * @param caption
	 * @param rowBean
	 */
	private void makeCaptionCheckBox(SourceBean caption, SourceBean rowBean) {
		if (caption != null) {

			boolean isEnabled = testConditionParameter(caption, rowBean) ;
			if (! isEnabled) {
				String disableImage = (String)caption.getAttribute("disableImage");
				String altMessage = (String)rowBean.getAttribute("DISABLE_MESSAGE", "Riga non selezionabile");
				_htmlStream.append("<img src=\"" + disableImage + "\" alt=\"" + altMessage + "\">") ;
			} else {
				String columnValueName = (String) caption.getAttribute("columnValueName"); // es: sel
				String columnnKeyName = (String) caption.getAttribute("columnnKeyName"); // es: nExec
				String checkBoxName = ""+rowBean.getAttribute(columnnKeyName) ;
				String checkBoxValue = ""+rowBean.getAttribute(columnValueName) ;

				_htmlStream.append("      <input name=\"" + checkBoxName + "\" type=\"checkbox\" ") ;
				if (checkBoxValue.equalsIgnoreCase("Y") || checkBoxValue.equalsIgnoreCase("S"))
					_htmlStream.append(" checked ") ;
				String onclick = (String)caption.getAttribute("onclick") ;
				if (onclick != null && onclick.trim().length() > 0)
					_htmlStream.append(" onclick=\""+onclick +"\" ") ;
				_htmlStream.append(" >\n") ;
			}
		}
	}
	
	/**
	 * Make all defined Caption for generic Action
	 * 
	 * @param genericCaption
	 * @param rowBean
	 * @throws JspException
	 */
	private void makeGenericCaption(List captionList, SourceBean rowBean, int rowIndex) throws JspException {
//		Collections.sort(captionList,new CaptionComparator());
		for (int j = 0; j < captionList.size(); j++) {
			SourceBean caption = (SourceBean)((SourceBean)captionList.get(j)).cloneObject();
			Caption captionTag = new Caption(pageContext,caption,_form);
			captionTag.drawCaption(_htmlStream, rowBean, rowIndex);
		} // for (int i = 0; i < genericCaption.size(); i++)
	}
	
	/**
	 * Gets default label for captions
	 * @param captionType
	 * @return
	 */
	private String getDefaultLabel(String captionType) {
		if (captionType.equals(SELECT_CAPTION))
			return MessageBundle.getMessage(MSG_CAPTION_SELECT_LABEL) ;
		if (captionType.equals(DELETE_CAPTION))
			return MessageBundle.getMessage(MSG_CAPTION_DELETE_LABEL) ;
		if (captionType.equals(CHECKBOX_CAPTION))
			return MessageBundle.getMessage(MSG_CAPTION_CHECKBOX_SEL) ;
		
		return MessageBundle.getMessage(MSG_CAPTION_GENERIC_LABEL) ;
	}
	
	/**
	 * Gets default style for captions
	 * @param captionType
	 * @return
	 */
	private String getStyleClass(String captionType) {
		if (captionType.equals(SELECT_CAPTION))
			return "edit" ;
		if (captionType.equals(DELETE_CAPTION))
			return "delete" ;

		return "generic" ;
	}
	
	/**
	 * Gets default MESSAGE for captions
	 * @param captionType
	 * @return
	 */
	private String getMessage(String captionType) {
		if (captionType.equals(SELECT_CAPTION))
			return "&MESSAGE=" + DelegatedDetailService.DETAIL_SELECT + "&" ;
		if (captionType.equals(DELETE_CAPTION)) {
			return "MESSAGE=" + DelegatedBasicListService.LIST_DELETE + "&NAVIGATOR_DISABLED=TRUE&" ;
/*
			return _providerURL + "MESSAGE=" + DelegatedBasicListService.LIST_DELETE
			    + "&NAVIGATOR_DISABLED=TRUE" ;
			    + "&LIST_PAGE=" + _content.getAttribute("PAGED_LIST.PAGE_NUMBER") ;
*/			    
		}
		
		return  "" ;
	}	
	
	/**
	 * Gets default question for confirm popups
	 * @param captionType
	 * @return
	 */
	private String getQuestion(String captionType) {
		if (captionType.equals(SELECT_CAPTION))
			return MessageBundle.getMessage(MSG_ASK_SELECT) ;
		if (captionType.equals(DELETE_CAPTION))
			return MessageBundle.getMessage(MSG_ASK_DELETE) ;
		
		return MessageBundle.getMessage(MSG_ASK_GENERIC) ;
	}	
	
	/**
	 * 
	 * @param adapterClass
	 */
	public void setAdapterClass(String adapterClass) {
		TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG, "DefaultListTag::setAdapterClass: adapterClass ["
				+ adapterClass + "]");
		if (adapterClass != null) {
			try {
				_adapter = (IFaceListItemAdapter) Class.forName(adapterClass).newInstance();
			} // try
			catch (Exception ex) {
				TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.MAJOR, "DefaultListTag::setAdapterClass:", ex);
			} // catch (Exception ex)
		} // if (adapterClass != null)
	} // public void setAdapterClass(String adapterClass)
	
	/**
	 * Order the captions as requested
	 * @author salerno
	 */
	public class CaptionComparator implements Comparator<SourceBean> {

		public int compare(SourceBean o1, SourceBean o2) {
			
			if (o1.getName().equals(o2.getName())) {
				return 0;
			} else if (o1.getName().equals(SELECT_CAPTION) && o2.getName().equals(DELETE_CAPTION)) {
				return 1;
			} else if (o1.getName().equals(DELETE_CAPTION) && o2.getName().equals(SELECT_CAPTION)) {
				return -1;
			} else if (o1.getName().equals(SELECT_CAPTION) && o2.getName().equals(CHECKBOX_CAPTION)) {
				return 1;
			} else if (o1.getName().equals(CHECKBOX_CAPTION) && o2.getName().equals(SELECT_CAPTION)) {
				return -1;
			} else if (o1.getName().equals(DELETE_CAPTION) && o2.getName().equals(CHECKBOX_CAPTION)) {
				return 1;
			} else if (o1.getName().equals(CHECKBOX_CAPTION) && o2.getName().equals(DELETE_CAPTION)) {
				return -1;
			} else if (o1.getName().equals(GENERIC_CAPTION)){
				return 1;
			} else if (o2.getName().equals(GENERIC_CAPTION)){
				return -1;
			} else {
				return 0;
			}

		}
		
	}
	
	/**
	 * Formatta i campi per la visualizzazione
	 * @param fieldObject
	 * @param decoratorClassName
	 * @return
	 */
	protected String fieldFormat(Object fieldObject, AbstractDecorator decorator) {
		String field = "&nbsp;";
		if (fieldObject != null) {
			if (fieldObject instanceof BigDecimal)
				field = ((BigDecimal)fieldObject).toPlainString() ;
			else
				field = fieldObject.toString();
			if (decorator != null) {
				try {
//					Class thisClass = Class.forName(decoratorClassName);
//					Object iClass = thisClass.newInstance();
//					Class[] parameterTypes = new Class[] { String.class };
//					Object[] arguments = new Object[] { field };
//					Method thisMethod = thisClass.getDeclaredMethod("decorate", parameterTypes);
//					field = (String) thisMethod.invoke(iClass, arguments);
					field = decorator.decorate(fieldObject);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		return field;
	}
}