/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.tags;

import it.eng.spago.base.SourceBeanAttribute;
import java.util.Iterator;
import java.util.List;

public class SaveRequestTag extends AbstractStandardTag {
	private static final long serialVersionUID = -5317853272899078189L;
	StringBuffer _htmlStream = null ;
	
	public SaveRequestTag() {
		super() ;
	}
	
	protected StringBuffer getHtmlStream() throws Exception {
		_htmlStream = new StringBuffer() ;
		saveRequestParameter() ;
		return _htmlStream;
	}	
	/**
	 * Salva in campi hidden i parametri ricevuti nella request
	 * @throws Exception
	 */
	protected void saveRequestParameter() throws Exception {
		List listaRequest =  _serviceRequest.getContainedAttributes() ;
		if (listaRequest != null) {
			Iterator iter = listaRequest.iterator() ;
			String excludeKey = "ACTION_NAME,MODULE,PAGE,NAVIGATOR_DISABLED,AJAX,MESSAGE" ;
			       excludeKey += ",ENABLE_PARAMETER,FLASH,NEW_SESSION,SPAGO_TOKEN,LIST_PAGE" ;
			       excludeKey += ",DETAIL_NEW,DETAIL_INSERT,DETAIL_SELECT,DETAIL_UPDATE,SERVICE_MODE" ;
			       excludeKey += ",INSERT,UPDATE,SELECT,DELETE,TYPED_SERVICE_REQUEST" ;
			String key, value ;
			while (iter.hasNext()) {
				Object obj = iter.next() ;
				if (obj instanceof SourceBeanAttribute) {
					key = ((SourceBeanAttribute)obj).getKey().toUpperCase() ;
					if (excludeKey.indexOf(key) == -1) {
						value = ((SourceBeanAttribute)obj).getValue().toString().trim() ;
						if (value.length() > 0)
							_htmlStream.append("\n<input type=\"hidden\" name=\""+ key+"\" id=\""+key+"\" value=\""+value+"\">") ;
					}
				}
			}
		}
	}

}
