/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.tags;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;

import javax.servlet.jsp.JspException;

/**
 * Prints the control buttons for the ListTag. Needs to be used in correlation with a paged row provider
 * @author salerno
 */
public class Slider extends AbstractStandardTag {
	
	private static final long serialVersionUID = -5146192688133361672L;
	
	private String styleClass;
	
	public void setStyleClass(String styleClass) {
		this.styleClass = styleClass;
	}

	/**
	 * @override
	 */
	protected StringBuffer getHtmlStream() throws Exception {
		StringBuffer htmlStream = new StringBuffer();
		if (_content != null) // Quando il servizio non viene eseguito (Es: validationError)
			makeNavigationButton(htmlStream);

		return htmlStream;
	}
	
	/**
	 * Draws the slider buttons
	 * <td class="paginaprima" onmouseover="this.className='paginaprimaOver'" onmouseout="this.className='paginaprima'"><img border="0" src="/img/trasparente.gif" alt="VAI ALLA PRIMA PAGINA" onclick="xxx"></td>
	 * <td class="paginaprecedente" onmouseover="this.className='paginaprecedenteOver'" onmouseout="this.className='paginaprecedente'"><img border="0" src="/img/trasparente.gif" alt="VAI ALLA PAGINA PRECEDENTE" onclick="xxx"></td>
	 * <td><input type="text" id="paginatore" class="paginatore" value="1/10" size="100%"></td>
	 * <td class="paginaspecifica" onmouseover="this.className='paginaspecificaOver'" onmouseout="this.className='paginaspecifica'"><img border="0" src="/img/trasparente.gif" alt="VAI ALLA PAGINA INDICATA" onclick="xxx"></td>
	 * <td class="paginasuccessiva" onmouseover="this.className='paginasuccessivaOver'" onmouseout="this.className='paginasuccessiva'"><img border="0" src="/img/trasparente.gif" alt="VAI ALLA PAGINA SUCCESSIVA" onclick="xxx"></td>
	 * <td class="paginaultima" onmouseover="this.className='paginaultimaOver'" onmouseout="this.className='paginaultima'"><img border="0" src="/img/trasparente.gif" alt="VAI ALL'ULTIMA PAGINA" onclick="xxx"></td>
	 * 
	 * @param htmlStream
	 * @throws JspException
	 */
	protected void makeNavigationButton(StringBuffer htmlStream) throws JspException {
		int pagesNumber = 1, pageNumber = 1, prevPage = 1, nextPage=1;
		
		htmlStream.append("<div id=\""+id+"\" class=\""+styleClass+"\" >");
		htmlStream.append("<table>");
		htmlStream.append("<tr>");
		
		String pageNumberString = "",pagesNumberString= "",pageSizeString= "";
		
		try {
			pageNumberString  = (String) _content.getAttribute("PAGED_LIST.PAGE_NUMBER","1");
			if (pageNumberString.trim().length() > 0)
				pageNumber = Integer.parseInt(pageNumberString);
				
			pagesNumberString = (String) _content.getAttribute("PAGED_LIST.PAGES_NUMBER","1");
			if (pagesNumberString.trim().length() > 0)
				pagesNumber = Integer.parseInt(pagesNumberString);

			pageSizeString    = (String) _content.getAttribute("PAGED_LIST.PAGE_SIZE","");			

			prevPage = pageNumber - 1;
			if (prevPage < 1)
				prevPage = 1;
			nextPage = pageNumber + 1;
			if (nextPage > pagesNumber)
				nextPage = pagesNumber;

			//htmlStream.append("<input type=\"hidden\" name=\"PAGACT\" id=\"PAGACT\" value=\""+ pageNumber + "\">\n") ;
			//htmlStream.append("<input type=\"hidden\" name=\"PAGMAX\" id=\"PAGMAX\" value=\""+ pagesNumber + "\">\n") ;

		} // / try
		catch (NumberFormatException ex) {
			// Evidentemente il chiamante non ha pagine (pagina di dettaglio):
		} // catch (NumberFormatException ex)
		catch (NullPointerException ex) {
			// Evidentemente il chiamante non ha pagine (pagina di dettaglio):
		} // catch (NumberFormatException ex)
		
		
		
		htmlStream.append(getHtml4Navigation(pageNumber>1, "paginaprima", "VAI ALLA PRIMA PAGINA", "LIST_FIRST", "onclick=\"javascript:document.getElementById('paginatore"+_form+"').value='1';if (verificaPaginatore(this,'"+_form+"'))" ));
		htmlStream.append(getHtml4Navigation(pageNumber>1, "paginaprecedente", "VAI A PAGINA "+prevPage,"LIST_PAGE&LIST_PAGE="+prevPage+"", "onclick=\"javascript:document.getElementById('paginatore"+_form+"').value='"+prevPage+"';if (verificaPaginatore(this,'"+_form+"'))" ));
		htmlStream.append(getHtml4Navigation(pagesNumber>pageNumber, "paginasuccessiva", "VAI A PAGINA "+nextPage,"LIST_PAGE&LIST_PAGE="+nextPage+"", "onclick=\"javascript:document.getElementById('paginatore"+_form+"').value='"+nextPage+"';if (verificaPaginatore(this,'"+_form+"'))" ));
		htmlStream.append(getHtml4Navigation(pagesNumber>pageNumber, "paginaultima", "VAI ALL'ULTIMA PAGINA", "LIST_PAGE&LIST_PAGE="+pagesNumber+"", "onclick=\"javascript:document.getElementById('paginatore"+_form+"').value='"+pagesNumber+"';if (verificaPaginatore(this,'"+_form+"'))" ));

		if(pagesNumber>1)	htmlStream.append("<td class=\"iPage\"><input type=\"text\" id=\"paginatore"+_form+"\" name=\"paginatore\" class=\"iPage\" value=\"" 
												+ pageNumber + " di " + pagesNumber
												+ "\" size=\"15%\">"
												+"</td>\n");
		else				htmlStream.append("<td class=\"iPage\"><input type=\"text\" id=\"paginatore"+_form+"\" name=\"paginatore\" class=\"iPage\" value=\"" 
												+ "\" size=\"15%\" "
												+ "readonly disabled>"
												+"</td>\n");

		htmlStream.append(getHtml4Navigation(pagesNumber>1, "paginaspecifica", "VAI A PAGINA ", "LIST_PAGE&LIST_PAGE='+document.getElementById('paginatore"+_form+"').value+'", "onclick=\"javascript:if (verificaPaginatore(this,'"+_form+"'))" ));
		
		htmlStream.append("<td class=\"rownum\"><input class=\"iPage\" type=\"text\" id=\"PAGE_SIZE"+_form+"\" name=\"PAGE_SIZE"+_form+"\" value=\""+pageSizeString+"\" max_length=\"5\" size=\"3\"></td>");	
		
		htmlStream.append("</tr>");
		htmlStream.append("</table>");
		htmlStream.append("</div>");
	}

	
	/**
	 * Prints a button
	 * @param enable
	 * @param className
	 * @param alt
	 * @param message
	 * @param targetPage
	 * @return
	 */
	private String getHtml4Navigation(boolean enable, String className, String alt, String message, String javascript) {
		String html = "" ;
		
		if (enable) {
			html ="<td class=\"" + className + "\" "
			+ "onmouseover=\"this.className='" + className + "Over'\" "
			+ "onmouseout=\"this.className='" + className + "'\"><img border=\"0\" "
			+ "src=\""+getResourcePath()+"/spago/img/trasparente.gif\" "
			+ "alt=\"" + alt + "\" "
			+ "title=\"" + alt + "\" "
			+ javascript
			+ "callPagination('"+_pageName+"','" + message + "','"+_form+"');\""													
			+"></td>\n";
		} else {
			html = "<td class=\"" + className + "Disabled\">"
			+ "<img border=\"0\" "
			+ "src=\""+getResourcePath()+"/spago/img/trasparente.gif\" "
			+"></td>\n" ;
		}
		
		return html ;
	}

}
