/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/

package it.eng.spago.tags;

import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.SessionContainer;
import it.eng.spago.presentation.Publisher;

import javax.servlet.jsp.JspException;

/**
 * 
 * This class generate the identifier for storing suspend-resume containers. The suspend resume id must be
 * generated in publishers (for example JSP pages ) because the containers that are used to suspend the containers
 * need to be bound to publisher.
 *  
 * @author Zoppello
 *
 */
public class SuspendResumeIdGenerator {
	public static String SUSPEND_RESUME_ID = "SUSPEND_RESUME_ID" ;
	
	public static String getSuspendResumeId(RequestContainer requestContainer, ResponseContainer responseContainer) throws JspException {
		return getSuspendResumeId(requestContainer) ;
	}
	
	/**
	 * Salva l'ID corrente nei dati persistenti di sessione
	 * @param requestContainer
	 * @param suspendResumeId
	 */
	public static void setSuspendResumeId(RequestContainer requestContainer, String suspendResumeId) {
		SessionContainer permContainer = requestContainer.getSessionContainer().getPermanentContainer() ;
		permContainer.delAttribute(SUSPEND_RESUME_ID) ;
		permContainer.setAttribute(SUSPEND_RESUME_ID, suspendResumeId) ;
	}
	
	public static String getSuspendResumeId(RequestContainer requestContainer) {
		SessionContainer permContainer = requestContainer.getSessionContainer().getPermanentContainer() ;
		return (String)permContainer.getAttribute(SUSPEND_RESUME_ID) ;
	}

}
