/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.tags;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.tracing.TracerSingleton;
import it.eng.spago.util.ContextScooping;
import it.eng.spago.util.QueryParameter;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;

/**
 * Questo tag visualizza per le PAGE che lo prevedono una riga di linguette che
 * possono richiamare MODULE definiti nella PAGE stessa
 * 
 * @author salerno
 * 
 */
public class TabContainerTag extends AbstractStandardTag {
	private static final long serialVersionUID = 1L;

	@Override
	protected StringBuffer getHtmlStream() throws Exception {

		SourceBean pageBean = (SourceBean) configure.getFilteredSourceBeanAttribute("PAGES.PAGE", "NAME", _pageName);

		if (pageBean != null) {
			try {

				StringBuffer sbuff = new StringBuffer();

				StringBuffer scripts = new StringBuffer();

				List<SourceBean> tabs = pageBean.getAttributeAsList("TABS.TAB");
				
				
				for (Iterator<SourceBean> iter = tabs.iterator(); iter.hasNext();) {
					SourceBean object = iter.next();
					if (!object.getAttribute("af_form","f1").equals(_form)) {
						iter.remove();
					}
				}

				
				if (tabs != null && tabs.size() > 0) {
					
					SourceBean tab;

					StringBuffer onclickFunction = new StringBuffer();
					onclickFunction.append("appendElementToForm('"+_form+"','PAGE','" + _pageName + "');");
					sbuff.append("<table class=\"BANNERTB\" name=\"BANNERTB\" id=\"BANNERTB\" border=0\" cellpadding=\"0\" cellspacing=\"0\" >");
					sbuff.append("\r\n");
					sbuff.append("<tr>");
					sbuff.append("\r\n");
					sbuff.append("<td NOWRAP class=\"BANNERFREEI\">&nbsp;</td>");
					sbuff.append("\r\n");

					// StringBuffer relativeParameters = new StringBuffer();

					String currentPage = _pageName;
					boolean isActive = false;
					boolean hasCurrentModuleTab = false;
					Map<String, String> conditionParameters = new HashMap<String, String>();

					//onclickFunction.append("addToForm('PAGE','" + currentPage + "');");

					for (Iterator iter = tabs.iterator(); iter.hasNext();) {
						tab = (SourceBean) iter.next();

						boolean disable = false;
						// String styleClass;
						List<SourceBean> queryParameters = tab.getAttributeAsList("QUERY_PARAMETER.PARAMETER");
						List<SourceBean> parameters = tab.getAttributeAsList("PARAMETER");
						//List<SourceBean> conditionParameters = tab.getAttributeAsList("CONDITION.PARAMETER");

						String currentModule = new String();

						if (tab.containsAttribute("QUERY_PARAMETER")) {

							SourceBean rowsSourceBean = new SourceBean("ROWS");
							SourceBean rowBean = null;

							for (Iterator iterator = queryParameters.iterator(); iterator.hasNext();) {
								SourceBean element = (SourceBean) iterator.next();
								String name = (String) (element).getAttribute("NAME");
								String scope = (String) element.getAttribute("SCOPE");
								String value = (String) (element).getAttribute("VALUE");
								String parameterValue = null;
								rowBean = new SourceBean("ROW");

								if (!name.equals(value)) {
									parameterValue = (String) ContextScooping.getScopedParameter(_requestContainer, _responseContainer, value, scope, element);
								} else {
									parameterValue = (String) ContextScooping.getScopedParameter(_requestContainer, _responseContainer, name, scope, element);

								}

								if (name != null && parameterValue != null) {
									rowBean.setAttribute(name, parameterValue);
									rowsSourceBean.setAttribute(rowBean);
									//requestParameters.put(name, parameterValue);
									onclickFunction.append("appendElementToForm('"+_form+"','" + name + "','" + parameterValue.trim() + "');");
								}

							}

							SourceBean queryParameterBean = handleLocalParameter((SourceBean) tab.getAttribute("QUERY_PARAMETER"), rowsSourceBean);
							String retriveParameter = QueryParameter.getParametersAsQueryString(_requestContainer, _responseContainer, rowsSourceBean, queryParameterBean);
							// Se non recupero parametri per i QUER_PARAMETER
							// disabilito il check-box
							if (retriveParameter == null || retriveParameter.trim().length() == 0) {
								disable = true;
							}

							if (!disable) {

								StringTokenizer tok = new StringTokenizer(retriveParameter, "&");

								while (tok.hasMoreTokens()) {
									String token = tok.nextToken();

									String name = token.substring(0, token.indexOf("="));
									String value = token.substring(token.indexOf("=") + 1);

									if (name.equals("MODULE")) {
										currentModule = value;

										SourceBean paramBean = new SourceBean("PARAMETER");
										paramBean.setAttribute("NAME", "MODULE");
										paramBean.setAttribute("TYPE", "ABSOLUTE");
										paramBean.setAttribute("VALUE", value);
										paramBean.setAttribute("SCOPE", "");
										parameters.add(paramBean);

									}

								}
							}

						} else {

							for (Iterator iterator = parameters.iterator(); iterator.hasNext();) {
								SourceBean element = (SourceBean) iterator.next();
								if (element.getAttribute("NAME").equals("MODULE") || element.getAttribute("NAME").equals("TAB")) {
									currentModule = ((String) element.getAttribute("VALUE"));
								}
							}

							disable = !testConditionParameter(tab, conditionParameters);

						}

						isActive = _moduleName != null && _moduleName.equalsIgnoreCase(currentModule);

						if (isActive) {
							hasCurrentModuleTab = true;
						}

						StringBuffer onclickFunctionLocal = new StringBuffer();
						onclickFunctionLocal.append("impostaSpecia(this);");

						for (Iterator iterator = parameters.iterator(); iterator.hasNext();) {
							SourceBean element = (SourceBean) iterator.next();

							String name = (String) (element).getAttribute("NAME");

							String scope = (String) (element).getAttribute("SCOPE");
							String value = (String) (element).getAttribute("VALUE");
							String type = (String) (element).getAttribute("TYPE");

							String parameterValue = null;

							if (scope.equals("LOCAL")) {

							} else {

								if (type.equals("ABSOLUTE")) {
									parameterValue = value;

									if (!isActive) {
										onclickFunctionLocal.append("appendElementToForm('"+_form+"','" + name + "','" + parameterValue.trim() + "');");
									}
								} else {

									if (type.equals("RELATIVE")) {

										if (!name.equals(value)) {
											parameterValue = (String) ContextScooping.getScopedParameter(_requestContainer, _responseContainer, value, scope, element);
										} else {
											parameterValue = (String) ContextScooping.getScopedParameter(_requestContainer, _responseContainer, name, scope, element);
										}

										if (parameterValue == null) {// &&
											// persist
											// != null
											// &&
											// persist.equals("TRUE"))
											// {
											parameterValue = (String) ContextScooping.getScopedParameter(_requestContainer, _responseContainer, name, "SERVICE_REQUEST", null);
										}
										// if (!isActive) {
										// requestParameters.put(name,
										// parameterValue);
										// }
									}
									// if (!isActive && parameterValue != null)
									if (parameterValue != null) {
										onclickFunction.append("appendElementToForm('"+_form+"','" + name + "','" + parameterValue.trim() + "');");
									}
								}
							}

						}

						if (isActive) {
							sbuff.append("<td NOWRAP class=\"BANNERONI\">&nbsp;</td>");
							sbuff.append("\r\n");
							onclickFunctionLocal.append("goConfirm('Confermi ?','MODULE="+currentModule+"&NAVIGATOR_DISABLED=TRUE', 'FALSE', 'TRUE','"+_form+"', 'PLAIN');");
							sbuff.append("<td class=\"BANNERON\" NOWRAP onclick=\"" + onclickFunctionLocal + "\" >" + tab.getAttribute("LABEL") + "</td>");
							sbuff.append("\r\n");
							sbuff.append("<input type=\"hidden\" name=\"MODULE\" value=\""+currentModule+"\"/>");
							sbuff.append("<td NOWRAP class=\"BANNERONF\" >&nbsp;</td>");
							sbuff.append("\r\n");
						} else if (!disable) {
							sbuff.append("<td NOWRAP class=\"BANNEROFFI\">&nbsp;</td>");
							sbuff.append("\r\n");
							//onclickFunction.append("document.getElementById('MODULE').value='"+currentModule+"';");

							sbuff.append("<td class=\"BANNEROFF\" NOWRAP  ");

							// onclickFunction.append("appendElement('site','ajax','PubPaginaAjax');");
							// onclickFunction.append("");
							// onclickFunction.append("xmlhttpPost('f1','/Master/servlet/AdapterHTTP');");

							sbuff.append("onmouseover=\"javascript:this.style.cursor='hand'\" onmouseout=\"javascript:this.style.cursor='normal'\"  onclick=\"" +
									//"impostaSpecia(this);" +
									//"addToForm('MODULE','" + currentModule+ "');" +
									onclickFunctionLocal +
										"setCommonParameters('"+_form+"');");
										if (tab.getAttribute("AJAX")==null) {
										
											sbuff.append(""+_form+".submit();");
										
										} else {
											sbuff.append("appendElementToForm('"+_form+"','ajax','" + ((SourceBean)tab.getAttribute("AJAX")).getAttribute("publisher") + "');");
											sbuff.append("xmlhttpPost('"+_form+"', 'AdapterHTTP?');");
										}
							
							sbuff.append("\" >" + tab.getAttribute("LABEL") + "</td>");
							sbuff.append("\r\n");
							sbuff.append("<td NOWRAP class=\"BANNEROFFF\" >&nbsp;</td>");
							sbuff.append("\r\n");
						} else if (disable) {
							sbuff.append("<td NOWRAP class=\"BANNERDISI\">&nbsp;</td>");
							sbuff.append("\r\n");
							sbuff.append("<td NOWRAP class=\"BANNERDIS\">" + tab.getAttribute("LABEL") + "</td>");
							sbuff.append("\r\n");
							sbuff.append("<td NOWRAP class=\"BANNERDISF\" >&nbsp;</td>");
							sbuff.append("\r\n");

						}

					}
					
					for (Iterator iter = conditionParameters.keySet().iterator(); iter.hasNext();) {
						String key = (String)iter.next();
						onclickFunction.append("appendElementToForm(form,'" + key + "','" + conditionParameters.get(key).trim() + "');");
					}

					sbuff.append("<td NOWRAP class=\"BANNERFREE\" align=\"right\">&nbsp;</td>");
					sbuff.append("\r\n");
					sbuff.append("</tr>");
					sbuff.append("\r\n");
					sbuff.append("</table>");
					sbuff.append("\r\n");

					scripts.append("<script language=\"Javascript\" type=\"text/javascript\">");
					scripts.append("\r\n");
					scripts.append("function setCommonParameters(form) {");
					scripts.append("\r\n");
					scripts.append("if (form=='"+_form+"') {");
					scripts.append(onclickFunction);
					scripts.append("}");
					scripts.append("\r\n");
					scripts.append("}");
					scripts.append("\r\n");
					scripts.append("</script>");
					scripts.append("\r\n");

					sbuff.insert(0, scripts.toString());

//					if (hasCurrentModuleTab)
						return sbuff;

				}

			} catch (Exception e) {
				  TracerSingleton.log(Constants.HTTP_CHANNEL, TracerSingleton.MINOR,
		                    "TabContainerTag:getHtmlStream - Error"+e);
			}
		}
		return new StringBuffer();

	}

	/**
	 * Sostitutisce i parametri LOCAL con dei tipi ABSOLUTE valorizzati dalla
	 * riga rowBean
	 * 
	 * @param parameterBean
	 * @param rowBean
	 * @return
	 * @throws Exception
	 */
	private SourceBean handleLocalParameter(SourceBean parameterBean, SourceBean rowBean) throws Exception {
		SourceBean handledBean = new SourceBean(parameterBean);
		handledBean.delAttribute("PARAMETER");

		for (Object par : parameterBean.getAttributeAsList("PARAMETER")) {
			if (((String) ((SourceBean) par).getAttribute("scope")).equalsIgnoreCase("LOCAL")) {
				SourceBean handledPar = new SourceBean("PARAMETER");
				handledPar.setAttribute("scope", "");
				handledPar.setAttribute("type", "ABSOLUTE");
				Object localValue = rowBean.getAttribute((String) ((SourceBean) par).getAttribute("name"));
				handledPar.setAttribute("value", "" + localValue);
				handledBean.setAttribute(handledPar);
			} else {
				handledBean.setAttribute((SourceBean) par);
			}
		}
		return handledBean;
	}

	/**
	 * Valuta l'eventuale condizione impostata tramite: <CONDITION><PARAMETER
	 * name="xxx" value="xxx" scope="xxx" type="xxx" /></CONDITION>
	 * 
	 * Il value nel CONDITION.PARAMETER, pu contenere pi valori separati dalla
	 * virgola (es: value="Y,N")
	 * 
	 * @param bean
	 * @param row
	 * @return
	 */
	private boolean testConditionParameter(SourceBean bean, Map requestParameters) {
		if (bean.containsAttribute("CONDITION.PARAMETER")) {
			SourceBean condition = (SourceBean) bean.getAttribute("CONDITION.PARAMETER");
			String name = (String) condition.getAttribute("NAME");

			String value = getParameterValue(condition);
			String conditionValues = (String) condition.getAttribute("VALUE");

			requestParameters.put(name, value);

			if (conditionValues != null && value != null) {
				value = value.toUpperCase();
				conditionValues = conditionValues.toUpperCase();
				StringTokenizer stk = new StringTokenizer(conditionValues, ",");
				while (stk.hasMoreTokens()) {
					String conditionValue = stk.nextToken().trim();
					if (value.indexOf(conditionValue) != -1)
						return true;
				}
			}
			return false;
		}
		return true; // Enanble x default
	}

}
