/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.tags;

import javax.servlet.jsp.JspException;

import it.eng.spago.base.SessionContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.security.IEngUserProfile;
/**
 * Classes used by tags but not defined in tlds should extend this 
 * @author salerno
 */
public abstract class TagComponent extends AbstractStandardTag implements IConditionalTag {
	
	/**
	 * 
	 */
	protected SourceBean _config;
	
	/**
	 * 
	 * @param config
	 * @throws JspException
	 */
	public abstract void initFromConfig(SourceBean config) throws JspException;

	/**
	 * Checks if the element should be enabled ( stub )
	 */
	public boolean isEnabled() {
		SessionContainer permanentContainer = _requestContainer.getSessionContainer().getPermanentContainer();
		IEngUserProfile ucx = (IEngUserProfile) permanentContainer.getAttribute(IEngUserProfile.ENG_USER_PROFILE);
		return ucx.isSuperRole(_pageName);
	}

	/**
	 * Checks if the element should be visible ( stub )
	 */
	public boolean isVisible() {
		return true;
	}
}
