/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.testing.dispatching.action.detail.impl;

import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.dispatching.action.AbstractAction;

/**
 * @author grassi
 * 
 */
public class ActTestRecorder extends AbstractAction {
	public void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception {
		String message = (String) serviceRequest.getAttribute("message");
		if (message != null && message.trim().equalsIgnoreCase("START")) {
			ConfigSingleton.getInstance().updAttribute("COMMON.test_recording", "TRUE");
			serviceResponse.setAttribute("TEST_RECORDER", "REGISTRATORE AVVIATO") ;
		} else if (message != null && message.trim().equalsIgnoreCase("STOP")) {
			ConfigSingleton.getInstance().updAttribute("COMMON.test_recording", "FALSE");
			SourceBean recorder = (SourceBean) ConfigSingleton.getInstance().getAttribute("TEST_RECORDER");
			if (recorder != null)
				serviceResponse.setAttribute(recorder);
		} else if (message != null && message.trim().equalsIgnoreCase("RESET")) {
			ConfigSingleton.getInstance().delAttribute("TEST_RECORDER");
			serviceResponse.setAttribute("TEST_RECORDER", "REGISTRAZIONE CANCELLATA") ;
		}
	}
}
