/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.testing.validators;

import java.util.StringTokenizer;
import it.eng.spago.base.SourceBean;

public class CheckAllAttribute implements TestValidatorIFace {
	public CheckAllAttribute() {
		super();
		
	}

	public boolean validateParameters(SourceBean configuration) {
		boolean configurationIsValid=true;
		String checkAttributes=(String)configuration.getAttribute("Key");
		if ( checkAttributes == null) configurationIsValid=false;
		return configurationIsValid;
	}
	public boolean validator(SourceBean configuration, SourceBean inputBean, SourceBean testBean) {
		boolean testPassed=true;
		String checkAttributes=(String)configuration.getAttribute("Key");
		StringTokenizer stk = stk = new StringTokenizer(checkAttributes, ",");
		
		for (; stk.hasMoreTokens();) {
			String token=stk.nextToken();
			inputBean.getAttributeAsList(token);
			if (! inputBean.containsAttribute(token)) {
				testPassed=false;
				break;
			}
		}
		return testPassed;
	}
}
