/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.testing.validators;

import java.util.List;
import java.util.StringTokenizer;
import it.eng.spago.base.SourceBean;

public class CheckCountEqual implements TestValidatorIFace {
	public CheckCountEqual() {
		super();
		
	}

	public boolean validateParameters(SourceBean configuration) {
		boolean configurationIsValid=true;
		String checkAttributes=(String)configuration.getAttribute("Key");
		if ( checkAttributes == null) configurationIsValid=false;
		try  {
			int countOccorrence=Integer.parseInt((String)configuration.getAttribute("count"));
		}catch( Exception ex) { //catturo anche eventuale null
			configurationIsValid=false;
		}
		return configurationIsValid;
	}
	
	public boolean validator(SourceBean configuration, SourceBean inputBean, SourceBean testBean) {
		boolean testPassed=true;
		List attributeAsList=null;
		String checkAttribute=(String)configuration.getAttribute("Key");
		int countOccorrence=Integer.parseInt((String)configuration.getAttribute("count"));
		
			attributeAsList = inputBean.getAttributeAsList(checkAttribute);
			if (attributeAsList.size() != countOccorrence) testPassed=false;
		
		return testPassed;
	}
}
