/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.testing.validators;

import it.eng.spago.base.SourceBean;
import java.io.Serializable;

/**
 * La classe <code>SortValidators</code> gestisce le validazioni di tipo SORT_
 * per le PAGE di tipo List Utilizza il file di configurazione
 * <code>SortValidators</code>
 * <p>
 * 
 * @version 1.0, 01/01/2008
 * @author Andrea Grassi
 * @see SortValidators
 */
public class ListPagValidator extends AbstractListValidator implements Serializable, TestValidatorIFace {
	private static final long serialVersionUID = 1L;

	/**
	 * Verifica la configurazione del Test
	 */
	public boolean validateParameters(SourceBean config) {
		// TODO Stub di metodo generato automaticamente
		return true;
	}

	/**
	 * Verifica gli eventuali comandi di paginazione
	 * Es:
	 *    LIST_FIRST  : vai alla prima pagina
	 *    LIST_PAGE=4 : vai alla pagina 4
	 *     
	 * @return true per SUCCESSO altrimenti false
	 */
	public boolean validator(SourceBean validatorConfiguration, SourceBean inputBean, SourceBean testConfiguration) {
		boolean ret = true;
		_testConfiguration = testConfiguration;
		setServiceResponse(inputBean);

		if (_testConfiguration.getFilteredSourceBeanAttribute("PARAMETERS.PARAMETER", "NAME", "LIST_FIRST") != null)
			handleListPage("1");
		else {
			SourceBean param = (SourceBean) _testConfiguration.getFilteredSourceBeanAttribute("PARAMETERS.PARAMETER", "NAME",
					"LIST_PAGE");
			handleListPage((String) param.getAttribute("VALUE"));
		}

		if ((ret = handleListParameter("LIST_FIRST")) != false)
			ret = handleListParameter("LIST_PAGE");

		return ret;
	}

	/**
	 * Verifica che la pagina passata sia quella corretta
	 * @param pageNum : numero della pagina richiesta
	 * @return
	 */
	private boolean handleListPage(String pageNum) {

		return false;
	}

	@Override
	protected boolean validateParameter(SourceBean parameter) {
		// TODO Stub di metodo generato automaticamente
		return false;
	}
}
