/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.util;

import java.util.List;
import java.util.StringTokenizer;

import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.service.RequestContextIFace;

/**
 * @author scarciello
 *
 */
public class ConditionEngine {
	
	public static boolean evaluate(final SourceBean conditionBean, final RequestContextIFace requestContext) {
		RequestContainer requestContainer = requestContext.getRequestContainer();
		ResponseContainer responseContainer = requestContext.getResponseContainer();
		return evaluate(conditionBean,requestContainer,responseContainer);
	}

	public static boolean evaluate(final SourceBean conditionBean, final RequestContainer requestContainer, final ResponseContainer responseContainer) {
		boolean result = true;
		if (conditionBean != null) {
			for(SourceBean param : (List<SourceBean>)conditionBean.getAttributeAsList("PARAMETER")) {
				String name = (String) param.getAttribute("NAME");
				String scope = (String) param.getAttribute("SCOPE");
				String conditionValue = (String) param.getAttribute("VALUE");
				String notEquals = (String) param.getAttribute("NOTEQUALS");
				StringTokenizer stk = new StringTokenizer(conditionValue, ",");

				if(notEquals==null || notEquals.length()==0)
					notEquals="FALSE";

				boolean resultWhile = false;

				while(stk.hasMoreTokens() && !resultWhile) {
					String value = stk.nextToken().trim();
					String scopedValue = (String) ContextScooping.getScopedParameter(requestContainer, responseContainer, name, scope);

					if(value.equalsIgnoreCase("AF_NOT_DEFINED")) {
						if(scopedValue==null || scopedValue.trim().length()==0)
							resultWhile = true;
					} else if(value.equalsIgnoreCase("AF_DEFINED")) {
						if(scopedValue!=null && scopedValue.trim().length()>0)
							resultWhile = true;
					}else if(scopedValue!=null ) {
						if((scopedValue.equalsIgnoreCase(value)) && notEquals.equalsIgnoreCase("FALSE")) {
							resultWhile = true;
						}
						else if((! scopedValue.equalsIgnoreCase(value)) && notEquals.equalsIgnoreCase("TRUE"))
							resultWhile = true;
					}
				}
				if (!resultWhile)
					result=false;
			}
		}
		return result;
	}
}
