/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.util.sqlField;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.tracing.TracerSingleton;
import java.util.Comparator;
import java.util.StringTokenizer;

/**
 * @author grassi
 *
 */
public class SqlTableTypeComparator implements Comparator {
	public int compare(Object o1, Object o2) {
		try {
			SqlTableType left = (SqlTableType)o1 ;
			SqlTableType right = (SqlTableType)o2 ;
			return left.getTableName().compareToIgnoreCase(right.getTableName()) ;
		}catch (ClassCastException ex) {
            TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.CRITICAL, "InstructionComparator::compare:", ex);
            throw ex ;
		}
	}
}
