/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.validation;

import java.util.Map;

import it.eng.spago.base.SourceBean;

public interface FieldValidatorIFace {
	
	public void init(SourceBean config);
	
	public SourceBean getConfig();
	
    /**
     * Validate a single field.
     * @param serviceRequest Service request
     * @param fieldName Field name
     * @param value Value to validate
     * @param fieldValidationParams Configuration parameters
     * @throws EMFValidationError Validation error if the value is not valid
     */
    public void validateField(SourceBean serviceRequest, String fieldName, String value, Map fieldValidationParams) throws EMFValidationError;
    
    /**
     * Set the default value on the field, if configured
     * @param serviceRequest Service request
     * @param fieldName Field name
     * @param fieldValidationParams Configuration parameters
     * @return true if the default value was setted
     * @throws EMFValidationError
     */
    public boolean setDefault(SourceBean serviceRequest, String fieldName, Map fieldValidationParams) throws EMFValidationError;
    
}
