/**

 Copyright 2004, 2008 Engineering Ingegneria Informatica S.p.A.

 This file is part of Spago.

 Spago is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 any later version.

 Spago is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Spago; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago.validation.impl;

import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;

public class ValidationServices {

	/**
	 * The Key of the element that represent the Typed service Request
	 */
    public static final String TYPED_SERVICE_REQUEST = "TYPED_SERVICE_REQUEST";

    /**
	 * This method get the TYPED_SERVICE_REQUEST SourceBean from Service Request, if service Request doesn't have
	 * the Typed Service Request this will be created
	 * 
	 * @param serviceRequest The Spago Service Request
	 * @return The Typed Service Request Source Bean
	 * @throws SourceBeanException if some errors occurs istantiating service request source bean
	 */
	public static SourceBean getTypedServiceRequest(SourceBean serviceRequest) throws SourceBeanException{
		SourceBean typedServiceRequest  = (SourceBean)serviceRequest.getAttribute(TYPED_SERVICE_REQUEST);
		if ( typedServiceRequest == null){
			typedServiceRequest = new SourceBean(TYPED_SERVICE_REQUEST);
			serviceRequest.setAttribute(typedServiceRequest);
		}
		return typedServiceRequest;
		
	}
}
